-- ****************************************
-- DO NOT EDIT
-- This file was automatically generated by the Impulse C Compiler.
-- 
-- Impulse C is Copyright 2002-2005, Impulse Accelerated Technologies, Inc.
-- 
-- Stage Master is Copyright 2002-2005, Green Mountain Computing Systems, Inc.
-- 
-- All rights reserved.
-- 
-- ****************************************


-- TARGET: VHDL
  
library ieee;
use ieee.std_logic_1164.all;

package external_components is
end package;
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity PWM_pwm_RAM is
  port (
    rst,clk : in std_ulogic;
    we : in std_ulogic;
    addr : in std_ulogic_vector(4 downto 0);
    addr2 : in std_ulogic_vector(4 downto 0);
    din : in std_ulogic_vector(31 downto 0);
    dout : out std_ulogic_vector(31 downto 0);
    dout2 : out std_ulogic_vector(31 downto 0)
  );
end PWM_pwm_RAM;

architecture dualsync of PWM_pwm_RAM is
  type memtype is array (0 to 31) of
    std_ulogic_vector(31 downto 0);
  signal mem : memtype;
  signal raddr: unsigned(4 downto 0);
  signal raddr2: unsigned(4 downto 0);
begin
  writemem: process (clk)
  begin
    if (clk'event and clk='1') then
      if (we = '1') then
        mem(conv_integer(unsigned(addr))) <= din;
      end if;
      raddr <= unsigned(addr);
      raddr2 <= unsigned(addr2);
    end if;
  end process;

  dout <= mem(conv_integer(raddr));
  dout2 <= mem(conv_integer(raddr2));
end dualsync;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity PWM_sequence_RAM is
  port (
    rst,clk : in std_ulogic;
    we : in std_ulogic;
    addr : in std_ulogic_vector(8 downto 0);
    addr2 : in std_ulogic_vector(8 downto 0);
    din : in std_ulogic_vector(7 downto 0);
    dout : out std_ulogic_vector(7 downto 0);
    dout2 : out std_ulogic_vector(7 downto 0)
  );
end PWM_sequence_RAM;

architecture dualsync of PWM_sequence_RAM is
  type memtype is array (0 to 299) of
    std_ulogic_vector(7 downto 0);
  signal mem : memtype;
  signal raddr: unsigned(8 downto 0);
  signal raddr2: unsigned(8 downto 0);
begin
  writemem: process (clk)
  begin
    if (clk'event and clk='1') then
      if (we = '1') then
        mem(conv_integer(unsigned(addr))) <= din;
      end if;
      raddr <= unsigned(addr);
      raddr2 <= unsigned(addr2);
    end if;
  end process;

  dout <= mem(conv_integer(raddr));
  dout2 <= mem(conv_integer(raddr2));
end dualsync;

library ieee;
use ieee.std_logic_1164.all;

library impulse;
use impulse.components.all;
  
use impulse.xilinx_float_low_latency.all;
  
entity PWM is
  port (signal reset : in std_ulogic;
    signal sclk : in std_ulogic;
    signal clk : in std_ulogic;
    signal p_pwm_stream_rdy : in std_ulogic;
    signal p_pwm_stream_en : inout std_ulogic;
    signal p_pwm_stream_eos : in std_ulogic;
    signal p_pwm_stream_data : in std_ulogic_vector (31 downto 0);
    signal p_iteration_stream_rdy : in std_ulogic;
    signal p_iteration_stream_en : inout std_ulogic;
    signal p_iteration_stream_eos : in std_ulogic;
    signal p_iteration_stream_data : in std_ulogic_vector (15 downto 0);
    signal p_dna_stream_rdy : in std_ulogic;
    signal p_dna_stream_en : inout std_ulogic;
    signal p_dna_stream_eos : in std_ulogic;
    signal p_dna_stream_data : in std_ulogic_vector (7 downto 0);
    signal p_counter_stream_rdy : in std_ulogic;
    signal p_counter_stream_en : inout std_ulogic;
    signal p_counter_stream_eos : out std_ulogic;
    signal p_counter_stream_data : out std_ulogic_vector (15 downto 0);
    signal p_sum_stream_rdy : in std_ulogic;
    signal p_sum_stream_en : inout std_ulogic;
    signal p_sum_stream_eos : out std_ulogic;
    signal p_sum_stream_data : out std_ulogic_vector (31 downto 0));
end PWM;

use work.external_components.all;
architecture rtl of PWM is
  function mkvec(b : in std_ulogic) return std_ulogic_vector is
    variable res : std_ulogic_vector(0 downto 0);
  begin
    res(0):=b;
    return(res);
  end;

  component PWM_pwm_RAM is
    port (signal rst : in std_ulogic;
      signal clk : in std_ulogic;
      signal we : in std_ulogic;
      signal addr : in std_ulogic_vector (4 downto 0);
      signal addr2 : in std_ulogic_vector (4 downto 0);
      signal din : in std_ulogic_vector (31 downto 0);
      signal dout : out std_ulogic_vector (31 downto 0);
      signal dout2 : out std_ulogic_vector (31 downto 0));
  end component;

  component PWM_sequence_RAM is
    port (signal rst : in std_ulogic;
      signal clk : in std_ulogic;
      signal we : in std_ulogic;
      signal addr : in std_ulogic_vector (8 downto 0);
      signal addr2 : in std_ulogic_vector (8 downto 0);
      signal din : in std_ulogic_vector (7 downto 0);
      signal dout : out std_ulogic_vector (7 downto 0);
      signal dout2 : out std_ulogic_vector (7 downto 0));
  end component;

  type stateType is (init, b0s0, b1s0, b1s1, b2s0, b2s1, b2s2, b3s0, b4s0, b4s1, b5s0, b6s0, b6s1, b6s2, b7s0, b8s0, b9s0, b10s0, b11s0, b11s1, b12s0, b13s0, b14s0, b15s0, b16s0, finished);
  type pipeStateType is (idle, init, run, flush);
  type t_b10_0 is record
     predicates : std_ulogic_vector (7 downto 0);
     f_r_e_g_1 : std_ulogic_vector (8 downto 0);
     f_r_e_g_2 : std_ulogic_vector (31 downto 0);
  end record;
  type t_b10_1 is record
     predicates : std_ulogic_vector (7 downto 0);
     f_r_e_g_1 : std_ulogic_vector (8 downto 0);
     f_r_e_g_2 : std_ulogic_vector (31 downto 0);
     f_suif_tmp4 : std_ulogic_vector (31 downto 0);
     f_r_e_g_0 : std_ulogic_vector (4 downto 0);
     f_r_e_g_3 : std_ulogic_vector (4 downto 0);
     f_r_e_g_4 : std_ulogic_vector (4 downto 0);
     f_r_e_g_5 : std_ulogic_vector (4 downto 0);
  end record;
  type t_b10_2 is record
     predicates : std_ulogic_vector (7 downto 0);
     f_r_e_g_1 : std_ulogic_vector (8 downto 0);
     f_r_e_g_2 : std_ulogic_vector (31 downto 0);
     f_suif_tmp4 : std_ulogic_vector (31 downto 0);
     f_r_e_g_0 : std_ulogic_vector (4 downto 0);
     f_r_e_g_3 : std_ulogic_vector (4 downto 0);
     f_r_e_g_4 : std_ulogic_vector (4 downto 0);
     f_r_e_g_5 : std_ulogic_vector (4 downto 0);
  end record;
  type t_b10_3 is record
     predicates : std_ulogic_vector (7 downto 0);
     f_r_e_g_1 : std_ulogic_vector (8 downto 0);
     f_r_e_g_2 : std_ulogic_vector (31 downto 0);
     f_suif_tmp4 : std_ulogic_vector (31 downto 0);
     f_r_e_g_0 : std_ulogic_vector (4 downto 0);
     f_r_e_g_3 : std_ulogic_vector (4 downto 0);
     f_r_e_g_4 : std_ulogic_vector (4 downto 0);
     f_r_e_g_5 : std_ulogic_vector (4 downto 0);
  end record;
  type t_b10_4 is record
     predicates : std_ulogic_vector (7 downto 0);
     f_r_e_g_1 : std_ulogic_vector (8 downto 0);
     f_r_e_g_2 : std_ulogic_vector (31 downto 0);
     f_suif_tmp4 : std_ulogic_vector (31 downto 0);
     f_r_e_g_0 : std_ulogic_vector (4 downto 0);
     f_r_e_g_3 : std_ulogic_vector (4 downto 0);
     f_r_e_g_4 : std_ulogic_vector (4 downto 0);
     f_r_e_g_5 : std_ulogic_vector (4 downto 0);
  end record;
  type t_b10_5 is record
     predicates : std_ulogic_vector (7 downto 0);
     f_r_e_g_1 : std_ulogic_vector (8 downto 0);
     f_r_e_g_2 : std_ulogic_vector (31 downto 0);
     f_suif_tmp4 : std_ulogic_vector (31 downto 0);
     f_r_e_g_0 : std_ulogic_vector (4 downto 0);
     f_r_e_g_3 : std_ulogic_vector (4 downto 0);
     f_r_e_g_4 : std_ulogic_vector (4 downto 0);
     f_r_e_g_5 : std_ulogic_vector (4 downto 0);
     f_sum : std_ulogic_vector (31 downto 0);
  end record;
  type t_b10_6 is record
     predicates : std_ulogic_vector (7 downto 0);
     f_sum : std_ulogic_vector (31 downto 0);
  end record;
  signal thisState : stateType;
  signal nextState : stateType;
  signal stateEn : std_ulogic;
  signal newState : std_ulogic;
  signal r_pwm_stream : std_ulogic_vector (31 downto 0);
  signal r_iteration_stream : std_ulogic_vector (15 downto 0);
  signal r_dna_stream : std_ulogic_vector (7 downto 0);
  signal r_i : std_ulogic_vector (31 downto 0);
  signal ni407_i : std_ulogic_vector (31 downto 0);
  signal ni411_i : std_ulogic_vector (31 downto 0);
  signal r_j : std_ulogic_vector (31 downto 0);
  signal ni405_j : std_ulogic_vector (31 downto 0);
  signal ni412_j : std_ulogic_vector (31 downto 0);
  signal r_k : std_ulogic_vector (31 downto 0);
  signal ni415_k : std_ulogic_vector (31 downto 0);
  signal ni418_k : std_ulogic_vector (31 downto 0);
  signal ni444_k : std_ulogic_vector (31 downto 0);
  signal r_l : std_ulogic_vector (31 downto 0);
  signal ni422_l : std_ulogic_vector (31 downto 0);
  signal ni438_l : std_ulogic_vector (31 downto 0);
  signal r_nSamplePwm : std_ulogic_vector (31 downto 0);
  signal ni409_nSamplePwm : std_ulogic_vector (31 downto 0);
  signal r_pwm : std_ulogic_vector (31 downto 0);
  signal ni88_pwm : std_ulogic_vector (31 downto 0);
  signal ni196_pwm : std_ulogic_vector (31 downto 0);
  signal ni207_pwm : std_ulogic_vector (31 downto 0);
  signal ni218_pwm : std_ulogic_vector (31 downto 0);
  signal ni229_pwm : std_ulogic_vector (31 downto 0);
  signal p_pwm_we : std_ulogic;
  signal p_pwm_din : std_ulogic_vector (31 downto 0);
  signal p_pwm_dout : std_ulogic_vector (31 downto 0);
  signal p_pwm_addr : std_ulogic_vector (4 downto 0);
  signal p_pwm_addr2 : std_ulogic_vector (4 downto 0);
  signal p_pwm_dout2 : std_ulogic_vector (31 downto 0);
  signal p_pwm_imm : std_ulogic_vector (31 downto 0);
  signal p_pwm_re : std_ulogic;
  signal r2_pwm : std_ulogic_vector (31 downto 0);
  signal p_pwm_imm2 : std_ulogic_vector (31 downto 0);
  signal p_pwm_re2 : std_ulogic;
  signal r_dnaLength : std_ulogic_vector (15 downto 0);
  signal ni414_dnaLength : std_ulogic_vector (15 downto 0);
  signal r_motifLength : std_ulogic_vector (31 downto 0);
  signal ni404_motifLength : std_ulogic_vector (31 downto 0);
  signal r_nSampleDna : std_ulogic_vector (7 downto 0);
  signal ni417_nSampleDna : std_ulogic_vector (7 downto 0);
  signal ni443_nSampleDna : std_ulogic_vector (7 downto 0);
  signal r_sequence : std_ulogic_vector (7 downto 0);
  signal ni134_sequence : std_ulogic_vector (7 downto 0);
  signal ni168_sequence : std_ulogic_vector (7 downto 0);
  signal ni278_sequence : std_ulogic_vector (7 downto 0);
  signal p_sequence_we : std_ulogic;
  signal p_sequence_din : std_ulogic_vector (7 downto 0);
  signal p_sequence_dout : std_ulogic_vector (7 downto 0);
  signal p_sequence_addr : std_ulogic_vector (8 downto 0);
  signal p_sequence_addr2 : std_ulogic_vector (8 downto 0);
  signal p_sequence_dout2 : std_ulogic_vector (7 downto 0);
  signal p_sequence_imm : std_ulogic_vector (7 downto 0);
  signal p_sequence_re : std_ulogic;
  signal r2_sequence : std_ulogic_vector (7 downto 0);
  signal p_sequence_imm2 : std_ulogic_vector (7 downto 0);
  signal p_sequence_re2 : std_ulogic;
  signal r_counter : std_ulogic_vector (15 downto 0);
  signal ni419_counter : std_ulogic_vector (15 downto 0);
  signal ni445_counter : std_ulogic_vector (15 downto 0);
  signal r_sum : std_ulogic_vector (31 downto 0);
  signal ni420_sum : std_ulogic_vector (31 downto 0);
  signal ni427_sum : std_ulogic_vector (31 downto 0);
  signal ni430_sum : std_ulogic_vector (31 downto 0);
  signal ni433_sum : std_ulogic_vector (31 downto 0);
  signal ni436_sum : std_ulogic_vector (31 downto 0);
  signal ni446_sum : std_ulogic_vector (31 downto 0);
  signal r_nHitStart : std_ulogic_vector (15 downto 0);
  signal ni440_nHitStart : std_ulogic_vector (15 downto 0);
  signal r_nHitScore : std_ulogic_vector (31 downto 0);
  signal ni441_nHitScore : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp : std_ulogic_vector (31 downto 0);
  signal ni413_suif_tmp : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp0 : std_ulogic_vector (31 downto 0);
  signal ni421_suif_tmp0 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp1 : std_ulogic_vector (31 downto 0);
  signal ni447_suif_tmp1 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp2 : std_ulogic_vector (31 downto 0);
  signal ni442_suif_tmp2 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp3 : std_ulogic_vector (31 downto 0);
  signal ni423_suif_tmp3 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp4 : std_ulogic_vector (31 downto 0);
  signal ni439_suif_tmp4 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp5 : std_ulogic_vector (31 downto 0);
  signal ni426_suif_tmp5 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp6 : std_ulogic_vector (31 downto 0);
  signal ni429_suif_tmp6 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp7 : std_ulogic_vector (31 downto 0);
  signal ni432_suif_tmp7 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp8 : std_ulogic_vector (31 downto 0);
  signal ni435_suif_tmp8 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp9 : std_ulogic_vector (31 downto 0);
  signal ni406_suif_tmp9 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp10 : std_ulogic_vector (31 downto 0);
  signal ni408_suif_tmp10 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp11 : std_ulogic_vector (31 downto 0);
  signal ni416_suif_tmp11 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp90 : std_ulogic_vector (31 downto 0);
  signal ni424_suif_tmp90 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp_0 : std_ulogic_vector (31 downto 0);
  signal ni425_suif_tmp_0 : std_ulogic_vector (31 downto 0);
  signal r_r_e_g_0 : std_ulogic_vector (4 downto 0);
  signal ni410_r_e_g_0 : std_ulogic_vector (4 downto 0);
  signal ni428_r_e_g_0 : std_ulogic_vector (4 downto 0);
  signal r_r_e_g_1 : std_ulogic_vector (8 downto 0);
  signal ni170_r_e_g_1 : std_ulogic_vector (8 downto 0);
  signal r_r_e_g_2 : std_ulogic_vector (31 downto 0);
  signal ni400_r_e_g_2 : std_ulogic_vector (31 downto 0);
  signal r_r_e_g_3 : std_ulogic_vector (4 downto 0);
  signal ni431_r_e_g_3 : std_ulogic_vector (4 downto 0);
  signal r_r_e_g_4 : std_ulogic_vector (4 downto 0);
  signal ni434_r_e_g_4 : std_ulogic_vector (4 downto 0);
  signal r_r_e_g_5 : std_ulogic_vector (4 downto 0);
  signal ni437_r_e_g_5 : std_ulogic_vector (4 downto 0);
  signal t_10 : std_ulogic_vector (8 downto 0);
  signal t_9 : std_ulogic_vector (31 downto 0);
  signal t_8 : std_ulogic_vector (31 downto 0);
  signal ti227_pipeen : std_ulogic;
  signal ti227_req : std_ulogic;
  signal t_7 : std_ulogic_vector (31 downto 0);
  signal ti216_pipeen : std_ulogic;
  signal ti216_req : std_ulogic;
  signal t_6 : std_ulogic_vector (31 downto 0);
  signal ti205_pipeen : std_ulogic;
  signal ti205_req : std_ulogic;
  signal t_5 : std_ulogic_vector (31 downto 0);
  signal ti194_pipeen : std_ulogic;
  signal ti194_req : std_ulogic;
  signal t_4 : std_ulogic_vector (31 downto 0);
  signal t_3 : std_ulogic_vector (31 downto 0);
  signal t_2 : std_ulogic_vector (31 downto 0);
  signal t_1 : std_ulogic_vector (31 downto 0);
  signal t_0 : std_ulogic_vector (8 downto 0);
  signal s_b10_state : pipeStateType;
  signal s_b10_0 : t_b10_0;
  signal s_b10_1 : t_b10_1;
  signal s_b10_2 : t_b10_2;
  signal s_b10_3 : t_b10_3;
  signal s_b10_4 : t_b10_4;
  signal s_b10_5 : t_b10_5;
  signal s_b10_6 : t_b10_6;
  signal s_b10_stall : std_ulogic;
  signal s_b10_break : std_ulogic;
  signal s_b10_loop : std_ulogic;
  signal s_b10_flushed : std_ulogic;
  signal s_b10_done : std_ulogic;
  signal s_b10_vstall : std_ulogic_vector (6 downto 0);
  signal s_b10_vbreak : std_ulogic_vector (6 downto 0);
  signal s_b10_stage : std_ulogic_vector (6 downto 0);
  signal s_b10_vwrite : std_ulogic_vector (6 downto 0);
  signal s_b10_vcont : std_ulogic_vector (6 downto 0);
  signal s_b10_delay : std_ulogic_vector (5 downto 0);
  signal s_b10_predicates : std_ulogic_vector (7 downto 0);
begin
  process (clk,reset)
  begin
    if (reset='1') then
     thisState <= init;
    elsif (clk'event and clk='1') then
      if (stateEn = '1') then
        thisState <= nextState;
      end if;
    end if;
  end process;

  stateEn <= 
    '0' when thisState = b2s1 and p_pwm_stream_rdy = '0' else
    '0' when thisState = b4s0 and p_iteration_stream_rdy = '0' else
    '0' when thisState = b6s1 and p_dna_stream_rdy = '0' else
    '0' when thisState = b10s0 and s_b10_done = '0' else
    '0' when thisState = b11s0 and (p_counter_stream_rdy and p_sum_stream_rdy and p_dna_stream_rdy) = '0' else
    '0' when thisState = b15s0 and (p_pwm_stream_eos and p_iteration_stream_eos and p_dna_stream_eos and p_counter_stream_rdy and p_sum_stream_rdy) = '0' else
    '1';

  process (ni447_suif_tmp1,r_suif_tmp2,ni423_suif_tmp3,ni421_suif_tmp0,ni416_suif_tmp11,r_suif_tmp,ni408_suif_tmp10,ni406_suif_tmp9,thisState)
  begin
    case thisState is
    when init =>
      nextState <= b0s0;
    when b0s0 =>
      nextState <= b1s0;
    when b1s0 =>
      if ((not ni406_suif_tmp9(0)) = '1') then
        nextState <= b4s0;
      else
        nextState <= b1s1;
      end if;
    when b1s1 =>
      nextState <= b2s0;
    when b2s0 =>
      if ((not ni408_suif_tmp10(0)) = '1') then
        nextState <= b3s0;
      else
        nextState <= b2s1;
      end if;
    when b2s1 =>
      nextState <= b2s2;
    when b2s2 =>
      nextState <= b2s0;
    when b3s0 =>
      nextState <= b1s0;
    when b4s0 =>
      nextState <= b4s1;
    when b4s1 =>
      if (r_suif_tmp(0) = '1') then
        nextState <= b5s0;
      elsif ((not r_suif_tmp(0)) = '1') then
        nextState <= b5s0;
      else
        nextState <= b4s1;
      end if;
    when b5s0 =>
      nextState <= b6s0;
    when b6s0 =>
      if ((not ni416_suif_tmp11(0)) = '1') then
        nextState <= b7s0;
      else
        nextState <= b6s1;
      end if;
    when b6s1 =>
      nextState <= b6s2;
    when b6s2 =>
      nextState <= b6s0;
    when b7s0 =>
      if (ni421_suif_tmp0(0) = '1') then
        nextState <= b8s0;
      elsif ((not ni421_suif_tmp0(0)) = '1') then
        nextState <= b15s0;
      else
        nextState <= b7s0;
      end if;
    when b8s0 =>
      if (ni423_suif_tmp3(0) = '1') then
        nextState <= b9s0;
      elsif ((not ni423_suif_tmp3(0)) = '1') then
        nextState <= b11s0;
      else
        nextState <= b8s0;
      end if;
    when b9s0 =>
      nextState <= b10s0;
    when b10s0 =>
      nextState <= b11s0;
    when b11s0 =>
      nextState <= b11s1;
    when b11s1 =>
      if (r_suif_tmp2(0) = '1') then
        nextState <= b12s0;
      elsif ((not r_suif_tmp2(0)) = '1') then
        nextState <= b13s0;
      else
        nextState <= b11s1;
      end if;
    when b12s0 =>
      nextState <= b14s0;
    when b13s0 =>
      nextState <= b15s0;
    when b14s0 =>
      if (ni447_suif_tmp1(0) = '1') then
        nextState <= b8s0;
      elsif ((not ni447_suif_tmp1(0)) = '1') then
        nextState <= b15s0;
      else
        nextState <= b14s0;
      end if;
    when b15s0 =>
      nextState <= b0s0;
    when b16s0 =>
      nextState <= finished;
    when finished =>
      nextState <= finished;
    when others =>
      nextState <= init;
    end case;
  end process;

  process (clk,reset)
  begin
    if (reset='1') then
     newState <= '1';
    elsif (clk'event and clk='1') then
      case thisState is
      when b10s0 =>
       newState <= not s_b10_stall;
      when  others =>
       newState <= stateEn;
      end case;
    end if;
  end process;

-- b0s0
  ni404_motifLength <= X"00000008";
  ni405_j <= X"00000000";

-- b1s0
  ni406_suif_tmp9 <= "0000000000000000000000000000000" & cmp_less_s(r_j, X"00000008");

-- b1s1
  ni407_i <= X"00000000";

-- b2s0
  ni408_suif_tmp10 <= "0000000000000000000000000000000" & cmp_less_s(r_i, X"00000004");

-- b2s1
  ni411_i <= add(r_i, X"00000001");
  ni410_r_e_g_0 <= add(shl(r_i(4 downto 0), 3), r_j(4 downto 0));

-- b2s2
  ni409_nSamplePwm <= r_pwm_stream;
  ni88_pwm <= ni409_nSamplePwm;

-- b3s0
  ni412_j <= add(r_j, X"00000001");

-- b4s0
  ni413_suif_tmp <= "0000000000000000000000000000000" & eq("0" & mkvec(p_iteration_stream_eos), "00");

-- b4s1
  ni414_dnaLength <= r_iteration_stream;

-- b5s0
  ni415_k <= X"00000000";

-- b6s0
  ni416_suif_tmp11 <= "0000000000000000000000000000000" & cmp_less_s(r_k, X"00000008");

-- b6s1

-- b6s2
  ni417_nSampleDna <= r_dna_stream;
  ni134_sequence <= ni417_nSampleDna;
  t_0 <= r_k(8 downto 0);
  ni418_k <= add(r_k, X"00000001");

-- b7s0
  ni419_counter <= X"0000";
  ni420_sum <= X"00000000";
  ni421_suif_tmp0 <= "0000000000000000000000000000000" & cmp_less_equal_s(X"00000000", sub(sign_ext(r_dnaLength, 32), X"00000008"));

-- b8s0
  ni422_l <= X"00000000";
  ni423_suif_tmp3 <= "0000000000000000000000000000000" & cmp_less_s(ni422_l, X"00000008");

-- b9s0
  ni424_suif_tmp90 <= sign_ext(r_counter, 32);

  process (clk,reset)
  begin
    if (reset='1') then
     s_b10_state <= idle;
    elsif (clk'event and clk='1') then
      case s_b10_state is
      when idle =>
        if (stateEn = '1' and nextState = b10s0) then
          s_b10_state <= init;
        else
          s_b10_state <= idle;
        end if;
      when init =>
        s_b10_state <= run;
      when run =>
        if ((not s_b10_loop) = '1') then
          s_b10_state <= idle;
        elsif (s_b10_break = '1') then
          s_b10_state <= flush;
        else
          s_b10_state <= run;
        end if;
      when flush =>
        if (s_b10_flushed = '1') then
          s_b10_state <= idle;
        else
          s_b10_state <= flush;
        end if;
      when others => null;
      end case;
    end if;
  end process;

-- b10 stage 0
  s_b10_vstall(0) <= '0';
  ni170_r_e_g_1 <= add(r_l(8 downto 0), r_suif_tmp90(8 downto 0));
  ni400_r_e_g_2 <= add(r_l, X"00000001");
  s_b10_vbreak(0) <= '0';
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (s_b10_vwrite(0) = '1') then
        s_b10_0.f_r_e_g_2 <= ni400_r_e_g_2;
        s_b10_0.f_r_e_g_1 <= ni170_r_e_g_1;
        s_b10_0.predicates(0) <= '0';
        s_b10_0.predicates(1) <= '0';
        s_b10_0.predicates(2) <= '0';
        s_b10_0.predicates(3) <= '0';
        s_b10_0.predicates(4) <= '0';
        s_b10_0.predicates(5) <= '0';
        s_b10_0.predicates(6) <= '0';
        s_b10_0.predicates(7) <= '0';
      end if;
    end if;
  end process;

-- b10 stage 1
  s_b10_vstall(1) <= '0';
  ni168_sequence <= p_sequence_imm2;
  ni425_suif_tmp_0 <= sign_ext(ni168_sequence, 32);
  ni426_suif_tmp5 <= "0000000000000000000000000000000" & eq(ni425_suif_tmp_0(7 downto 0), X"41");
  ni429_suif_tmp6 <= "0000000000000000000000000000000" & eq(ni425_suif_tmp_0(7 downto 0), X"43");
  ni432_suif_tmp7 <= "0000000000000000000000000000000" & eq(ni425_suif_tmp_0(7 downto 0), X"47");
  ni435_suif_tmp8 <= "0000000000000000000000000000000" & eq(ni425_suif_tmp_0(7 downto 0), X"54");
  s_b10_predicates(6) <= 
    s_b10_predicates(5) when t_1(0) = '1' else
    '0';
  s_b10_predicates(7) <= 
    s_b10_predicates(5) when (not t_1(0)) = '1' else
    '0';
  t_1 <= 
    ni435_suif_tmp8 when s_b10_predicates(5) = '1' else
    r_suif_tmp8;
  s_b10_predicates(4) <= 
    s_b10_predicates(3) when t_2(0) = '1' else
    '0';
  s_b10_predicates(5) <= 
    s_b10_predicates(3) when (not t_2(0)) = '1' else
    '0';
  t_2 <= 
    ni432_suif_tmp7 when s_b10_predicates(3) = '1' else
    r_suif_tmp7;
  s_b10_predicates(2) <= 
    s_b10_predicates(1) when t_3(0) = '1' else
    '0';
  s_b10_predicates(3) <= 
    s_b10_predicates(1) when (not t_3(0)) = '1' else
    '0';
  t_3 <= 
    ni429_suif_tmp6 when s_b10_predicates(1) = '1' else
    r_suif_tmp6;
  s_b10_predicates(0) <= 
    '1' when ni426_suif_tmp5(0) = '1' else
    '0';
  s_b10_predicates(1) <= 
    '1' when (not ni426_suif_tmp5(0)) = '1' else
    '0';
  ni438_l <= s_b10_0.f_r_e_g_2;
  ni439_suif_tmp4 <= "0000000000000000000000000000000" & cmp_less_s(ni438_l, X"00000008");
  ni428_r_e_g_0 <= r_l(4 downto 0);
  ni431_r_e_g_3 <= add("01000", r_l(4 downto 0));
  ni434_r_e_g_4 <= add("10000", r_l(4 downto 0));
  ni437_r_e_g_5 <= add("11000", r_l(4 downto 0));
  s_b10_vbreak(1) <= '0';
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (s_b10_vwrite(1) = '1') then
        s_b10_1.f_r_e_g_5 <= ni437_r_e_g_5;
        s_b10_1.f_r_e_g_4 <= ni434_r_e_g_4;
        s_b10_1.f_r_e_g_3 <= ni431_r_e_g_3;
        s_b10_1.f_r_e_g_0 <= ni428_r_e_g_0;
        s_b10_1.f_suif_tmp4 <= ni439_suif_tmp4;
        s_b10_1.f_r_e_g_2 <= s_b10_0.f_r_e_g_2;
        s_b10_1.f_r_e_g_1 <= s_b10_0.f_r_e_g_1;
        s_b10_1.predicates(0) <= s_b10_predicates(0);
        s_b10_1.predicates(1) <= s_b10_predicates(1);
        s_b10_1.predicates(2) <= s_b10_predicates(2);
        s_b10_1.predicates(3) <= s_b10_predicates(3);
        s_b10_1.predicates(4) <= s_b10_predicates(4);
        s_b10_1.predicates(5) <= s_b10_predicates(5);
        s_b10_1.predicates(6) <= s_b10_predicates(6);
        s_b10_1.predicates(7) <= s_b10_predicates(7);
      end if;
    end if;
  end process;

-- b10 stage 2
  s_b10_vstall(2) <= '0';
  ni196_pwm <= p_pwm_imm2;
  fadd_ll_0: fadd_ll
    port map (
      clk => clk, 
      a => s_b10_6.f_sum, 
      b => ni196_pwm, 
      go => ti194_req, 
      result => t_4, 
      pipeEn => ti194_pipeen);

  ni207_pwm <= p_pwm_imm;
  fadd_ll_1: fadd_ll
    port map (
      clk => clk, 
      a => s_b10_6.f_sum, 
      b => ni207_pwm, 
      go => ti205_req, 
      result => t_5, 
      pipeEn => ti205_pipeen);

  s_b10_vbreak(2) <= '0';
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (s_b10_vwrite(2) = '1') then
        s_b10_2.f_r_e_g_5 <= s_b10_1.f_r_e_g_5;
        s_b10_2.f_r_e_g_4 <= s_b10_1.f_r_e_g_4;
        s_b10_2.f_r_e_g_3 <= s_b10_1.f_r_e_g_3;
        s_b10_2.f_r_e_g_0 <= s_b10_1.f_r_e_g_0;
        s_b10_2.f_suif_tmp4 <= s_b10_1.f_suif_tmp4;
        s_b10_2.f_r_e_g_2 <= s_b10_1.f_r_e_g_2;
        s_b10_2.f_r_e_g_1 <= s_b10_1.f_r_e_g_1;
        s_b10_2.predicates(0) <= s_b10_1.predicates(0);
        s_b10_2.predicates(1) <= s_b10_1.predicates(1);
        s_b10_2.predicates(2) <= s_b10_1.predicates(2);
        s_b10_2.predicates(3) <= s_b10_1.predicates(3);
        s_b10_2.predicates(4) <= s_b10_1.predicates(4);
        s_b10_2.predicates(5) <= s_b10_1.predicates(5);
        s_b10_2.predicates(6) <= s_b10_1.predicates(6);
        s_b10_2.predicates(7) <= s_b10_1.predicates(7);
      end if;
    end if;
  end process;

-- b10 stage 3
  s_b10_vstall(3) <= '0';
  ni218_pwm <= p_pwm_imm2;
  fadd_ll_2: fadd_ll
    port map (
      clk => clk, 
      a => s_b10_6.f_sum, 
      b => ni218_pwm, 
      go => ti216_req, 
      result => t_6, 
      pipeEn => ti216_pipeen);

  ni229_pwm <= p_pwm_imm;
  fadd_ll_3: fadd_ll
    port map (
      clk => clk, 
      a => s_b10_6.f_sum, 
      b => ni229_pwm, 
      go => ti227_req, 
      result => t_7, 
      pipeEn => ti227_pipeen);

  s_b10_vbreak(3) <= '0';
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (s_b10_vwrite(3) = '1') then
        s_b10_3.f_r_e_g_5 <= s_b10_2.f_r_e_g_5;
        s_b10_3.f_r_e_g_4 <= s_b10_2.f_r_e_g_4;
        s_b10_3.f_r_e_g_3 <= s_b10_2.f_r_e_g_3;
        s_b10_3.f_r_e_g_0 <= s_b10_2.f_r_e_g_0;
        s_b10_3.f_suif_tmp4 <= s_b10_2.f_suif_tmp4;
        s_b10_3.f_r_e_g_2 <= s_b10_2.f_r_e_g_2;
        s_b10_3.f_r_e_g_1 <= s_b10_2.f_r_e_g_1;
        s_b10_3.predicates(0) <= s_b10_2.predicates(0);
        s_b10_3.predicates(1) <= s_b10_2.predicates(1);
        s_b10_3.predicates(2) <= s_b10_2.predicates(2);
        s_b10_3.predicates(3) <= s_b10_2.predicates(3);
        s_b10_3.predicates(4) <= s_b10_2.predicates(4);
        s_b10_3.predicates(5) <= s_b10_2.predicates(5);
        s_b10_3.predicates(6) <= s_b10_2.predicates(6);
        s_b10_3.predicates(7) <= s_b10_2.predicates(7);
      end if;
    end if;
  end process;

-- b10 stage 4
  s_b10_vstall(4) <= '0';
  s_b10_vbreak(4) <= '0';
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (s_b10_vwrite(4) = '1') then
        s_b10_4.f_r_e_g_5 <= s_b10_3.f_r_e_g_5;
        s_b10_4.f_r_e_g_4 <= s_b10_3.f_r_e_g_4;
        s_b10_4.f_r_e_g_3 <= s_b10_3.f_r_e_g_3;
        s_b10_4.f_r_e_g_0 <= s_b10_3.f_r_e_g_0;
        s_b10_4.f_suif_tmp4 <= s_b10_3.f_suif_tmp4;
        s_b10_4.f_r_e_g_2 <= s_b10_3.f_r_e_g_2;
        s_b10_4.f_r_e_g_1 <= s_b10_3.f_r_e_g_1;
        s_b10_4.predicates(0) <= s_b10_3.predicates(0);
        s_b10_4.predicates(1) <= s_b10_3.predicates(1);
        s_b10_4.predicates(2) <= s_b10_3.predicates(2);
        s_b10_4.predicates(3) <= s_b10_3.predicates(3);
        s_b10_4.predicates(4) <= s_b10_3.predicates(4);
        s_b10_4.predicates(5) <= s_b10_3.predicates(5);
        s_b10_4.predicates(6) <= s_b10_3.predicates(6);
        s_b10_4.predicates(7) <= s_b10_3.predicates(7);
      end if;
    end if;
  end process;

-- b10 stage 5
  s_b10_vstall(5) <= '0';
  ni427_sum <= t_4;
  ni430_sum <= t_5;
  t_8 <= 
    ni430_sum when s_b10_4.predicates(2) = '1' else
    ni427_sum when s_b10_4.predicates(0) = '1' else
    s_b10_6.f_sum;
  s_b10_vbreak(5) <= '0';
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (s_b10_vwrite(5) = '1') then
        s_b10_5.f_sum <= t_8;
        s_b10_5.f_r_e_g_5 <= s_b10_4.f_r_e_g_5;
        s_b10_5.f_r_e_g_4 <= s_b10_4.f_r_e_g_4;
        s_b10_5.f_r_e_g_3 <= s_b10_4.f_r_e_g_3;
        s_b10_5.f_r_e_g_0 <= s_b10_4.f_r_e_g_0;
        s_b10_5.f_suif_tmp4 <= s_b10_4.f_suif_tmp4;
        s_b10_5.f_r_e_g_2 <= s_b10_4.f_r_e_g_2;
        s_b10_5.f_r_e_g_1 <= s_b10_4.f_r_e_g_1;
        s_b10_5.predicates(0) <= s_b10_4.predicates(0);
        s_b10_5.predicates(1) <= s_b10_4.predicates(1);
        s_b10_5.predicates(2) <= s_b10_4.predicates(2);
        s_b10_5.predicates(3) <= s_b10_4.predicates(3);
        s_b10_5.predicates(4) <= s_b10_4.predicates(4);
        s_b10_5.predicates(5) <= s_b10_4.predicates(5);
        s_b10_5.predicates(6) <= s_b10_4.predicates(6);
        s_b10_5.predicates(7) <= s_b10_4.predicates(7);
      end if;
    end if;
  end process;

-- b10 stage 6
  s_b10_vstall(6) <= '0';
  ni433_sum <= t_6;
  ni436_sum <= t_7;
  t_9 <= 
    ni436_sum when s_b10_5.predicates(6) = '1' else
    ni433_sum when s_b10_5.predicates(4) = '1' else
    s_b10_5.f_sum;
  s_b10_vbreak(6) <= '0';
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (s_b10_state = init) then
        s_b10_6.f_sum <= r_sum;
      elsif (s_b10_vwrite(6) = '1') then
        s_b10_6.f_sum <= t_9;
        s_b10_6.predicates(0) <= s_b10_5.predicates(0);
        s_b10_6.predicates(1) <= s_b10_5.predicates(1);
        s_b10_6.predicates(2) <= s_b10_5.predicates(2);
        s_b10_6.predicates(3) <= s_b10_5.predicates(3);
        s_b10_6.predicates(4) <= s_b10_5.predicates(4);
        s_b10_6.predicates(5) <= s_b10_5.predicates(5);
        s_b10_6.predicates(6) <= s_b10_5.predicates(6);
        s_b10_6.predicates(7) <= s_b10_5.predicates(7);
      end if;
    end if;
  end process;

  with s_b10_state select
    s_b10_break <= 
      '1' when flush,
      '0' when others;
  process (clk,reset)
  begin
    if (reset='1') then
     s_b10_delay <= "000001";
    elsif (clk'event and clk='1') then
      if (s_b10_state = idle) then
       s_b10_delay <= "000001";
      elsif (thisState = b10s0 and s_b10_stall = '0' and s_b10_done = '0') then
       s_b10_delay <= s_b10_delay(0) & s_b10_delay(5 downto 1);
      end if;    end if;
  end process;

  process (clk,reset)
  begin
    if (reset='1') then
     s_b10_stage <= "0000000";
    elsif (clk'event and clk='1') then
      if (s_b10_state = idle) then
       s_b10_stage <= "0000000";
      elsif (thisState = b10s0 and s_b10_stall = '0') then
       s_b10_stage <= s_b10_vcont(5 downto 0) & ((not s_b10_break) and s_b10_delay(0));
      end if;    end if;
  end process;

  s_b10_stall <= 
    '0' when (s_b10_vstall and s_b10_stage) = "0000000" else
    '1';
  s_b10_vwrite(0) <= 
    s_b10_stage(0) when s_b10_stall = '0' else
    '0';
  s_b10_vwrite(1) <= 
    s_b10_stage(1) when s_b10_stall = '0' else
    '0';
  s_b10_vwrite(2) <= 
    s_b10_stage(2) when s_b10_stall = '0' else
    '0';
  s_b10_vwrite(3) <= 
    s_b10_stage(3) when s_b10_stall = '0' else
    '0';
  s_b10_vwrite(4) <= 
    s_b10_stage(4) when s_b10_stall = '0' else
    '0';
  s_b10_vwrite(5) <= 
    s_b10_stage(5) when s_b10_stall = '0' else
    '0';
  s_b10_vwrite(6) <= 
    s_b10_stage(6) when s_b10_stall = '0' else
    '0';
  s_b10_vcont(0) <= s_b10_stage(0);
  s_b10_vcont(1) <= s_b10_stage(1);
  s_b10_vcont(2) <= s_b10_stage(2);
  s_b10_vcont(3) <= s_b10_stage(3);
  s_b10_vcont(4) <= s_b10_stage(4);
  s_b10_vcont(5) <= s_b10_stage(5);
  s_b10_vcont(6) <= '0';
  s_b10_loop <= 
    '0' when (s_b10_stage(6) and (not s_b10_vstall(6)) and (not s_b10_5.f_suif_tmp4(0))) = '1' else
    '1';
  s_b10_flushed <= 
    '1' when s_b10_stall = '0' and s_b10_vcont = "0000000" else
    '0';
  with s_b10_state select
    s_b10_done <= 
      '0' when init,
      not s_b10_loop when run,
      s_b10_flushed when flush,
      '0' when others;
-- b11s0
  ni440_nHitStart <= r_counter;
  ni441_nHitScore <= r_sum;
  ni442_suif_tmp2 <= "0000000000000000000000000000000" & eq("0" & mkvec(p_dna_stream_eos), "00");

-- b11s1
  ni443_nSampleDna <= r_dna_stream;

-- b12s0
  ni278_sequence <= r_nSampleDna;
  t_10 <= r_k(8 downto 0);
  ni444_k <= add(r_k, X"00000001");

-- b13s0

-- b14s0
  ni445_counter <= add(r_counter, X"0001");
  ni446_sum <= X"00000000";
  ni447_suif_tmp1 <= "0000000000000000000000000000000" & cmp_less_equal_s(sign_ext(ni445_counter, 32), sub(sign_ext(r_dnaLength, 32), X"00000008"));

-- b15s0

-- b16s0

-- 


  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b0s0 =>
        if (stateEn = '1') then
          r_motifLength <= ni404_motifLength;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b0s0 =>
        if (stateEn = '1') then
          r_j <= ni405_j;
        end if;
      when b3s0 =>
        if (stateEn = '1') then
          r_j <= ni412_j;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b1s0 =>
        if (stateEn = '1') then
          r_suif_tmp9 <= ni406_suif_tmp9;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b1s1 =>
        if (stateEn = '1') then
          r_i <= ni407_i;
        end if;
      when b2s1 =>
        if (stateEn = '1') then
          r_i <= ni411_i;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b2s0 =>
        if (stateEn = '1') then
          r_suif_tmp10 <= ni408_suif_tmp10;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b2s1 =>
        if (stateEn = '1') then
          r_r_e_g_0 <= ni410_r_e_g_0;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b2s2 =>
        if (stateEn = '1') then
          r_nSamplePwm <= ni409_nSamplePwm;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b4s0 =>
        if (stateEn = '1') then
          r_suif_tmp <= ni413_suif_tmp;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b4s1 =>
        if (stateEn = '1') then
          r_dnaLength <= ni414_dnaLength;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b5s0 =>
        if (stateEn = '1') then
          r_k <= ni415_k;
        end if;
      when b6s2 =>
        if (stateEn = '1') then
          r_k <= ni418_k;
        end if;
      when b12s0 =>
        if (stateEn = '1') then
          r_k <= ni444_k;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b6s0 =>
        if (stateEn = '1') then
          r_suif_tmp11 <= ni416_suif_tmp11;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b6s2 =>
        if (stateEn = '1') then
          r_nSampleDna <= ni417_nSampleDna;
        end if;
      when b11s1 =>
        if (stateEn = '1') then
          r_nSampleDna <= ni443_nSampleDna;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b7s0 =>
        if (stateEn = '1') then
          r_counter <= ni419_counter;
        end if;
      when b14s0 =>
        if (stateEn = '1') then
          r_counter <= ni445_counter;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b7s0 =>
        if (stateEn = '1') then
          r_sum <= ni420_sum;
        end if;
      when b10s0 =>
        if (s_b10_vwrite(5) = '1') then
          r_sum <= t_8;
        end if;
        if (s_b10_vwrite(6) = '1') then
          r_sum <= t_9;
        end if;
      when b14s0 =>
        if (stateEn = '1') then
          r_sum <= ni446_sum;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b7s0 =>
        if (stateEn = '1') then
          r_suif_tmp0 <= ni421_suif_tmp0;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b8s0 =>
        if (stateEn = '1') then
          r_l <= ni422_l;
        end if;
      when b10s0 =>
        if (s_b10_vwrite(1) = '1') then
          r_l <= ni438_l;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b8s0 =>
        if (stateEn = '1') then
          r_suif_tmp3 <= ni423_suif_tmp3;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b9s0 =>
        if (stateEn = '1') then
          r_suif_tmp90 <= ni424_suif_tmp90;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b11s0 =>
        if (stateEn = '1') then
          r_nHitStart <= ni440_nHitStart;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b11s0 =>
        if (stateEn = '1') then
          r_nHitScore <= ni441_nHitScore;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b11s0 =>
        if (stateEn = '1') then
          r_suif_tmp2 <= ni442_suif_tmp2;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b14s0 =>
        if (stateEn = '1') then
          r_suif_tmp1 <= ni447_suif_tmp1;
        end if;
      when others => null;
      end case;
    end if;
  end process;

-- "pwm_stream" interface signals
  process (clk)
  begin
    if (clk'event and clk='1') then
      if ((p_pwm_stream_en and p_pwm_stream_rdy) = '1') then
        r_pwm_stream <= p_pwm_stream_data;
      end if;
    end if;
  end process;

  p_pwm_stream_en <= 
    stateEn and (not p_pwm_stream_eos) when thisState = b2s1 else
    stateEn when thisState = b15s0 else
    '0';

-- "iteration_stream" interface signals
  process (clk)
  begin
    if (clk'event and clk='1') then
      if ((p_iteration_stream_en and p_iteration_stream_rdy) = '1') then
        r_iteration_stream <= p_iteration_stream_data;
      end if;
    end if;
  end process;

  p_iteration_stream_en <= 
    stateEn and (not p_iteration_stream_eos) when thisState = b4s0 else
    stateEn when thisState = b15s0 else
    '0';

-- "dna_stream" interface signals
  process (clk)
  begin
    if (clk'event and clk='1') then
      if ((p_dna_stream_en and p_dna_stream_rdy) = '1') then
        r_dna_stream <= p_dna_stream_data;
      end if;
    end if;
  end process;

  p_dna_stream_en <= 
    stateEn and (not p_dna_stream_eos) when thisState = b6s1 else
    stateEn and (not p_dna_stream_eos) when thisState = b11s0 else
    stateEn when thisState = b15s0 else
    '0';

-- "counter_stream" interface signals
  p_counter_stream_en <= 
    stateEn when thisState = b11s0 else
    stateEn when thisState = b15s0 else
    '0';
  p_counter_stream_data <= ni440_nHitStart;
  p_counter_stream_eos <= 
    '1' when thisState = b15s0 else
    '0';

-- "sum_stream" interface signals
  p_sum_stream_en <= 
    stateEn when thisState = b11s0 else
    stateEn when thisState = b15s0 else
    '0';
  p_sum_stream_data <= ni441_nHitScore;
  p_sum_stream_eos <= 
    '1' when thisState = b15s0 else
    '0';

-- "pwm" memory signals
  ram_4: PWM_pwm_RAM
    port map (
      rst => reset, 
      clk => clk, 
      we => p_pwm_we, 
      addr => p_pwm_addr, 
      addr2 => p_pwm_addr2, 
      din => p_pwm_din, 
      dout => p_pwm_dout, 
      dout2 => p_pwm_dout2);

  p_pwm_addr <= 
    r_r_e_g_0 when thisState = b2s2 else
    ni431_r_e_g_3 when thisState = b10s0 and s_b10_vwrite(1) = '1' and s_b10_predicates(2) = '1' else
    r_r_e_g_3 when thisState = b10s0 and s_b10_vwrite(1) = '1' else
    s_b10_1.f_r_e_g_5 when thisState = b10s0 and s_b10_vwrite(2) = '1' else
    (others => 'X');
  p_pwm_re <= 
    newState when thisState = b10s0 and s_b10_stage(2) = '1' and s_b10_1.predicates(2) = '1' else
    newState when thisState = b10s0 and s_b10_stage(3) = '1' and s_b10_2.predicates(6) = '1' else
    '0';
  p_pwm_re2 <= 
    newState when thisState = b10s0 and s_b10_stage(2) = '1' and s_b10_1.predicates(0) = '1' else
    newState when thisState = b10s0 and s_b10_stage(3) = '1' and s_b10_2.predicates(4) = '1' else
    '0';
  p_pwm_addr2 <= 
    ni428_r_e_g_0 when thisState = b10s0 and s_b10_vwrite(1) = '1' and s_b10_predicates(0) = '1' else
    r_r_e_g_0 when thisState = b10s0 and s_b10_vwrite(1) = '1' else
    s_b10_1.f_r_e_g_4 when thisState = b10s0 and s_b10_vwrite(2) = '1' else
    (others => 'X');
  p_pwm_we <= 
    '1' when thisState = b2s2 else
    '0';
  p_pwm_din <= ni409_nSamplePwm;
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (p_pwm_re = '1') then
        r_pwm <= p_pwm_dout;
      end if;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      if (p_pwm_re2 = '1') then
        r2_pwm <= p_pwm_dout2;
      end if;
    end if;
  end process;

  p_pwm_imm <= 
    p_pwm_dout when newState = '1' else
    r_pwm;
  p_pwm_imm2 <= 
    p_pwm_dout2 when newState = '1' else
    r2_pwm;
-- "sequence" memory signals
  ram_5: PWM_sequence_RAM
    port map (
      rst => reset, 
      clk => clk, 
      we => p_sequence_we, 
      addr => p_sequence_addr, 
      addr2 => p_sequence_addr2, 
      din => p_sequence_din, 
      dout => p_sequence_dout, 
      dout2 => p_sequence_dout2);

  p_sequence_addr <= 
    r_k(8 downto 0) when thisState = b6s2 else
    r_k(8 downto 0) when thisState = b12s0 else
    (others => 'X');
  p_sequence_re <= '0';
  p_sequence_re2 <= 
    newState when thisState = b10s0 and s_b10_stage(1) = '1' else
    '0';
  p_sequence_addr2 <= ni170_r_e_g_1;
  p_sequence_we <= 
    '1' when thisState = b6s2 else
    '1' when thisState = b12s0 else
    '0';
  p_sequence_din <= 
    ni417_nSampleDna when thisState = b6s2 else
    r_nSampleDna when thisState = b12s0 else
    (others => 'X');
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (p_sequence_re = '1') then
        r_sequence <= p_sequence_dout;
      end if;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      if (p_sequence_re2 = '1') then
        r2_sequence <= p_sequence_dout2;
      end if;
    end if;
  end process;

  p_sequence_imm <= 
    p_sequence_dout when newState = '1' else
    r_sequence;
  p_sequence_imm2 <= 
    p_sequence_dout2 when newState = '1' else
    r2_sequence;
  ti194_req <= 
    '1' when thisState = b10s0 and s_b10_vwrite(2) = '1' and s_b10_1.predicates(0) = '1' else
    '0';
  ti194_pipeen <= 
    not s_b10_stall when thisState = b10s0 and s_b10_predicates(0) = '1' else
    '0';
  ti205_req <= 
    '1' when thisState = b10s0 and s_b10_vwrite(2) = '1' and s_b10_1.predicates(2) = '1' else
    '0';
  ti205_pipeen <= 
    not s_b10_stall when thisState = b10s0 and s_b10_predicates(2) = '1' else
    '0';
  ti216_req <= 
    '1' when thisState = b10s0 and s_b10_vwrite(3) = '1' and s_b10_2.predicates(4) = '1' else
    '0';
  ti216_pipeen <= 
    not s_b10_stall when thisState = b10s0 and s_b10_predicates(4) = '1' else
    '0';
  ti227_req <= 
    '1' when thisState = b10s0 and s_b10_vwrite(3) = '1' and s_b10_2.predicates(6) = '1' else
    '0';
  ti227_pipeen <= 
    not s_b10_stall when thisState = b10s0 and s_b10_predicates(6) = '1' else
    '0';
end rtl;
library ieee;
use ieee.std_logic_1164.all;

library impulse;
use impulse.components.all;
  
use impulse.xilinx_float_low_latency.all;
  
entity Filter is
  port (signal reset : in std_ulogic;
    signal sclk : in std_ulogic;
    signal clk : in std_ulogic;
    signal p_threshold_stream_rdy : in std_ulogic;
    signal p_threshold_stream_en : inout std_ulogic;
    signal p_threshold_stream_eos : in std_ulogic;
    signal p_threshold_stream_data : in std_ulogic_vector (31 downto 0);
    signal p_counter_stream_rdy : in std_ulogic;
    signal p_counter_stream_en : inout std_ulogic;
    signal p_counter_stream_eos : in std_ulogic;
    signal p_counter_stream_data : in std_ulogic_vector (15 downto 0);
    signal p_sum_stream_rdy : in std_ulogic;
    signal p_sum_stream_en : inout std_ulogic;
    signal p_sum_stream_eos : in std_ulogic;
    signal p_sum_stream_data : in std_ulogic_vector (31 downto 0);
    signal p_start_stream_rdy : in std_ulogic;
    signal p_start_stream_en : inout std_ulogic;
    signal p_start_stream_eos : out std_ulogic;
    signal p_start_stream_data : out std_ulogic_vector (15 downto 0);
    signal p_score_stream_rdy : in std_ulogic;
    signal p_score_stream_en : inout std_ulogic;
    signal p_score_stream_eos : out std_ulogic;
    signal p_score_stream_data : out std_ulogic_vector (31 downto 0));
end Filter;

use work.external_components.all;
architecture rtl of Filter is
  function mkvec(b : in std_ulogic) return std_ulogic_vector is
    variable res : std_ulogic_vector(0 downto 0);
  begin
    res(0):=b;
    return(res);
  end;

  type stateType is (init, b0s0, b0s1, b1s0, b2s0, b3s0, b4s0, b4s1, b4s2, b5s0, b6s0, b6s1, b6s2, b6s3, b7s0, b7s1, b7s2, b7s3, b8s0, b9s0, b10s0, b11s0, b12s0, finished);
  signal thisState : stateType;
  signal nextState : stateType;
  signal stateEn : std_ulogic;
  signal newState : std_ulogic;
  signal r_threshold_stream : std_ulogic_vector (31 downto 0);
  signal r_counter_stream : std_ulogic_vector (15 downto 0);
  signal r_sum_stream : std_ulogic_vector (31 downto 0);
  signal r_threshold : std_ulogic_vector (31 downto 0);
  signal ni230_threshold : std_ulogic_vector (31 downto 0);
  signal r_filterMode : std_ulogic_vector (31 downto 0);
  signal ni231_filterMode : std_ulogic_vector (31 downto 0);
  signal ni232_filterMode : std_ulogic_vector (31 downto 0);
  signal r_nResultStart : std_ulogic_vector (15 downto 0);
  signal ni233_nResultStart : std_ulogic_vector (15 downto 0);
  signal ni242_nResultStart : std_ulogic_vector (15 downto 0);
  signal r_nResultScore : std_ulogic_vector (31 downto 0);
  signal ni234_nResultScore : std_ulogic_vector (31 downto 0);
  signal ni240_nResultScore : std_ulogic_vector (31 downto 0);
  signal ni243_nResultScore : std_ulogic_vector (31 downto 0);
  signal r_nHitStart : std_ulogic_vector (15 downto 0);
  signal ni236_nHitStart : std_ulogic_vector (15 downto 0);
  signal r_nHitScore : std_ulogic_vector (31 downto 0);
  signal ni238_nHitScore : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp : std_ulogic_vector (31 downto 0);
  signal ni229_suif_tmp : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp0 : std_ulogic_vector (31 downto 0);
  signal ni235_suif_tmp0 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp1 : std_ulogic_vector (31 downto 0);
  signal ni237_suif_tmp1 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp2 : std_ulogic_vector (31 downto 0);
  signal ni239_suif_tmp2 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp3 : std_ulogic_vector (31 downto 0);
  signal ni241_suif_tmp3 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp4 : std_ulogic_vector (31 downto 0);
  signal ni244_suif_tmp4 : std_ulogic_vector (31 downto 0);
  signal r_r_e_g_0 : std_ulogic_vector (0 downto 0);
  signal ni75_r_e_g_0 : std_ulogic_vector (0 downto 0);
  signal ti137_pipeen : std_ulogic;
  signal ti137_req : std_ulogic;
  signal t_1 : std_ulogic_vector (0 downto 0);
  signal ti132_pipeen : std_ulogic;
  signal ti132_req : std_ulogic;
  signal t_0 : std_ulogic_vector (31 downto 0);
begin
  process (clk,reset)
  begin
    if (reset='1') then
     thisState <= init;
    elsif (clk'event and clk='1') then
      if (stateEn = '1') then
        thisState <= nextState;
      end if;
    end if;
  end process;

  stateEn <= 
    '0' when thisState = b0s0 and p_threshold_stream_rdy = '0' else
    '0' when thisState = b4s0 and p_counter_stream_rdy = '0' else
    '0' when thisState = b4s1 and p_sum_stream_rdy = '0' else
    '0' when thisState = b8s0 and (p_start_stream_rdy and p_score_stream_rdy) = '0' else
    '0' when thisState = b10s0 and (p_start_stream_rdy and p_score_stream_rdy) = '0' else
    '0' when thisState = b11s0 and (p_threshold_stream_eos and p_counter_stream_eos and p_sum_stream_eos and p_start_stream_rdy and p_score_stream_rdy) = '0' else
    '1';

  process (ni244_suif_tmp4,ni241_suif_tmp3,ni239_suif_tmp2,r_suif_tmp1,ni235_suif_tmp0,ni229_suif_tmp,thisState)
  begin
    case thisState is
    when init =>
      nextState <= b0s0;
    when b0s0 =>
      nextState <= b0s1;
    when b0s1 =>
      if (ni229_suif_tmp(0) = '1') then
        nextState <= b1s0;
      elsif ((not ni229_suif_tmp(0)) = '1') then
        nextState <= b2s0;
      else
        nextState <= b0s1;
      end if;
    when b1s0 =>
      nextState <= b3s0;
    when b2s0 =>
      nextState <= b3s0;
    when b3s0 =>
      nextState <= b4s0;
    when b4s0 =>
      if ((not ni235_suif_tmp0(0)) = '1') then
        nextState <= b9s0;
      else
        nextState <= b4s1;
      end if;
    when b4s1 =>
      nextState <= b4s2;
    when b4s2 =>
      if (r_suif_tmp1(0) = '1') then
        nextState <= b5s0;
      elsif ((not r_suif_tmp1(0)) = '1') then
        nextState <= b4s0;
      else
        nextState <= b4s2;
      end if;
    when b5s0 =>
      if (ni239_suif_tmp2(0) = '1') then
        nextState <= b6s0;
      elsif ((not ni239_suif_tmp2(0)) = '1') then
        nextState <= b7s0;
      else
        nextState <= b5s0;
      end if;
    when b6s0 =>
      nextState <= b6s1;
    when b6s1 =>
      nextState <= b6s2;
    when b6s2 =>
      nextState <= b6s3;
    when b6s3 =>
      nextState <= b4s0;
    when b7s0 =>
      nextState <= b7s1;
    when b7s1 =>
      nextState <= b7s2;
    when b7s2 =>
      nextState <= b7s3;
    when b7s3 =>
      if (ni241_suif_tmp3(0) = '1') then
        nextState <= b8s0;
      elsif ((not ni241_suif_tmp3(0)) = '1') then
        nextState <= b4s0;
      else
        nextState <= b7s3;
      end if;
    when b8s0 =>
      nextState <= b4s0;
    when b9s0 =>
      if (ni244_suif_tmp4(0) = '1') then
        nextState <= b10s0;
      elsif ((not ni244_suif_tmp4(0)) = '1') then
        nextState <= b11s0;
      else
        nextState <= b9s0;
      end if;
    when b10s0 =>
      nextState <= b11s0;
    when b11s0 =>
      nextState <= b0s0;
    when b12s0 =>
      nextState <= finished;
    when finished =>
      nextState <= finished;
    when others =>
      nextState <= init;
    end case;
  end process;

  process (clk,reset)
  begin
    if (reset='1') then
     newState <= '1';
    elsif (clk'event and clk='1') then
      newState <= stateEn;
    end if;
  end process;

-- b0s0
  ni75_r_e_g_0 <= mkvec(p_threshold_stream_eos);

-- b0s1
  ni230_threshold <= r_threshold_stream;
  ni229_suif_tmp <= "0000000000000000000000000000000" & neq("0" & r_r_e_g_0, "00");

-- b1s0
  ni231_filterMode <= X"00000001";

-- b2s0
  ni232_filterMode <= X"00000002";

-- b3s0
  ni233_nResultStart <= X"0000";
  ni234_nResultScore <= X"00000000";

-- b4s0
  ni235_suif_tmp0 <= "0000000000000000000000000000000" & eq("0" & mkvec(p_counter_stream_eos), "00");

-- b4s1
  ni236_nHitStart <= r_counter_stream;
  ni237_suif_tmp1 <= "0000000000000000000000000000000" & eq("0" & mkvec(p_sum_stream_eos), "00");

-- b4s2
  ni238_nHitScore <= r_sum_stream;

-- b5s0
  ni239_suif_tmp2 <= "0000000000000000000000000000000" & eq(r_filterMode(2 downto 0), "001");

-- b6s0
  fadd_ll_0: fadd_ll
    port map (
      clk => clk, 
      a => r_nResultScore, 
      b => r_nHitScore, 
      go => ti132_req, 
      result => t_0, 
      pipeEn => ti132_pipeen);


-- b6s1

-- b6s2

-- b6s3
  ni240_nResultScore <= t_0;

-- b7s0
  flteq_ll_1: flteq_ll
    port map (
      clk => clk, 
      a => r_threshold, 
      b => r_nHitScore, 
      go => ti137_req, 
      result => t_1, 
      pipeEn => ti137_pipeen);


-- b7s1

-- b7s2

-- b7s3
  ni241_suif_tmp3 <= "0000000000000000000000000000000" & t_1;

-- b8s0
  ni242_nResultStart <= r_nHitStart;
  ni243_nResultScore <= r_nHitScore;

-- b9s0
  ni244_suif_tmp4 <= "0000000000000000000000000000000" & eq(r_filterMode(2 downto 0), "001");

-- b10s0

-- b11s0

-- b12s0

-- 


  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b0s0 =>
        if (stateEn = '1') then
          r_r_e_g_0 <= ni75_r_e_g_0;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b0s1 =>
        if (stateEn = '1') then
          r_threshold <= ni230_threshold;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b0s1 =>
        if (stateEn = '1') then
          r_suif_tmp <= ni229_suif_tmp;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b1s0 =>
        if (stateEn = '1') then
          r_filterMode <= ni231_filterMode;
        end if;
      when b2s0 =>
        if (stateEn = '1') then
          r_filterMode <= ni232_filterMode;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b3s0 =>
        if (stateEn = '1') then
          r_nResultStart <= ni233_nResultStart;
        end if;
      when b8s0 =>
        if (stateEn = '1') then
          r_nResultStart <= ni242_nResultStart;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b3s0 =>
        if (stateEn = '1') then
          r_nResultScore <= ni234_nResultScore;
        end if;
      when b6s3 =>
        if (stateEn = '1') then
          r_nResultScore <= ni240_nResultScore;
        end if;
      when b8s0 =>
        if (stateEn = '1') then
          r_nResultScore <= ni243_nResultScore;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b4s0 =>
        if (stateEn = '1') then
          r_suif_tmp0 <= ni235_suif_tmp0;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b4s1 =>
        if (stateEn = '1') then
          r_nHitStart <= ni236_nHitStart;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b4s1 =>
        if (stateEn = '1') then
          r_suif_tmp1 <= ni237_suif_tmp1;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b4s2 =>
        if (stateEn = '1') then
          r_nHitScore <= ni238_nHitScore;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b5s0 =>
        if (stateEn = '1') then
          r_suif_tmp2 <= ni239_suif_tmp2;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b7s3 =>
        if (stateEn = '1') then
          r_suif_tmp3 <= ni241_suif_tmp3;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b9s0 =>
        if (stateEn = '1') then
          r_suif_tmp4 <= ni244_suif_tmp4;
        end if;
      when others => null;
      end case;
    end if;
  end process;

-- "threshold_stream" interface signals
  process (clk)
  begin
    if (clk'event and clk='1') then
      if ((p_threshold_stream_en and p_threshold_stream_rdy) = '1') then
        r_threshold_stream <= p_threshold_stream_data;
      end if;
    end if;
  end process;

  p_threshold_stream_en <= 
    stateEn and (not p_threshold_stream_eos) when thisState = b0s0 else
    stateEn when thisState = b11s0 else
    '0';

-- "counter_stream" interface signals
  process (clk)
  begin
    if (clk'event and clk='1') then
      if ((p_counter_stream_en and p_counter_stream_rdy) = '1') then
        r_counter_stream <= p_counter_stream_data;
      end if;
    end if;
  end process;

  p_counter_stream_en <= 
    stateEn and (not p_counter_stream_eos) when thisState = b4s0 else
    stateEn when thisState = b11s0 else
    '0';

-- "sum_stream" interface signals
  process (clk)
  begin
    if (clk'event and clk='1') then
      if ((p_sum_stream_en and p_sum_stream_rdy) = '1') then
        r_sum_stream <= p_sum_stream_data;
      end if;
    end if;
  end process;

  p_sum_stream_en <= 
    stateEn and (not p_sum_stream_eos) when thisState = b4s1 else
    stateEn when thisState = b11s0 else
    '0';

-- "start_stream" interface signals
  p_start_stream_en <= 
    stateEn when thisState = b8s0 else
    stateEn when thisState = b10s0 else
    stateEn when thisState = b11s0 else
    '0';
  p_start_stream_data <= 
    ni242_nResultStart when thisState = b8s0 else
    r_nResultStart when thisState = b10s0 else
    (others => 'X');
  p_start_stream_eos <= 
    '1' when thisState = b11s0 else
    '0';

-- "score_stream" interface signals
  p_score_stream_en <= 
    stateEn when thisState = b8s0 else
    stateEn when thisState = b10s0 else
    stateEn when thisState = b11s0 else
    '0';
  p_score_stream_data <= 
    ni243_nResultScore when thisState = b8s0 else
    r_nResultScore when thisState = b10s0 else
    (others => 'X');
  p_score_stream_eos <= 
    '1' when thisState = b11s0 else
    '0';

  ti132_req <= 
    '1' when thisState = b6s0 and stateEn = '1' else
    '0';
  ti132_pipeen <= 
    '1' when stateEn = '1' else
    '0';
  ti137_req <= 
    '1' when thisState = b7s0 and stateEn = '1' else
    '0';
  ti137_pipeen <= 
    '1' when stateEn = '1' else
    '0';
end rtl;
