#include "co.h"
extern void *ccs_alloc_process(void *sim);
extern int Producer(co_stream,co_stream,co_stream,co_stream, co_parameter);
extern void *create_PWM_rtl();
extern void enum_PWM_rtl(void (*)(), void *);
extern void *create_Filter_rtl();
extern void enum_Filter_rtl(void (*)(), void *);
extern int Consumer(co_stream,co_stream);

int PWM(co_stream pwm_stream, co_stream iteration_stream, co_stream dna_stream, co_stream counter_stream, co_stream sum_stream)
{
  void *proc;

  proc=ccs_alloc_process(create_PWM_rtl());

  ccs_load_symbols(proc,enum_PWM_rtl);
  ccs_attach_signals(proc,ccs_stream_reader(pwm_stream),"p_pwm_stream",O_RDONLY);
  ccs_stream_readable(ccs_stream_reader(pwm_stream));
  ccs_attach_signals(proc,ccs_stream_reader(iteration_stream),"p_iteration_stream",O_RDONLY);
  ccs_stream_readable(ccs_stream_reader(iteration_stream));
  ccs_attach_signals(proc,ccs_stream_reader(dna_stream),"p_dna_stream",O_RDONLY);
  ccs_stream_readable(ccs_stream_reader(dna_stream));
  ccs_attach_signals(proc,ccs_stream_writer(counter_stream),"p_counter_stream",O_WRONLY);
  ccs_stream_writable(ccs_stream_writer(counter_stream));
  ccs_attach_signals(proc,ccs_stream_writer(sum_stream),"p_sum_stream",O_WRONLY);
  ccs_stream_writable(ccs_stream_writer(sum_stream));
  ccs_dbg(proc);
}
int Filter(co_stream threshold_stream, co_stream counter_stream, co_stream sum_stream, co_stream start_stream, co_stream score_stream)
{
  void *proc;

  proc=ccs_alloc_process(create_Filter_rtl());

  ccs_load_symbols(proc,enum_Filter_rtl);
  ccs_attach_signals(proc,ccs_stream_reader(threshold_stream),"p_threshold_stream",O_RDONLY);
  ccs_stream_readable(ccs_stream_reader(threshold_stream));
  ccs_attach_signals(proc,ccs_stream_reader(counter_stream),"p_counter_stream",O_RDONLY);
  ccs_stream_readable(ccs_stream_reader(counter_stream));
  ccs_attach_signals(proc,ccs_stream_reader(sum_stream),"p_sum_stream",O_RDONLY);
  ccs_stream_readable(ccs_stream_reader(sum_stream));
  ccs_attach_signals(proc,ccs_stream_writer(start_stream),"p_start_stream",O_WRONLY);
  ccs_stream_writable(ccs_stream_writer(start_stream));
  ccs_attach_signals(proc,ccs_stream_writer(score_stream),"p_score_stream",O_WRONLY);
  ccs_stream_writable(ccs_stream_writer(score_stream));
  ccs_dbg(proc);
}

static void ccs_config(void *arg)
{
  co_process proc;

  _co_arch_wait_init(1);

  co_stream threshold_stream;
  co_stream pwm_stream;
  co_stream iteration_stream;
  co_stream dna_stream;
  co_stream counter_stream;
  co_stream sum_stream;
  co_stream start_stream;
  co_stream score_stream;

  threshold_stream=co_stream_create("threshold_stream",UINT_TYPE(32),1);
  pwm_stream=co_stream_create("pwm_stream",UINT_TYPE(32),32);
  iteration_stream=co_stream_create("iteration_stream",INT_TYPE(16),1);
  dna_stream=co_stream_create("dna_stream",INT_TYPE(8),300);
  counter_stream=co_stream_create("counter_stream",INT_TYPE(16),300);
  sum_stream=co_stream_create("sum_stream",UINT_TYPE(32),300);
  start_stream=co_stream_create("start_stream",INT_TYPE(16),30);
  score_stream=co_stream_create("score_stream",UINT_TYPE(32),30);

  proc=co_process_create("Producer",(co_function)Producer,5,
                    threshold_stream,
                    pwm_stream,
                    iteration_stream,
                    dna_stream,
                    arg);
  proc=co_process_create("PWM",(co_function)PWM,5,
                    pwm_stream,
                    iteration_stream,
                    dna_stream,
                    counter_stream,
                    sum_stream);
  co_process_config(proc,co_loc,"PE0");
  proc=co_process_create("Filter",(co_function)Filter,5,
                    threshold_stream,
                    counter_stream,
                    sum_stream,
                    start_stream,
                    score_stream);
  co_process_config(proc,co_loc,"PE0");
  proc=co_process_create("Consumer",(co_function)Consumer,2,
                    start_stream,
                    score_stream);

  ccs_stream_attach(threshold_stream,O_RDONLY);
  ccs_stream_attach(pwm_stream,O_RDONLY);
  ccs_stream_attach(iteration_stream,O_RDONLY);
  ccs_stream_attach(dna_stream,O_RDONLY);
  ccs_stream_attach(counter_stream,O_WRONLY);
  ccs_stream_attach(counter_stream,O_RDONLY);
  ccs_stream_attach(sum_stream,O_WRONLY);
  ccs_stream_attach(sum_stream,O_RDONLY);
  ccs_stream_attach(start_stream,O_WRONLY);
  ccs_stream_attach(score_stream,O_WRONLY);
  ccsdbg_config("FPWM.smd");

}

co_architecture co_initialize(void *arg)
{
  return(co_architecture_create("FPWM","generic_vhdl",ccs_config,arg));
}
