#define BIT(d,no) (((d)>>(no))&0x1)
#define MKBIT(d,no) ((d)<<(no))

typedef struct vec64_s {
  unsigned int d1,d0;
} vec64_t;

typedef unsigned int vec_t;

#define LESS_SIGN(x,y,ty) ((ty)(x)<(ty)(y))
#define LESS_EQ_SIGN(x,y,ty) ((ty)(x)<=(ty)(y))
#define GREATER_SIGN(x,y,ty) ((ty)(x)>(ty)(y))
#define GREATER_EQ_SIGN(x,y,ty) ((ty)(x)>=(ty)(y))
#define LESS_UNSIGN(x,y) ((unsigned int)(x)<(unsigned int)(y))
#define LESS_EQ_UNSIGN(x,y) ((unsigned int)(x)<=(unsigned int)(y))
#define GREATER_UNSIGN(x,y) ((unsigned int)(x)>(unsigned int)(y))
#define GREATER_EQ_UNSIGN(x,y) ((unsigned int)(x)>=(unsigned int)(y))
#define RSHIFT_UNSIGN(x,y) ((x)>>(y))
#define RSHIFT_SIGN(x,y,ty) (((ty)(x))>>(y))
#define MUL_SIGN(x,y,ty) (((ty)(x))*(ty)(y))
#define MUL_UNSIGN(x,y,ty) (((ty)(x))*(ty)(y))
#define SIGN8(x) ((char)(x))
#define SIGN16(x) ((short)(x))
#define SIGN32(x) ((int)(x))
#define SIGN64(x) ((long long)(x))
#define EXT_SIGN8(x,y) ((((char)(x))<<y)>>y)
#define EXT_SIGN16(x,y) ((((short)(x))<<y)>>y)
#define EXT_SIGN32(x,y) ((((int)(x))<<y)>>y)
#define EXT_SIGN64(x,y) ((((long long)(x))<<y)>>y)

extern ccsvec_copy(vec_t *dst, vec_t *src);
extern vec_t *ccsvec_const(vec_t *dst, int sz, ...);
extern vec_t *ccsvec_import(vec_t *dst, int sz, unsigned long long val);
extern vec_t *ccsvec_slice(vec_t *v, int off, int sz);
extern unsigned long long ccsvec_extract(vec_t *v, int off, int sz);
extern vec_t *ccsvec_extend(vec_t *dst, int sz, unsigned long long val, int extsz);
extern vec_t *ccsvec_cat(vec_t *dst, int no, ...);
extern vec_t *ccsvec_not(vec_t *dst, vec_t *arg);
extern vec_t *ccsvec_neg(vec_t *dst, vec_t *arg);
extern vec_t *ccsvec_abs(vec_t *dst, vec_t *arg);
extern vec_t *ccsvec_sll(vec_t *dst, vec_t *v, int n);
extern vec_t *ccsvec_srl(vec_t *dst, vec_t *v, int n);
extern vec_t *ccsvec_sra(vec_t *dst, vec_t *v, int n);
extern vec_t *ccsvec_rol(vec_t *dst, vec_t *v, int n);
extern vec_t *ccsvec_ror(vec_t *dst, vec_t *v, int n);
extern vec_t *ccsvec_and(vec_t *dst, vec_t *v1, vec_t *v2);
extern vec_t *ccsvec_or(vec_t *dst, vec_t *v1, vec_t *v2);
extern vec_t *ccsvec_xor(vec_t *dst, vec_t *v1, vec_t *v2);
extern vec_t *ccsvec_nand(vec_t *dst, vec_t *v1, vec_t *v2);
extern vec_t *ccsvec_nor(vec_t *dst, vec_t *v1, vec_t *v2);
extern vec_t *ccsvec_xnor(vec_t *dst, vec_t *v1, vec_t *v2);
extern vec_t *ccsvec_add(vec_t *dst, vec_t *v1, vec_t *v2);
extern vec_t *ccsvec_sub(vec_t *dst, vec_t *v1, vec_t *v2);
extern vec_t *ccsvec_mul(vec_t *dst, vec_t *v1, vec_t *v2);
extern vec_t *ccsvec_div(vec_t *dst, vec_t *v1, vec_t *v2);
extern vec_t *ccsvec_mod(vec_t *dst, vec_t *v1, vec_t *v2);
extern int ccsvec_eq(vec_t *v1, vec_t *v2);
extern int ccsvec_neq(vec_t *v1, vec_t *v2);
extern int ccsvec_less(vec_t *v1, vec_t *v2, int issigned);
extern int ccsvec_leq(vec_t *v1, vec_t *v2, int issigned);
extern int ccsvec_greater(vec_t *v1, vec_t *v2, int issigned);
extern int ccsvec_geq(vec_t *v1, vec_t *v2, int issigned);

extern unsigned fadd(unsigned,unsigned);
extern unsigned fsub(unsigned,unsigned);
extern unsigned fmul(unsigned,unsigned);
extern unsigned fdiv(unsigned,unsigned);
extern unsigned feq(unsigned,unsigned);
extern unsigned fneq(unsigned,unsigned);
extern unsigned flt(unsigned,unsigned);
extern unsigned flteq(unsigned,unsigned);

extern unsigned long long faddd(unsigned long long,unsigned long long);
extern unsigned long long fsubd(unsigned long long,unsigned long long);
extern unsigned long long fmuld(unsigned long long,unsigned long long);
extern unsigned long long fdivd(unsigned long long,unsigned long long);
extern unsigned long long feqd(unsigned long long,unsigned long long);
extern unsigned long long fneqd(unsigned long long,unsigned long long);
extern unsigned long long fltd(unsigned long long,unsigned long long);
extern unsigned long long flteqd(unsigned long long,unsigned long long);

extern unsigned itof(unsigned);
extern unsigned utof(unsigned);
extern unsigned ftoi(unsigned);
extern unsigned long long itod(unsigned);
extern unsigned long long utod(unsigned);
extern unsigned dtoi(unsigned long long);
struct _sd_reset_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_sclk_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_clk_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_threshold_stream_rdy_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_threshold_stream_en_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_threshold_stream_eos_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_threshold_stream_data_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned int last_value;
};
struct _sd_p_counter_stream_rdy_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_counter_stream_en_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_counter_stream_eos_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_counter_stream_data_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned int last_value;
};
struct _sd_p_sum_stream_rdy_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_sum_stream_en_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_sum_stream_eos_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_sum_stream_data_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned int last_value;
};
struct _sd_p_start_stream_rdy_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_start_stream_en_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_start_stream_eos_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_start_stream_data_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned int last_value;
};
struct _sd_p_score_stream_rdy_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_score_stream_en_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_score_stream_eos_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_score_stream_data_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned int last_value;
};

enum stateType {stateType_finished,stateType_b12s0,stateType_b11s0,stateType_b10s0,stateType_b9s0,stateType_b8s0,stateType_b7s3,stateType_b7s2,stateType_b7s1,stateType_b7s0,stateType_b6s3,stateType_b6s2,stateType_b6s1,stateType_b6s0,stateType_b5s0,stateType_b4s2,stateType_b4s1,stateType_b4s0,stateType_b3s0,stateType_b2s0,stateType_b1s0,stateType_b0s1,stateType_b0s0,stateType_init};

typedef struct {
  struct _sd_reset_s _sd_reset;
  unsigned char reset;
  struct _sd_sclk_s _sd_sclk;
  unsigned char sclk;
  struct _sd_clk_s _sd_clk;
  unsigned char clk;
  struct _sd_p_threshold_stream_rdy_s _sd_p_threshold_stream_rdy;
  unsigned char p_threshold_stream_rdy;
  struct _sd_p_threshold_stream_en_s _sd_p_threshold_stream_en;
  unsigned char p_threshold_stream_en;
  struct _sd_p_threshold_stream_eos_s _sd_p_threshold_stream_eos;
  unsigned char p_threshold_stream_eos;
  struct _sd_p_threshold_stream_data_s _sd_p_threshold_stream_data;
  unsigned int p_threshold_stream_data;
  struct _sd_p_counter_stream_rdy_s _sd_p_counter_stream_rdy;
  unsigned char p_counter_stream_rdy;
  struct _sd_p_counter_stream_en_s _sd_p_counter_stream_en;
  unsigned char p_counter_stream_en;
  struct _sd_p_counter_stream_eos_s _sd_p_counter_stream_eos;
  unsigned char p_counter_stream_eos;
  struct _sd_p_counter_stream_data_s _sd_p_counter_stream_data;
  unsigned int p_counter_stream_data;
  struct _sd_p_sum_stream_rdy_s _sd_p_sum_stream_rdy;
  unsigned char p_sum_stream_rdy;
  struct _sd_p_sum_stream_en_s _sd_p_sum_stream_en;
  unsigned char p_sum_stream_en;
  struct _sd_p_sum_stream_eos_s _sd_p_sum_stream_eos;
  unsigned char p_sum_stream_eos;
  struct _sd_p_sum_stream_data_s _sd_p_sum_stream_data;
  unsigned int p_sum_stream_data;
  struct _sd_p_start_stream_rdy_s _sd_p_start_stream_rdy;
  unsigned char p_start_stream_rdy;
  struct _sd_p_start_stream_en_s _sd_p_start_stream_en;
  unsigned char p_start_stream_en;
  struct _sd_p_start_stream_eos_s _sd_p_start_stream_eos;
  unsigned char p_start_stream_eos;
  struct _sd_p_start_stream_data_s _sd_p_start_stream_data;
  unsigned int p_start_stream_data;
  struct _sd_p_score_stream_rdy_s _sd_p_score_stream_rdy;
  unsigned char p_score_stream_rdy;
  struct _sd_p_score_stream_en_s _sd_p_score_stream_en;
  unsigned char p_score_stream_en;
  struct _sd_p_score_stream_eos_s _sd_p_score_stream_eos;
  unsigned char p_score_stream_eos;
  struct _sd_p_score_stream_data_s _sd_p_score_stream_data;
  unsigned int p_score_stream_data;
  unsigned int flteq_ll_1_queue_mem[4];
  unsigned int flteq_ll_1_queue_in_ptr;
  unsigned int flteq_ll_1_queue_out_ptr;
  unsigned int flteq_ll_1_queue_next_ptr;
  unsigned int flteq_ll_1_value;
  unsigned int fadd_ll_0_queue_mem[4];
  unsigned int fadd_ll_0_queue_in_ptr;
  unsigned int fadd_ll_0_queue_out_ptr;
  unsigned int fadd_ll_0_queue_next_ptr;
  unsigned int fadd_ll_0_value;
  enum stateType thisState;
  enum stateType nextState;
  unsigned char stateEn;
  unsigned char newState;
  unsigned int r_threshold_stream;
  unsigned int r_counter_stream;
  unsigned int r_sum_stream;
  unsigned int r_threshold;
  unsigned int ni230_threshold;
  unsigned int r_filterMode;
  unsigned int ni231_filterMode;
  unsigned int ni232_filterMode;
  unsigned int r_nResultStart;
  unsigned int ni233_nResultStart;
  unsigned int ni242_nResultStart;
  unsigned int r_nResultScore;
  unsigned int ni234_nResultScore;
  unsigned int ni240_nResultScore;
  unsigned int ni243_nResultScore;
  unsigned int r_nHitStart;
  unsigned int ni236_nHitStart;
  unsigned int r_nHitScore;
  unsigned int ni238_nHitScore;
  unsigned int r_suif_tmp;
  unsigned int ni229_suif_tmp;
  unsigned int r_suif_tmp0;
  unsigned int ni235_suif_tmp0;
  unsigned int r_suif_tmp1;
  unsigned int ni237_suif_tmp1;
  unsigned int r_suif_tmp2;
  unsigned int ni239_suif_tmp2;
  unsigned int r_suif_tmp3;
  unsigned int ni241_suif_tmp3;
  unsigned int r_suif_tmp4;
  unsigned int ni244_suif_tmp4;
  unsigned int r_r_e_g_0;
  unsigned int ni75_r_e_g_0;
  unsigned char ti137_pipeen;
  unsigned char ti137_req;
  unsigned int t_1;
  unsigned char ti132_pipeen;
  unsigned char ti132_req;
  unsigned int t_0;
} Filter_rtl_t;

typedef struct {
  void (*clk_deltap)(Filter_rtl_t *);
  void (*clk_procp)(Filter_rtl_t *);
  void (*init_procp)(Filter_rtl_t *);
  void (*endp)(Filter_rtl_t *);
  Filter_rtl_t *data;
} Filter_rtl_if_t;

static unsigned int mkvec(unsigned char b);
