#define BIT(d,no) (((d)>>(no))&0x1)
#define MKBIT(d,no) ((d)<<(no))

typedef struct vec64_s {
  unsigned int d1,d0;
} vec64_t;

typedef unsigned int vec_t;

#define LESS_SIGN(x,y,ty) ((ty)(x)<(ty)(y))
#define LESS_EQ_SIGN(x,y,ty) ((ty)(x)<=(ty)(y))
#define GREATER_SIGN(x,y,ty) ((ty)(x)>(ty)(y))
#define GREATER_EQ_SIGN(x,y,ty) ((ty)(x)>=(ty)(y))
#define LESS_UNSIGN(x,y) ((unsigned int)(x)<(unsigned int)(y))
#define LESS_EQ_UNSIGN(x,y) ((unsigned int)(x)<=(unsigned int)(y))
#define GREATER_UNSIGN(x,y) ((unsigned int)(x)>(unsigned int)(y))
#define GREATER_EQ_UNSIGN(x,y) ((unsigned int)(x)>=(unsigned int)(y))
#define RSHIFT_UNSIGN(x,y) ((x)>>(y))
#define RSHIFT_SIGN(x,y,ty) (((ty)(x))>>(y))
#define MUL_SIGN(x,y,ty) (((ty)(x))*(ty)(y))
#define MUL_UNSIGN(x,y,ty) (((ty)(x))*(ty)(y))
#define SIGN8(x) ((char)(x))
#define SIGN16(x) ((short)(x))
#define SIGN32(x) ((int)(x))
#define SIGN64(x) ((long long)(x))
#define EXT_SIGN8(x,y) ((((char)(x))<<y)>>y)
#define EXT_SIGN16(x,y) ((((short)(x))<<y)>>y)
#define EXT_SIGN32(x,y) ((((int)(x))<<y)>>y)
#define EXT_SIGN64(x,y) ((((long long)(x))<<y)>>y)

extern ccsvec_copy(vec_t *dst, vec_t *src);
extern vec_t *ccsvec_const(vec_t *dst, int sz, ...);
extern vec_t *ccsvec_import(vec_t *dst, int sz, unsigned long long val);
extern vec_t *ccsvec_slice(vec_t *v, int off, int sz);
extern unsigned long long ccsvec_extract(vec_t *v, int off, int sz);
extern vec_t *ccsvec_extend(vec_t *dst, int sz, unsigned long long val, int extsz);
extern vec_t *ccsvec_cat(vec_t *dst, int no, ...);
extern vec_t *ccsvec_not(vec_t *dst, vec_t *arg);
extern vec_t *ccsvec_neg(vec_t *dst, vec_t *arg);
extern vec_t *ccsvec_abs(vec_t *dst, vec_t *arg);
extern vec_t *ccsvec_sll(vec_t *dst, vec_t *v, int n);
extern vec_t *ccsvec_srl(vec_t *dst, vec_t *v, int n);
extern vec_t *ccsvec_sra(vec_t *dst, vec_t *v, int n);
extern vec_t *ccsvec_rol(vec_t *dst, vec_t *v, int n);
extern vec_t *ccsvec_ror(vec_t *dst, vec_t *v, int n);
extern vec_t *ccsvec_and(vec_t *dst, vec_t *v1, vec_t *v2);
extern vec_t *ccsvec_or(vec_t *dst, vec_t *v1, vec_t *v2);
extern vec_t *ccsvec_xor(vec_t *dst, vec_t *v1, vec_t *v2);
extern vec_t *ccsvec_nand(vec_t *dst, vec_t *v1, vec_t *v2);
extern vec_t *ccsvec_nor(vec_t *dst, vec_t *v1, vec_t *v2);
extern vec_t *ccsvec_xnor(vec_t *dst, vec_t *v1, vec_t *v2);
extern vec_t *ccsvec_add(vec_t *dst, vec_t *v1, vec_t *v2);
extern vec_t *ccsvec_sub(vec_t *dst, vec_t *v1, vec_t *v2);
extern vec_t *ccsvec_mul(vec_t *dst, vec_t *v1, vec_t *v2);
extern vec_t *ccsvec_div(vec_t *dst, vec_t *v1, vec_t *v2);
extern vec_t *ccsvec_mod(vec_t *dst, vec_t *v1, vec_t *v2);
extern int ccsvec_eq(vec_t *v1, vec_t *v2);
extern int ccsvec_neq(vec_t *v1, vec_t *v2);
extern int ccsvec_less(vec_t *v1, vec_t *v2, int issigned);
extern int ccsvec_leq(vec_t *v1, vec_t *v2, int issigned);
extern int ccsvec_greater(vec_t *v1, vec_t *v2, int issigned);
extern int ccsvec_geq(vec_t *v1, vec_t *v2, int issigned);

extern unsigned fadd(unsigned,unsigned);
extern unsigned fsub(unsigned,unsigned);
extern unsigned fmul(unsigned,unsigned);
extern unsigned fdiv(unsigned,unsigned);
extern unsigned feq(unsigned,unsigned);
extern unsigned fneq(unsigned,unsigned);
extern unsigned flt(unsigned,unsigned);
extern unsigned flteq(unsigned,unsigned);

extern unsigned long long faddd(unsigned long long,unsigned long long);
extern unsigned long long fsubd(unsigned long long,unsigned long long);
extern unsigned long long fmuld(unsigned long long,unsigned long long);
extern unsigned long long fdivd(unsigned long long,unsigned long long);
extern unsigned long long feqd(unsigned long long,unsigned long long);
extern unsigned long long fneqd(unsigned long long,unsigned long long);
extern unsigned long long fltd(unsigned long long,unsigned long long);
extern unsigned long long flteqd(unsigned long long,unsigned long long);

extern unsigned itof(unsigned);
extern unsigned utof(unsigned);
extern unsigned ftoi(unsigned);
extern unsigned long long itod(unsigned);
extern unsigned long long utod(unsigned);
extern unsigned dtoi(unsigned long long);
struct _sd_reset_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_sclk_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_clk_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_pwm_stream_rdy_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_pwm_stream_en_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_pwm_stream_eos_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_pwm_stream_data_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned int last_value;
};
struct _sd_p_iteration_stream_rdy_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_iteration_stream_en_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_iteration_stream_eos_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_iteration_stream_data_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned int last_value;
};
struct _sd_p_dna_stream_rdy_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_dna_stream_en_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_dna_stream_eos_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_dna_stream_data_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned int last_value;
};
struct _sd_p_counter_stream_rdy_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_counter_stream_en_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_counter_stream_eos_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_counter_stream_data_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned int last_value;
};
struct _sd_p_sum_stream_rdy_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_sum_stream_en_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_sum_stream_eos_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned char last_value;
};
struct _sd_p_sum_stream_data_s {
  unsigned char active,event;
  long long last_active,last_event;
  unsigned int last_value;
};

enum stateType {stateType_finished,stateType_b16s0,stateType_b15s0,stateType_b14s0,stateType_b13s0,stateType_b12s0,stateType_b11s1,stateType_b11s0,stateType_b10s0,stateType_b9s0,stateType_b8s0,stateType_b7s0,stateType_b6s2,stateType_b6s1,stateType_b6s0,stateType_b5s0,stateType_b4s1,stateType_b4s0,stateType_b3s0,stateType_b2s2,stateType_b2s1,stateType_b2s0,stateType_b1s1,stateType_b1s0,stateType_b0s0,stateType_init};

enum pipeStateType {pipeStateType_flush,pipeStateType_run,pipeStateType_init,pipeStateType_idle};

typedef struct {
  unsigned int predicates;
  unsigned int f_r_e_g_1;
  unsigned int f_r_e_g_2;
} t_b10_0_t_t;

typedef struct {
  unsigned int predicates;
  unsigned int f_r_e_g_1;
  unsigned int f_r_e_g_2;
  unsigned int f_suif_tmp4;
  unsigned int f_r_e_g_0;
  unsigned int f_r_e_g_3;
  unsigned int f_r_e_g_4;
  unsigned int f_r_e_g_5;
} t_b10_1_t_t;

typedef struct {
  unsigned int predicates;
  unsigned int f_r_e_g_1;
  unsigned int f_r_e_g_2;
  unsigned int f_suif_tmp4;
  unsigned int f_r_e_g_0;
  unsigned int f_r_e_g_3;
  unsigned int f_r_e_g_4;
  unsigned int f_r_e_g_5;
} t_b10_2_t_t;

typedef struct {
  unsigned int predicates;
  unsigned int f_r_e_g_1;
  unsigned int f_r_e_g_2;
  unsigned int f_suif_tmp4;
  unsigned int f_r_e_g_0;
  unsigned int f_r_e_g_3;
  unsigned int f_r_e_g_4;
  unsigned int f_r_e_g_5;
} t_b10_3_t_t;

typedef struct {
  unsigned int predicates;
  unsigned int f_r_e_g_1;
  unsigned int f_r_e_g_2;
  unsigned int f_suif_tmp4;
  unsigned int f_r_e_g_0;
  unsigned int f_r_e_g_3;
  unsigned int f_r_e_g_4;
  unsigned int f_r_e_g_5;
} t_b10_4_t_t;

typedef struct {
  unsigned int predicates;
  unsigned int f_r_e_g_1;
  unsigned int f_r_e_g_2;
  unsigned int f_suif_tmp4;
  unsigned int f_r_e_g_0;
  unsigned int f_r_e_g_3;
  unsigned int f_r_e_g_4;
  unsigned int f_r_e_g_5;
  unsigned int f_sum;
} t_b10_5_t_t;

typedef struct {
  unsigned int predicates;
  unsigned int f_sum;
} t_b10_6_t_t;

typedef struct {
  struct _sd_reset_s _sd_reset;
  unsigned char reset;
  struct _sd_sclk_s _sd_sclk;
  unsigned char sclk;
  struct _sd_clk_s _sd_clk;
  unsigned char clk;
  struct _sd_p_pwm_stream_rdy_s _sd_p_pwm_stream_rdy;
  unsigned char p_pwm_stream_rdy;
  struct _sd_p_pwm_stream_en_s _sd_p_pwm_stream_en;
  unsigned char p_pwm_stream_en;
  struct _sd_p_pwm_stream_eos_s _sd_p_pwm_stream_eos;
  unsigned char p_pwm_stream_eos;
  struct _sd_p_pwm_stream_data_s _sd_p_pwm_stream_data;
  unsigned int p_pwm_stream_data;
  struct _sd_p_iteration_stream_rdy_s _sd_p_iteration_stream_rdy;
  unsigned char p_iteration_stream_rdy;
  struct _sd_p_iteration_stream_en_s _sd_p_iteration_stream_en;
  unsigned char p_iteration_stream_en;
  struct _sd_p_iteration_stream_eos_s _sd_p_iteration_stream_eos;
  unsigned char p_iteration_stream_eos;
  struct _sd_p_iteration_stream_data_s _sd_p_iteration_stream_data;
  unsigned int p_iteration_stream_data;
  struct _sd_p_dna_stream_rdy_s _sd_p_dna_stream_rdy;
  unsigned char p_dna_stream_rdy;
  struct _sd_p_dna_stream_en_s _sd_p_dna_stream_en;
  unsigned char p_dna_stream_en;
  struct _sd_p_dna_stream_eos_s _sd_p_dna_stream_eos;
  unsigned char p_dna_stream_eos;
  struct _sd_p_dna_stream_data_s _sd_p_dna_stream_data;
  unsigned int p_dna_stream_data;
  struct _sd_p_counter_stream_rdy_s _sd_p_counter_stream_rdy;
  unsigned char p_counter_stream_rdy;
  struct _sd_p_counter_stream_en_s _sd_p_counter_stream_en;
  unsigned char p_counter_stream_en;
  struct _sd_p_counter_stream_eos_s _sd_p_counter_stream_eos;
  unsigned char p_counter_stream_eos;
  struct _sd_p_counter_stream_data_s _sd_p_counter_stream_data;
  unsigned int p_counter_stream_data;
  struct _sd_p_sum_stream_rdy_s _sd_p_sum_stream_rdy;
  unsigned char p_sum_stream_rdy;
  struct _sd_p_sum_stream_en_s _sd_p_sum_stream_en;
  unsigned char p_sum_stream_en;
  struct _sd_p_sum_stream_eos_s _sd_p_sum_stream_eos;
  unsigned char p_sum_stream_eos;
  struct _sd_p_sum_stream_data_s _sd_p_sum_stream_data;
  unsigned int p_sum_stream_data;
  unsigned int ram_5_mem[300];
  unsigned int ram_5_raddr;
  unsigned int ram_5_raddr2;
  unsigned int ram_4_mem[32];
  unsigned int ram_4_raddr;
  unsigned int ram_4_raddr2;
  unsigned int fadd_ll_3_queue_mem[4];
  unsigned int fadd_ll_3_queue_in_ptr;
  unsigned int fadd_ll_3_queue_out_ptr;
  unsigned int fadd_ll_3_queue_next_ptr;
  unsigned int fadd_ll_3_value;
  unsigned int fadd_ll_2_queue_mem[4];
  unsigned int fadd_ll_2_queue_in_ptr;
  unsigned int fadd_ll_2_queue_out_ptr;
  unsigned int fadd_ll_2_queue_next_ptr;
  unsigned int fadd_ll_2_value;
  unsigned int fadd_ll_1_queue_mem[4];
  unsigned int fadd_ll_1_queue_in_ptr;
  unsigned int fadd_ll_1_queue_out_ptr;
  unsigned int fadd_ll_1_queue_next_ptr;
  unsigned int fadd_ll_1_value;
  unsigned int fadd_ll_0_queue_mem[4];
  unsigned int fadd_ll_0_queue_in_ptr;
  unsigned int fadd_ll_0_queue_out_ptr;
  unsigned int fadd_ll_0_queue_next_ptr;
  unsigned int fadd_ll_0_value;
  enum stateType thisState;
  enum stateType nextState;
  unsigned char stateEn;
  unsigned char newState;
  unsigned int r_pwm_stream;
  unsigned int r_iteration_stream;
  unsigned int r_dna_stream;
  unsigned int r_i;
  unsigned int ni407_i;
  unsigned int ni411_i;
  unsigned int r_j;
  unsigned int ni405_j;
  unsigned int ni412_j;
  unsigned int r_k;
  unsigned int ni415_k;
  unsigned int ni418_k;
  unsigned int ni444_k;
  unsigned int r_l;
  unsigned int ni422_l;
  unsigned int ni438_l;
  unsigned int r_nSamplePwm;
  unsigned int ni409_nSamplePwm;
  unsigned int r_pwm;
  unsigned int ni88_pwm;
  unsigned int ni196_pwm;
  unsigned int ni207_pwm;
  unsigned int ni218_pwm;
  unsigned int ni229_pwm;
  unsigned char p_pwm_we;
  unsigned int p_pwm_din;
  unsigned int p_pwm_dout;
  unsigned int p_pwm_addr;
  unsigned int p_pwm_addr2;
  unsigned int p_pwm_dout2;
  unsigned int p_pwm_imm;
  unsigned char p_pwm_re;
  unsigned int r2_pwm;
  unsigned int p_pwm_imm2;
  unsigned char p_pwm_re2;
  unsigned int r_dnaLength;
  unsigned int ni414_dnaLength;
  unsigned int r_motifLength;
  unsigned int ni404_motifLength;
  unsigned int r_nSampleDna;
  unsigned int ni417_nSampleDna;
  unsigned int ni443_nSampleDna;
  unsigned int r_sequence;
  unsigned int ni134_sequence;
  unsigned int ni168_sequence;
  unsigned int ni278_sequence;
  unsigned char p_sequence_we;
  unsigned int p_sequence_din;
  unsigned int p_sequence_dout;
  unsigned int p_sequence_addr;
  unsigned int p_sequence_addr2;
  unsigned int p_sequence_dout2;
  unsigned int p_sequence_imm;
  unsigned char p_sequence_re;
  unsigned int r2_sequence;
  unsigned int p_sequence_imm2;
  unsigned char p_sequence_re2;
  unsigned int r_counter;
  unsigned int ni419_counter;
  unsigned int ni445_counter;
  unsigned int r_sum;
  unsigned int ni420_sum;
  unsigned int ni427_sum;
  unsigned int ni430_sum;
  unsigned int ni433_sum;
  unsigned int ni436_sum;
  unsigned int ni446_sum;
  unsigned int r_nHitStart;
  unsigned int ni440_nHitStart;
  unsigned int r_nHitScore;
  unsigned int ni441_nHitScore;
  unsigned int r_suif_tmp;
  unsigned int ni413_suif_tmp;
  unsigned int r_suif_tmp0;
  unsigned int ni421_suif_tmp0;
  unsigned int r_suif_tmp1;
  unsigned int ni447_suif_tmp1;
  unsigned int r_suif_tmp2;
  unsigned int ni442_suif_tmp2;
  unsigned int r_suif_tmp3;
  unsigned int ni423_suif_tmp3;
  unsigned int r_suif_tmp4;
  unsigned int ni439_suif_tmp4;
  unsigned int r_suif_tmp5;
  unsigned int ni426_suif_tmp5;
  unsigned int r_suif_tmp6;
  unsigned int ni429_suif_tmp6;
  unsigned int r_suif_tmp7;
  unsigned int ni432_suif_tmp7;
  unsigned int r_suif_tmp8;
  unsigned int ni435_suif_tmp8;
  unsigned int r_suif_tmp9;
  unsigned int ni406_suif_tmp9;
  unsigned int r_suif_tmp10;
  unsigned int ni408_suif_tmp10;
  unsigned int r_suif_tmp11;
  unsigned int ni416_suif_tmp11;
  unsigned int r_suif_tmp90;
  unsigned int ni424_suif_tmp90;
  unsigned int r_suif_tmp_0;
  unsigned int ni425_suif_tmp_0;
  unsigned int r_r_e_g_0;
  unsigned int ni410_r_e_g_0;
  unsigned int ni428_r_e_g_0;
  unsigned int r_r_e_g_1;
  unsigned int ni170_r_e_g_1;
  unsigned int r_r_e_g_2;
  unsigned int ni400_r_e_g_2;
  unsigned int r_r_e_g_3;
  unsigned int ni431_r_e_g_3;
  unsigned int r_r_e_g_4;
  unsigned int ni434_r_e_g_4;
  unsigned int r_r_e_g_5;
  unsigned int ni437_r_e_g_5;
  unsigned int t_10;
  unsigned int t_9;
  unsigned int t_8;
  unsigned char ti227_pipeen;
  unsigned char ti227_req;
  unsigned int t_7;
  unsigned char ti216_pipeen;
  unsigned char ti216_req;
  unsigned int t_6;
  unsigned char ti205_pipeen;
  unsigned char ti205_req;
  unsigned int t_5;
  unsigned char ti194_pipeen;
  unsigned char ti194_req;
  unsigned int t_4;
  unsigned int t_3;
  unsigned int t_2;
  unsigned int t_1;
  unsigned int t_0;
  enum pipeStateType s_b10_state;
  t_b10_0_t_t s_b10_0;
  t_b10_1_t_t s_b10_1;
  t_b10_2_t_t s_b10_2;
  t_b10_3_t_t s_b10_3;
  t_b10_4_t_t s_b10_4;
  t_b10_5_t_t s_b10_5;
  t_b10_6_t_t s_b10_6;
  unsigned char s_b10_stall;
  unsigned char s_b10_break;
  unsigned char s_b10_loop;
  unsigned char s_b10_flushed;
  unsigned char s_b10_done;
  unsigned int s_b10_vstall;
  unsigned int s_b10_vbreak;
  unsigned int s_b10_stage;
  unsigned int s_b10_vwrite;
  unsigned int s_b10_vcont;
  unsigned int s_b10_delay;
  unsigned int s_b10_predicates;
  unsigned int _tmp1;
  int _tmp1_2;
  unsigned int _tmp1_3;
  int _tmp1_4;
  unsigned int _tmp1_5;
  int _tmp1_6;
  unsigned int _tmp1_7;
  int _tmp1_8;
  unsigned int _tmp1_9;
  int _tmp1_10;
  unsigned int _tmp1_11;
  int _tmp1_12;
  unsigned int _tmp1_13;
  int _tmp1_14;
  unsigned int _tmp1_15;
  int _tmp1_16;
  unsigned int _tmp1_17;
  int _tmp1_18;
  unsigned int _tmp1_19;
  int _tmp1_20;
  unsigned int _tmp1_21;
  int _tmp1_22;
  unsigned int _tmp1_23;
  int _tmp1_24;
  unsigned int _tmp1_25;
  int _tmp1_26;
  unsigned int _tmp1_27;
  int _tmp1_28;
  unsigned int _tmp1_29;
  int _tmp1_30;
  unsigned int _tmp1_31;
  int _tmp1_32;
} PWM_rtl_t;

typedef struct {
  void (*clk_deltap)(PWM_rtl_t *);
  void (*clk_procp)(PWM_rtl_t *);
  void (*init_procp)(PWM_rtl_t *);
  void (*endp)(PWM_rtl_t *);
  PWM_rtl_t *data;
} PWM_rtl_if_t;

static unsigned int sign_ext(unsigned int v,int SIZE);
static unsigned int sign_ext_2(unsigned int v,int SIZE);
static unsigned int mkvec(unsigned char b);
