/*******************************************************************************
 DO NOT EDIT
 This file was automatically generated by the Impulse C Compiler.

 Impulse C is Copyright 2002-2005, Impulse Accelerated Technologies, Inc.

 Stage Master is Copyright 2002-2005, Green Mountain Computing Systems, Inc.

 All rights reserved.
********************************************************************************/

#include "co.h"

/* Architecture Includes */
#include <fcntl.h>
#include "einlib.h"

#define IMPULSE_BASE 0x7800000
#define IMPULSE_CONNECTION_SIZE (sizeof(uint64) * 4)

int _co_fpga_id, _num_bytes, _fpga_status;
const char * _fpga_bitfile = "top.bin.ufp";
err_e _cray_err;



/* Run Procedures */
extern void Producer(co_stream, co_stream, co_stream, co_stream, co_parameter);
extern void PWM(co_stream, co_stream, co_stream, co_stream, co_stream);
extern void Filter(co_stream, co_stream, co_stream, co_stream, co_stream);
extern void Consumer(co_stream, co_stream);

co_architecture co_initialize(void *arg)

{
  co_stream threshold_stream;
  co_stream pwm_stream;
  co_stream iteration_stream;
  co_stream dna_stream;
  co_stream counter_stream;
  co_stream sum_stream;
  co_stream start_stream;
  co_stream score_stream;

  threshold_stream=co_stream_create("threshold_stream",UINT_TYPE(32),1);
  pwm_stream=co_stream_create("pwm_stream",UINT_TYPE(32),32);
  iteration_stream=co_stream_create("iteration_stream",INT_TYPE(16),1);
  dna_stream=co_stream_create("dna_stream",INT_TYPE(8),300);
  counter_stream=co_stream_create("counter_stream",INT_TYPE(16),300);
  sum_stream=co_stream_create("sum_stream",UINT_TYPE(32),300);
  start_stream=co_stream_create("start_stream",INT_TYPE(16),30);
  score_stream=co_stream_create("score_stream",UINT_TYPE(32),30);
  co_process_create("Producer",(co_function)Producer,
                    5,
                    threshold_stream,
                    pwm_stream,
                    iteration_stream,
                    dna_stream,
                    arg);
  co_process_create("Consumer",(co_function)Consumer,
                    2,
                    start_stream,
                    score_stream);

  /* Architecture Initialization */
  /* Open the FPGA device */
  _co_fpga_id = fpga_open("/dev/ufp0", O_RDWR|O_SYNC, &_cray_err);
  if ( _cray_err != NOERR ) {
    printf("Failed to open FPGA device.\n");
    return NULL;
  }

  /* Load the bitfile into the FPGA. */
  _num_bytes = fpga_load(_co_fpga_id, _fpga_bitfile, &_cray_err);
  if ( _cray_err != NOERR ) {
    printf("Failed to load FPGA bitfile.\n");
    return NULL;
  }

  /* Start execution of the FPGA logic. */
  _fpga_status = fpga_start(_co_fpga_id, &_cray_err);
  if ( _fpga_status != 0 ) {
	  printf("Failed to execute FPGA logic.\n");
    return NULL;
  }
  co_stream_attach(threshold_stream, (void *)IMPULSE_BASE + IMPULSE_CONNECTION_SIZE*0, HW_INPUT);
  co_stream_attach(pwm_stream, (void *)IMPULSE_BASE + IMPULSE_CONNECTION_SIZE*1, HW_INPUT);
  co_stream_attach(iteration_stream, (void *)IMPULSE_BASE + IMPULSE_CONNECTION_SIZE*2, HW_INPUT);
  co_stream_attach(dna_stream, (void *)IMPULSE_BASE + IMPULSE_CONNECTION_SIZE*3, HW_INPUT);
  co_stream_attach(start_stream, (void *)IMPULSE_BASE + IMPULSE_CONNECTION_SIZE*4, HW_OUTPUT);
  co_stream_attach(score_stream, (void *)IMPULSE_BASE + IMPULSE_CONNECTION_SIZE*5, HW_OUTPUT);

  return(NULL);

}
