/*********************************************************************
* Copyright (c) 2004-2005, Impulse Accelerated Technologies, Inc.
* All Rights Reserved.
*
* co_math.h: Math functions and declarations.
*
* There is no need to #include this file directly -- it is referenced
* by co.h, the standard Impulse C header file.
*
*********************************************************************/

#ifndef CO_MATH_H
#define CO_MATH_H

#include "co_types.h"

typedef int8 co_int1;
typedef int8 co_int2;
typedef int8 co_int3;
typedef int8 co_int4;
typedef int8 co_int5;
typedef int8 co_int6;
typedef int8 co_int7;
typedef int8 co_int8;
typedef int16 co_int9;
typedef int16 co_int10;
typedef int16 co_int11;
typedef int16 co_int12;
typedef int16 co_int13;
typedef int16 co_int14;
typedef int16 co_int15;
typedef int16 co_int16;
typedef int32 co_int17;
typedef int32 co_int18;
typedef int32 co_int19;
typedef int32 co_int20;
typedef int32 co_int21;
typedef int32 co_int22;
typedef int32 co_int23;
typedef int32 co_int24;
typedef int32 co_int25;
typedef int32 co_int26;
typedef int32 co_int27;
typedef int32 co_int28;
typedef int32 co_int29;
typedef int32 co_int30;
typedef int32 co_int31;
typedef int32 co_int32;
typedef int64 co_int33;
typedef int64 co_int34;
typedef int64 co_int35;
typedef int64 co_int36;
typedef int64 co_int37;
typedef int64 co_int38;
typedef int64 co_int39;
typedef int64 co_int40;
typedef int64 co_int41;
typedef int64 co_int42;
typedef int64 co_int43;
typedef int64 co_int44;
typedef int64 co_int45;
typedef int64 co_int46;
typedef int64 co_int47;
typedef int64 co_int48;
typedef int64 co_int49;
typedef int64 co_int50;
typedef int64 co_int51;
typedef int64 co_int52;
typedef int64 co_int53;
typedef int64 co_int54;
typedef int64 co_int55;
typedef int64 co_int56;
typedef int64 co_int57;
typedef int64 co_int58;
typedef int64 co_int59;
typedef int64 co_int60;
typedef int64 co_int61;
typedef int64 co_int62;
typedef int64 co_int63;
typedef int64 co_int64;
typedef int64 co_int128[2];
typedef int64 co_int256[4];

typedef uint8 co_uint1;
typedef uint8 co_uint2;
typedef uint8 co_uint3;
typedef uint8 co_uint4;
typedef uint8 co_uint5;
typedef uint8 co_uint6;
typedef uint8 co_uint7;
typedef uint8 co_uint8;
typedef uint16 co_uint9;
typedef uint16 co_uint10;
typedef uint16 co_uint11;
typedef uint16 co_uint12;
typedef uint16 co_uint13;
typedef uint16 co_uint14;
typedef uint16 co_uint15;
typedef uint16 co_uint16;
typedef uint32 co_uint17;
typedef uint32 co_uint18;
typedef uint32 co_uint19;
typedef uint32 co_uint20;
typedef uint32 co_uint21;
typedef uint32 co_uint22;
typedef uint32 co_uint23;
typedef uint32 co_uint24;
typedef uint32 co_uint25;
typedef uint32 co_uint26;
typedef uint32 co_uint27;
typedef uint32 co_uint28;
typedef uint32 co_uint29;
typedef uint32 co_uint30;
typedef uint32 co_uint31;
typedef uint32 co_uint32;
typedef uint64 co_uint33;
typedef uint64 co_uint34;
typedef uint64 co_uint35;
typedef uint64 co_uint36;
typedef uint64 co_uint37;
typedef uint64 co_uint38;
typedef uint64 co_uint39;
typedef uint64 co_uint40;
typedef uint64 co_uint41;
typedef uint64 co_uint42;
typedef uint64 co_uint43;
typedef uint64 co_uint44;
typedef uint64 co_uint45;
typedef uint64 co_uint46;
typedef uint64 co_uint47;
typedef uint64 co_uint48;
typedef uint64 co_uint49;
typedef uint64 co_uint50;
typedef uint64 co_uint51;
typedef uint64 co_uint52;
typedef uint64 co_uint53;
typedef uint64 co_uint54;
typedef uint64 co_uint55;
typedef uint64 co_uint56;
typedef uint64 co_uint57;
typedef uint64 co_uint58;
typedef uint64 co_uint59;
typedef uint64 co_uint60;
typedef uint64 co_uint61;
typedef uint64 co_uint62;
typedef uint64 co_uint63;
typedef uint64 co_uint64;
typedef uint64 co_uint128[2];
typedef uint64 co_uint256[4];

#define IADD1(a,b) ((((int64)(a)+(int64)(b))<<63)>>63)
#define IADD2(a,b) ((((int64)(a)+(int64)(b))<<62)>>62)
#define IADD3(a,b) ((((int64)(a)+(int64)(b))<<61)>>61)
#define IADD4(a,b) ((((int64)(a)+(int64)(b))<<60)>>60)
#define IADD5(a,b) ((((int64)(a)+(int64)(b))<<59)>>59)
#define IADD6(a,b) ((((int64)(a)+(int64)(b))<<58)>>58)
#define IADD7(a,b) ((((int64)(a)+(int64)(b))<<57)>>57)
#define IADD8(a,b) ((((int64)(a)+(int64)(b))<<56)>>56)
#define IADD9(a,b) ((((int64)(a)+(int64)(b))<<55)>>55)
#define IADD10(a,b) ((((int64)(a)+(int64)(b))<<54)>>54)
#define IADD11(a,b) ((((int64)(a)+(int64)(b))<<53)>>53)
#define IADD12(a,b) ((((int64)(a)+(int64)(b))<<52)>>52)
#define IADD13(a,b) ((((int64)(a)+(int64)(b))<<51)>>51)
#define IADD14(a,b) ((((int64)(a)+(int64)(b))<<50)>>50)
#define IADD15(a,b) ((((int64)(a)+(int64)(b))<<49)>>49)
#define IADD16(a,b) ((((int64)(a)+(int64)(b))<<48)>>48)
#define IADD17(a,b) ((((int64)(a)+(int64)(b))<<47)>>47)
#define IADD18(a,b) ((((int64)(a)+(int64)(b))<<46)>>46)
#define IADD19(a,b) ((((int64)(a)+(int64)(b))<<45)>>45)
#define IADD20(a,b) ((((int64)(a)+(int64)(b))<<44)>>44)
#define IADD21(a,b) ((((int64)(a)+(int64)(b))<<43)>>43)
#define IADD22(a,b) ((((int64)(a)+(int64)(b))<<42)>>42)
#define IADD23(a,b) ((((int64)(a)+(int64)(b))<<41)>>41)
#define IADD24(a,b) ((((int64)(a)+(int64)(b))<<40)>>40)
#define IADD25(a,b) ((((int64)(a)+(int64)(b))<<39)>>39)
#define IADD26(a,b) ((((int64)(a)+(int64)(b))<<38)>>38)
#define IADD27(a,b) ((((int64)(a)+(int64)(b))<<37)>>37)
#define IADD28(a,b) ((((int64)(a)+(int64)(b))<<36)>>36)
#define IADD29(a,b) ((((int64)(a)+(int64)(b))<<35)>>35)
#define IADD30(a,b) ((((int64)(a)+(int64)(b))<<34)>>34)
#define IADD31(a,b) ((((int64)(a)+(int64)(b))<<33)>>33)
#define IADD32(a,b) ((((int64)(a)+(int64)(b))<<32)>>32)
#define IADD33(a,b) ((((int64)(a)+(int64)(b))<<31)>>31)
#define IADD34(a,b) ((((int64)(a)+(int64)(b))<<30)>>30)
#define IADD35(a,b) ((((int64)(a)+(int64)(b))<<29)>>29)
#define IADD36(a,b) ((((int64)(a)+(int64)(b))<<28)>>28)
#define IADD37(a,b) ((((int64)(a)+(int64)(b))<<27)>>27)
#define IADD38(a,b) ((((int64)(a)+(int64)(b))<<26)>>26)
#define IADD39(a,b) ((((int64)(a)+(int64)(b))<<25)>>25)
#define IADD40(a,b) ((((int64)(a)+(int64)(b))<<24)>>24)
#define IADD41(a,b) ((((int64)(a)+(int64)(b))<<23)>>23)
#define IADD42(a,b) ((((int64)(a)+(int64)(b))<<22)>>22)
#define IADD43(a,b) ((((int64)(a)+(int64)(b))<<21)>>21)
#define IADD44(a,b) ((((int64)(a)+(int64)(b))<<20)>>20)
#define IADD45(a,b) ((((int64)(a)+(int64)(b))<<19)>>19)
#define IADD46(a,b) ((((int64)(a)+(int64)(b))<<18)>>18)
#define IADD47(a,b) ((((int64)(a)+(int64)(b))<<17)>>17)
#define IADD48(a,b) ((((int64)(a)+(int64)(b))<<16)>>16)
#define IADD49(a,b) ((((int64)(a)+(int64)(b))<<15)>>15)
#define IADD50(a,b) ((((int64)(a)+(int64)(b))<<14)>>14)
#define IADD51(a,b) ((((int64)(a)+(int64)(b))<<13)>>13)
#define IADD52(a,b) ((((int64)(a)+(int64)(b))<<12)>>12)
#define IADD53(a,b) ((((int64)(a)+(int64)(b))<<11)>>11)
#define IADD54(a,b) ((((int64)(a)+(int64)(b))<<10)>>10)
#define IADD55(a,b) ((((int64)(a)+(int64)(b))<<9)>>9)
#define IADD56(a,b) ((((int64)(a)+(int64)(b))<<8)>>8)
#define IADD57(a,b) ((((int64)(a)+(int64)(b))<<7)>>7)
#define IADD58(a,b) ((((int64)(a)+(int64)(b))<<6)>>6)
#define IADD59(a,b) ((((int64)(a)+(int64)(b))<<5)>>5)
#define IADD60(a,b) ((((int64)(a)+(int64)(b))<<4)>>4)
#define IADD61(a,b) ((((int64)(a)+(int64)(b))<<3)>>3)
#define IADD62(a,b) ((((int64)(a)+(int64)(b))<<2)>>2)
#define IADD63(a,b) ((((int64)(a)+(int64)(b))<<1)>>1)
#define IADD64(a,b) ((int64)(a)+(int64)(b))

#define UADD1(a,b) (((uint8)(a)+(uint8)(b))&0x1)
#define UADD2(a,b) (((uint8)(a)+(uint8)(b))&0x3)
#define UADD3(a,b) (((uint8)(a)+(uint8)(b))&0x7)
#define UADD4(a,b) (((uint8)(a)+(uint8)(b))&0xf)
#define UADD5(a,b) (((uint8)(a)+(uint8)(b))&0x1f)
#define UADD6(a,b) (((uint8)(a)+(uint8)(b))&0x3f)
#define UADD7(a,b) (((uint8)(a)+(uint8)(b))&0x7f)
#define UADD8(a,b) ((uint8)(a)+(uint8)(b))
#define UADD9(a,b) (((uint16)(a)+(uint16)(b))&0x1ff)
#define UADD10(a,b) (((uint16)(a)+(uint16)(b))&0x3ff)
#define UADD11(a,b) (((uint16)(a)+(uint16)(b))&0x7ff)
#define UADD12(a,b) (((uint16)(a)+(uint16)(b))&0xfff)
#define UADD13(a,b) (((uint16)(a)+(uint16)(b))&0x1fff)
#define UADD14(a,b) (((uint16)(a)+(uint16)(b))&0x3fff)
#define UADD15(a,b) (((uint16)(a)+(uint16)(b))&0x7fff)
#define UADD16(a,b) ((uint16)(a)+(uint16)(b))
#define UADD17(a,b) (((uint32)(a)+(uint32)(b))&0x1ffff)
#define UADD18(a,b) (((uint32)(a)+(uint32)(b))&0x3ffff)
#define UADD19(a,b) (((uint32)(a)+(uint32)(b))&0x7ffff)
#define UADD20(a,b) (((uint32)(a)+(uint32)(b))&0xfffff)
#define UADD21(a,b) (((uint32)(a)+(uint32)(b))&0x1fffff)
#define UADD22(a,b) (((uint32)(a)+(uint32)(b))&0x3fffff)
#define UADD23(a,b) (((uint32)(a)+(uint32)(b))&0x7fffff)
#define UADD24(a,b) (((uint32)(a)+(uint32)(b))&0xffffff)
#define UADD25(a,b) (((uint32)(a)+(uint32)(b))&0x1ffffff)
#define UADD26(a,b) (((uint32)(a)+(uint32)(b))&0x3ffffff)
#define UADD27(a,b) (((uint32)(a)+(uint32)(b))&0x7ffffff)
#define UADD28(a,b) (((uint32)(a)+(uint32)(b))&0xfffffff)
#define UADD29(a,b) (((uint32)(a)+(uint32)(b))&0x1fffffff)
#define UADD30(a,b) (((uint32)(a)+(uint32)(b))&0x3fffffff)
#define UADD31(a,b) (((uint32)(a)+(uint32)(b))&0x7fffffff)
#define UADD32(a,b) ((uint32)(a)+(uint32)(b))
#define UADD33(a,b) (((uint64)(a)+(uint64)(b))&0x1ffffffffUL)
#define UADD34(a,b) (((uint64)(a)+(uint64)(b))&0x3ffffffffUL)
#define UADD35(a,b) (((uint64)(a)+(uint64)(b))&0x7ffffffffUL)
#define UADD36(a,b) (((uint64)(a)+(uint64)(b))&0xfffffffffUL)
#define UADD37(a,b) (((uint64)(a)+(uint64)(b))&0x1fffffffffUL)
#define UADD38(a,b) (((uint64)(a)+(uint64)(b))&0x3fffffffffUL)
#define UADD39(a,b) (((uint64)(a)+(uint64)(b))&0x7fffffffffUL)
#define UADD40(a,b) (((uint64)(a)+(uint64)(b))&0xffffffffffUL)
#define UADD41(a,b) (((uint64)(a)+(uint64)(b))&0x1ffffffffffUL)
#define UADD42(a,b) (((uint64)(a)+(uint64)(b))&0x3ffffffffffUL)
#define UADD43(a,b) (((uint64)(a)+(uint64)(b))&0x7ffffffffffUL)
#define UADD44(a,b) (((uint64)(a)+(uint64)(b))&0xfffffffffffUL)
#define UADD45(a,b) (((uint64)(a)+(uint64)(b))&0x1fffffffffffUL)
#define UADD46(a,b) (((uint64)(a)+(uint64)(b))&0x3fffffffffffUL)
#define UADD47(a,b) (((uint64)(a)+(uint64)(b))&0x7fffffffffffUL)
#define UADD48(a,b) (((uint64)(a)+(uint64)(b))&0xffffffffffffUL)
#define UADD49(a,b) (((uint64)(a)+(uint64)(b))&0x1ffffffffffffUL)
#define UADD50(a,b) (((uint64)(a)+(uint64)(b))&0x3ffffffffffffUL)
#define UADD51(a,b) (((uint64)(a)+(uint64)(b))&0x7ffffffffffffUL)
#define UADD52(a,b) (((uint64)(a)+(uint64)(b))&0xfffffffffffffUL)
#define UADD53(a,b) (((uint64)(a)+(uint64)(b))&0x1fffffffffffffUL)
#define UADD54(a,b) (((uint64)(a)+(uint64)(b))&0x3fffffffffffffUL)
#define UADD55(a,b) (((uint64)(a)+(uint64)(b))&0x7fffffffffffffUL)
#define UADD56(a,b) (((uint64)(a)+(uint64)(b))&0xffffffffffffffUL)
#define UADD57(a,b) (((uint64)(a)+(uint64)(b))&0x1ffffffffffffffUL)
#define UADD58(a,b) (((uint64)(a)+(uint64)(b))&0x3ffffffffffffffUL)
#define UADD59(a,b) (((uint64)(a)+(uint64)(b))&0x7ffffffffffffffUL)
#define UADD60(a,b) (((uint64)(a)+(uint64)(b))&0xfffffffffffffffUL)
#define UADD61(a,b) (((uint64)(a)+(uint64)(b))&0x1fffffffffffffffUL)
#define UADD62(a,b) (((uint64)(a)+(uint64)(b))&0x3fffffffffffffffUL)
#define UADD63(a,b) (((uint64)(a)+(uint64)(b))&0x7fffffffffffffffUL)
#define UADD64(a,b) ((uint64)(a)+(uint64)(b))

#define ISUB1(a,b) ((((int64)(a)-(int64)(b))<<63)>>63)
#define ISUB2(a,b) ((((int64)(a)-(int64)(b))<<62)>>62)
#define ISUB3(a,b) ((((int64)(a)-(int64)(b))<<61)>>61)
#define ISUB4(a,b) ((((int64)(a)-(int64)(b))<<60)>>60)
#define ISUB5(a,b) ((((int64)(a)-(int64)(b))<<59)>>59)
#define ISUB6(a,b) ((((int64)(a)-(int64)(b))<<58)>>58)
#define ISUB7(a,b) ((((int64)(a)-(int64)(b))<<57)>>57)
#define ISUB8(a,b) ((((int64)(a)-(int64)(b))<<56)>>56)
#define ISUB9(a,b) ((((int64)(a)-(int64)(b))<<55)>>55)
#define ISUB10(a,b) ((((int64)(a)-(int64)(b))<<54)>>54)
#define ISUB11(a,b) ((((int64)(a)-(int64)(b))<<53)>>53)
#define ISUB12(a,b) ((((int64)(a)-(int64)(b))<<52)>>52)
#define ISUB13(a,b) ((((int64)(a)-(int64)(b))<<51)>>51)
#define ISUB14(a,b) ((((int64)(a)-(int64)(b))<<50)>>50)
#define ISUB15(a,b) ((((int64)(a)-(int64)(b))<<49)>>49)
#define ISUB16(a,b) ((((int64)(a)-(int64)(b))<<48)>>48)
#define ISUB17(a,b) ((((int64)(a)-(int64)(b))<<47)>>47)
#define ISUB18(a,b) ((((int64)(a)-(int64)(b))<<46)>>46)
#define ISUB19(a,b) ((((int64)(a)-(int64)(b))<<45)>>45)
#define ISUB20(a,b) ((((int64)(a)-(int64)(b))<<44)>>44)
#define ISUB21(a,b) ((((int64)(a)-(int64)(b))<<43)>>43)
#define ISUB22(a,b) ((((int64)(a)-(int64)(b))<<42)>>42)
#define ISUB23(a,b) ((((int64)(a)-(int64)(b))<<41)>>41)
#define ISUB24(a,b) ((((int64)(a)-(int64)(b))<<40)>>40)
#define ISUB25(a,b) ((((int64)(a)-(int64)(b))<<39)>>39)
#define ISUB26(a,b) ((((int64)(a)-(int64)(b))<<38)>>38)
#define ISUB27(a,b) ((((int64)(a)-(int64)(b))<<37)>>37)
#define ISUB28(a,b) ((((int64)(a)-(int64)(b))<<36)>>36)
#define ISUB29(a,b) ((((int64)(a)-(int64)(b))<<35)>>35)
#define ISUB30(a,b) ((((int64)(a)-(int64)(b))<<34)>>34)
#define ISUB31(a,b) ((((int64)(a)-(int64)(b))<<33)>>33)
#define ISUB32(a,b) ((((int64)(a)-(int64)(b))<<32)>>32)
#define ISUB33(a,b) ((((int64)(a)-(int64)(b))<<31)>>31)
#define ISUB34(a,b) ((((int64)(a)-(int64)(b))<<30)>>30)
#define ISUB35(a,b) ((((int64)(a)-(int64)(b))<<29)>>29)
#define ISUB36(a,b) ((((int64)(a)-(int64)(b))<<28)>>28)
#define ISUB37(a,b) ((((int64)(a)-(int64)(b))<<27)>>27)
#define ISUB38(a,b) ((((int64)(a)-(int64)(b))<<26)>>26)
#define ISUB39(a,b) ((((int64)(a)-(int64)(b))<<25)>>25)
#define ISUB40(a,b) ((((int64)(a)-(int64)(b))<<24)>>24)
#define ISUB41(a,b) ((((int64)(a)-(int64)(b))<<23)>>23)
#define ISUB42(a,b) ((((int64)(a)-(int64)(b))<<22)>>22)
#define ISUB43(a,b) ((((int64)(a)-(int64)(b))<<21)>>21)
#define ISUB44(a,b) ((((int64)(a)-(int64)(b))<<20)>>20)
#define ISUB45(a,b) ((((int64)(a)-(int64)(b))<<19)>>19)
#define ISUB46(a,b) ((((int64)(a)-(int64)(b))<<18)>>18)
#define ISUB47(a,b) ((((int64)(a)-(int64)(b))<<17)>>17)
#define ISUB48(a,b) ((((int64)(a)-(int64)(b))<<16)>>16)
#define ISUB49(a,b) ((((int64)(a)-(int64)(b))<<15)>>15)
#define ISUB50(a,b) ((((int64)(a)-(int64)(b))<<14)>>14)
#define ISUB51(a,b) ((((int64)(a)-(int64)(b))<<13)>>13)
#define ISUB52(a,b) ((((int64)(a)-(int64)(b))<<12)>>12)
#define ISUB53(a,b) ((((int64)(a)-(int64)(b))<<11)>>11)
#define ISUB54(a,b) ((((int64)(a)-(int64)(b))<<10)>>10)
#define ISUB55(a,b) ((((int64)(a)-(int64)(b))<<9)>>9)
#define ISUB56(a,b) ((((int64)(a)-(int64)(b))<<8)>>8)
#define ISUB57(a,b) ((((int64)(a)-(int64)(b))<<7)>>7)
#define ISUB58(a,b) ((((int64)(a)-(int64)(b))<<6)>>6)
#define ISUB59(a,b) ((((int64)(a)-(int64)(b))<<5)>>5)
#define ISUB60(a,b) ((((int64)(a)-(int64)(b))<<4)>>4)
#define ISUB61(a,b) ((((int64)(a)-(int64)(b))<<3)>>3)
#define ISUB62(a,b) ((((int64)(a)-(int64)(b))<<2)>>2)
#define ISUB63(a,b) ((((int64)(a)-(int64)(b))<<1)>>1)
#define ISUB64(a,b) ((int64)(a)-(int64)(b))

#define USUB1(a,b) (((uint8)(a)-(uint8)(b))&0x1)
#define USUB2(a,b) (((uint8)(a)-(uint8)(b))&0x3)
#define USUB3(a,b) (((uint8)(a)-(uint8)(b))&0x7)
#define USUB4(a,b) (((uint8)(a)-(uint8)(b))&0xf)
#define USUB5(a,b) (((uint8)(a)-(uint8)(b))&0x1f)
#define USUB6(a,b) (((uint8)(a)-(uint8)(b))&0x3f)
#define USUB7(a,b) (((uint8)(a)-(uint8)(b))&0x7f)
#define USUB8(a,b) ((uint8)(a)-(uint8)(b))
#define USUB9(a,b) (((uint16)(a)-(uint16)(b))&0x1ff)
#define USUB10(a,b) (((uint16)(a)-(uint16)(b))&0x3ff)
#define USUB11(a,b) (((uint16)(a)-(uint16)(b))&0x7ff)
#define USUB12(a,b) (((uint16)(a)-(uint16)(b))&0xfff)
#define USUB13(a,b) (((uint16)(a)-(uint16)(b))&0x1fff)
#define USUB14(a,b) (((uint16)(a)-(uint16)(b))&0x3fff)
#define USUB15(a,b) (((uint16)(a)-(uint16)(b))&0x7fff)
#define USUB16(a,b) ((uint16)(a)-(uint16)(b))
#define USUB17(a,b) (((uint32)(a)-(uint32)(b))&0x1ffff)
#define USUB18(a,b) (((uint32)(a)-(uint32)(b))&0x3ffff)
#define USUB19(a,b) (((uint32)(a)-(uint32)(b))&0x7ffff)
#define USUB20(a,b) (((uint32)(a)-(uint32)(b))&0xfffff)
#define USUB21(a,b) (((uint32)(a)-(uint32)(b))&0x1fffff)
#define USUB22(a,b) (((uint32)(a)-(uint32)(b))&0x3fffff)
#define USUB23(a,b) (((uint32)(a)-(uint32)(b))&0x7fffff)
#define USUB24(a,b) (((uint32)(a)-(uint32)(b))&0xffffff)
#define USUB25(a,b) (((uint32)(a)-(uint32)(b))&0x1ffffff)
#define USUB26(a,b) (((uint32)(a)-(uint32)(b))&0x3ffffff)
#define USUB27(a,b) (((uint32)(a)-(uint32)(b))&0x7ffffff)
#define USUB28(a,b) (((uint32)(a)-(uint32)(b))&0xfffffff)
#define USUB29(a,b) (((uint32)(a)-(uint32)(b))&0x1fffffff)
#define USUB30(a,b) (((uint32)(a)-(uint32)(b))&0x3fffffff)
#define USUB31(a,b) (((uint32)(a)-(uint32)(b))&0x7fffffff)
#define USUB32(a,b) ((uint32)(a)-(uint32)(b))
#define USUB33(a,b) (((uint64)(a)-(uint64)(b))&0x1ffffffffUL)
#define USUB34(a,b) (((uint64)(a)-(uint64)(b))&0x3ffffffffUL)
#define USUB35(a,b) (((uint64)(a)-(uint64)(b))&0x7ffffffffUL)
#define USUB36(a,b) (((uint64)(a)-(uint64)(b))&0xfffffffffUL)
#define USUB37(a,b) (((uint64)(a)-(uint64)(b))&0x1fffffffffUL)
#define USUB38(a,b) (((uint64)(a)-(uint64)(b))&0x3fffffffffUL)
#define USUB39(a,b) (((uint64)(a)-(uint64)(b))&0x7fffffffffUL)
#define USUB40(a,b) (((uint64)(a)-(uint64)(b))&0xffffffffffUL)
#define USUB41(a,b) (((uint64)(a)-(uint64)(b))&0x1ffffffffffUL)
#define USUB42(a,b) (((uint64)(a)-(uint64)(b))&0x3ffffffffffUL)
#define USUB43(a,b) (((uint64)(a)-(uint64)(b))&0x7ffffffffffUL)
#define USUB44(a,b) (((uint64)(a)-(uint64)(b))&0xfffffffffffUL)
#define USUB45(a,b) (((uint64)(a)-(uint64)(b))&0x1fffffffffffUL)
#define USUB46(a,b) (((uint64)(a)-(uint64)(b))&0x3fffffffffffUL)
#define USUB47(a,b) (((uint64)(a)-(uint64)(b))&0x7fffffffffffUL)
#define USUB48(a,b) (((uint64)(a)-(uint64)(b))&0xffffffffffffUL)
#define USUB49(a,b) (((uint64)(a)-(uint64)(b))&0x1ffffffffffffUL)
#define USUB50(a,b) (((uint64)(a)-(uint64)(b))&0x3ffffffffffffUL)
#define USUB51(a,b) (((uint64)(a)-(uint64)(b))&0x7ffffffffffffUL)
#define USUB52(a,b) (((uint64)(a)-(uint64)(b))&0xfffffffffffffUL)
#define USUB53(a,b) (((uint64)(a)-(uint64)(b))&0x1fffffffffffffUL)
#define USUB54(a,b) (((uint64)(a)-(uint64)(b))&0x3fffffffffffffUL)
#define USUB55(a,b) (((uint64)(a)-(uint64)(b))&0x7fffffffffffffUL)
#define USUB56(a,b) (((uint64)(a)-(uint64)(b))&0xffffffffffffffUL)
#define USUB57(a,b) (((uint64)(a)-(uint64)(b))&0x1ffffffffffffffUL)
#define USUB58(a,b) (((uint64)(a)-(uint64)(b))&0x3ffffffffffffffUL)
#define USUB59(a,b) (((uint64)(a)-(uint64)(b))&0x7ffffffffffffffUL)
#define USUB60(a,b) (((uint64)(a)-(uint64)(b))&0xfffffffffffffffUL)
#define USUB61(a,b) (((uint64)(a)-(uint64)(b))&0x1fffffffffffffffUL)
#define USUB62(a,b) (((uint64)(a)-(uint64)(b))&0x3fffffffffffffffUL)
#define USUB63(a,b) (((uint64)(a)-(uint64)(b))&0x7fffffffffffffffUL)
#define USUB64(a,b) ((uint64)(a)-(uint64)(b))

#define IMUL1(a,b) ((((int64)(a)*(int64)(b))<<63)>>63)
#define IMUL2(a,b) ((((int64)(a)*(int64)(b))<<62)>>62)
#define IMUL3(a,b) ((((int64)(a)*(int64)(b))<<61)>>61)
#define IMUL4(a,b) ((((int64)(a)*(int64)(b))<<60)>>60)
#define IMUL5(a,b) ((((int64)(a)*(int64)(b))<<59)>>59)
#define IMUL6(a,b) ((((int64)(a)*(int64)(b))<<58)>>58)
#define IMUL7(a,b) ((((int64)(a)*(int64)(b))<<57)>>57)
#define IMUL8(a,b) ((((int64)(a)*(int64)(b))<<56)>>56)
#define IMUL9(a,b) ((((int64)(a)*(int64)(b))<<55)>>55)
#define IMUL10(a,b) ((((int64)(a)*(int64)(b))<<54)>>54)
#define IMUL11(a,b) ((((int64)(a)*(int64)(b))<<53)>>53)
#define IMUL12(a,b) ((((int64)(a)*(int64)(b))<<52)>>52)
#define IMUL13(a,b) ((((int64)(a)*(int64)(b))<<51)>>51)
#define IMUL14(a,b) ((((int64)(a)*(int64)(b))<<50)>>50)
#define IMUL15(a,b) ((((int64)(a)*(int64)(b))<<49)>>49)
#define IMUL16(a,b) ((((int64)(a)*(int64)(b))<<48)>>48)
#define IMUL17(a,b) ((((int64)(a)*(int64)(b))<<47)>>47)
#define IMUL18(a,b) ((((int64)(a)*(int64)(b))<<46)>>46)
#define IMUL19(a,b) ((((int64)(a)*(int64)(b))<<45)>>45)
#define IMUL20(a,b) ((((int64)(a)*(int64)(b))<<44)>>44)
#define IMUL21(a,b) ((((int64)(a)*(int64)(b))<<43)>>43)
#define IMUL22(a,b) ((((int64)(a)*(int64)(b))<<42)>>42)
#define IMUL23(a,b) ((((int64)(a)*(int64)(b))<<41)>>41)
#define IMUL24(a,b) ((((int64)(a)*(int64)(b))<<40)>>40)
#define IMUL25(a,b) ((((int64)(a)*(int64)(b))<<39)>>39)
#define IMUL26(a,b) ((((int64)(a)*(int64)(b))<<38)>>38)
#define IMUL27(a,b) ((((int64)(a)*(int64)(b))<<37)>>37)
#define IMUL28(a,b) ((((int64)(a)*(int64)(b))<<36)>>36)
#define IMUL29(a,b) ((((int64)(a)*(int64)(b))<<35)>>35)
#define IMUL30(a,b) ((((int64)(a)*(int64)(b))<<34)>>34)
#define IMUL31(a,b) ((((int64)(a)*(int64)(b))<<33)>>33)
#define IMUL32(a,b) ((((int64)(a)*(int64)(b))<<32)>>32)
#define IMUL33(a,b) ((((int64)(a)*(int64)(b))<<31)>>31)
#define IMUL34(a,b) ((((int64)(a)*(int64)(b))<<30)>>30)
#define IMUL35(a,b) ((((int64)(a)*(int64)(b))<<29)>>29)
#define IMUL36(a,b) ((((int64)(a)*(int64)(b))<<28)>>28)
#define IMUL37(a,b) ((((int64)(a)*(int64)(b))<<27)>>27)
#define IMUL38(a,b) ((((int64)(a)*(int64)(b))<<26)>>26)
#define IMUL39(a,b) ((((int64)(a)*(int64)(b))<<25)>>25)
#define IMUL40(a,b) ((((int64)(a)*(int64)(b))<<24)>>24)
#define IMUL41(a,b) ((((int64)(a)*(int64)(b))<<23)>>23)
#define IMUL42(a,b) ((((int64)(a)*(int64)(b))<<22)>>22)
#define IMUL43(a,b) ((((int64)(a)*(int64)(b))<<21)>>21)
#define IMUL44(a,b) ((((int64)(a)*(int64)(b))<<20)>>20)
#define IMUL45(a,b) ((((int64)(a)*(int64)(b))<<19)>>19)
#define IMUL46(a,b) ((((int64)(a)*(int64)(b))<<18)>>18)
#define IMUL47(a,b) ((((int64)(a)*(int64)(b))<<17)>>17)
#define IMUL48(a,b) ((((int64)(a)*(int64)(b))<<16)>>16)
#define IMUL49(a,b) ((((int64)(a)*(int64)(b))<<15)>>15)
#define IMUL50(a,b) ((((int64)(a)*(int64)(b))<<14)>>14)
#define IMUL51(a,b) ((((int64)(a)*(int64)(b))<<13)>>13)
#define IMUL52(a,b) ((((int64)(a)*(int64)(b))<<12)>>12)
#define IMUL53(a,b) ((((int64)(a)*(int64)(b))<<11)>>11)
#define IMUL54(a,b) ((((int64)(a)*(int64)(b))<<10)>>10)
#define IMUL55(a,b) ((((int64)(a)*(int64)(b))<<9)>>9)
#define IMUL56(a,b) ((((int64)(a)*(int64)(b))<<8)>>8)
#define IMUL57(a,b) ((((int64)(a)*(int64)(b))<<7)>>7)
#define IMUL58(a,b) ((((int64)(a)*(int64)(b))<<6)>>6)
#define IMUL59(a,b) ((((int64)(a)*(int64)(b))<<5)>>5)
#define IMUL60(a,b) ((((int64)(a)*(int64)(b))<<4)>>4)
#define IMUL61(a,b) ((((int64)(a)*(int64)(b))<<3)>>3)
#define IMUL62(a,b) ((((int64)(a)*(int64)(b))<<2)>>2)
#define IMUL63(a,b) ((((int64)(a)*(int64)(b))<<1)>>1)
#define IMUL64(a,b) ((int64)(a)*(int64)(b))

#define UMUL1(a,b) (((uint8)(a)*(uint8)(b))&0x1)
#define UMUL2(a,b) (((uint8)(a)*(uint8)(b))&0x3)
#define UMUL3(a,b) (((uint8)(a)*(uint8)(b))&0x7)
#define UMUL4(a,b) (((uint8)(a)*(uint8)(b))&0xf)
#define UMUL5(a,b) (((uint8)(a)*(uint8)(b))&0x1f)
#define UMUL6(a,b) (((uint8)(a)*(uint8)(b))&0x3f)
#define UMUL7(a,b) (((uint8)(a)*(uint8)(b))&0x7f)
#define UMUL8(a,b) ((uint8)(a)*(uint8)(b))
#define UMUL9(a,b) (((uint16)(a)*(uint16)(b))&0x1ff)
#define UMUL10(a,b) (((uint16)(a)*(uint16)(b))&0x3ff)
#define UMUL11(a,b) (((uint16)(a)*(uint16)(b))&0x7ff)
#define UMUL12(a,b) (((uint16)(a)*(uint16)(b))&0xfff)
#define UMUL13(a,b) (((uint16)(a)*(uint16)(b))&0x1fff)
#define UMUL14(a,b) (((uint16)(a)*(uint16)(b))&0x3fff)
#define UMUL15(a,b) (((uint16)(a)*(uint16)(b))&0x7fff)
#define UMUL16(a,b) ((uint16)(a)*(uint16)(b))
#define UMUL17(a,b) (((uint32)(a)*(uint32)(b))&0x1ffff)
#define UMUL18(a,b) (((uint32)(a)*(uint32)(b))&0x3ffff)
#define UMUL19(a,b) (((uint32)(a)*(uint32)(b))&0x7ffff)
#define UMUL20(a,b) (((uint32)(a)*(uint32)(b))&0xfffff)
#define UMUL21(a,b) (((uint32)(a)*(uint32)(b))&0x1fffff)
#define UMUL22(a,b) (((uint32)(a)*(uint32)(b))&0x3fffff)
#define UMUL23(a,b) (((uint32)(a)*(uint32)(b))&0x7fffff)
#define UMUL24(a,b) (((uint32)(a)*(uint32)(b))&0xffffff)
#define UMUL25(a,b) (((uint32)(a)*(uint32)(b))&0x1ffffff)
#define UMUL26(a,b) (((uint32)(a)*(uint32)(b))&0x3ffffff)
#define UMUL27(a,b) (((uint32)(a)*(uint32)(b))&0x7ffffff)
#define UMUL28(a,b) (((uint32)(a)*(uint32)(b))&0xfffffff)
#define UMUL29(a,b) (((uint32)(a)*(uint32)(b))&0x1fffffff)
#define UMUL30(a,b) (((uint32)(a)*(uint32)(b))&0x3fffffff)
#define UMUL31(a,b) (((uint32)(a)*(uint32)(b))&0x7fffffff)
#define UMUL32(a,b) ((uint32)(a)*(uint32)(b))
#define UMUL33(a,b) (((uint64)(a)*(uint64)(b))&0x1ffffffffUL)
#define UMUL34(a,b) (((uint64)(a)*(uint64)(b))&0x3ffffffffUL)
#define UMUL35(a,b) (((uint64)(a)*(uint64)(b))&0x7ffffffffUL)
#define UMUL36(a,b) (((uint64)(a)*(uint64)(b))&0xfffffffffUL)
#define UMUL37(a,b) (((uint64)(a)*(uint64)(b))&0x1fffffffffUL)
#define UMUL38(a,b) (((uint64)(a)*(uint64)(b))&0x3fffffffffUL)
#define UMUL39(a,b) (((uint64)(a)*(uint64)(b))&0x7fffffffffUL)
#define UMUL40(a,b) (((uint64)(a)*(uint64)(b))&0xffffffffffUL)
#define UMUL41(a,b) (((uint64)(a)*(uint64)(b))&0x1ffffffffffUL)
#define UMUL42(a,b) (((uint64)(a)*(uint64)(b))&0x3ffffffffffUL)
#define UMUL43(a,b) (((uint64)(a)*(uint64)(b))&0x7ffffffffffUL)
#define UMUL44(a,b) (((uint64)(a)*(uint64)(b))&0xfffffffffffUL)
#define UMUL45(a,b) (((uint64)(a)*(uint64)(b))&0x1fffffffffffUL)
#define UMUL46(a,b) (((uint64)(a)*(uint64)(b))&0x3fffffffffffUL)
#define UMUL47(a,b) (((uint64)(a)*(uint64)(b))&0x7fffffffffffUL)
#define UMUL48(a,b) (((uint64)(a)*(uint64)(b))&0xffffffffffffUL)
#define UMUL49(a,b) (((uint64)(a)*(uint64)(b))&0x1ffffffffffffUL)
#define UMUL50(a,b) (((uint64)(a)*(uint64)(b))&0x3ffffffffffffUL)
#define UMUL51(a,b) (((uint64)(a)*(uint64)(b))&0x7ffffffffffffUL)
#define UMUL52(a,b) (((uint64)(a)*(uint64)(b))&0xfffffffffffffUL)
#define UMUL53(a,b) (((uint64)(a)*(uint64)(b))&0x1fffffffffffffUL)
#define UMUL54(a,b) (((uint64)(a)*(uint64)(b))&0x3fffffffffffffUL)
#define UMUL55(a,b) (((uint64)(a)*(uint64)(b))&0x7fffffffffffffUL)
#define UMUL56(a,b) (((uint64)(a)*(uint64)(b))&0xffffffffffffffUL)
#define UMUL57(a,b) (((uint64)(a)*(uint64)(b))&0x1ffffffffffffffUL)
#define UMUL58(a,b) (((uint64)(a)*(uint64)(b))&0x3ffffffffffffffUL)
#define UMUL59(a,b) (((uint64)(a)*(uint64)(b))&0x7ffffffffffffffUL)
#define UMUL60(a,b) (((uint64)(a)*(uint64)(b))&0xfffffffffffffffUL)
#define UMUL61(a,b) (((uint64)(a)*(uint64)(b))&0x1fffffffffffffffUL)
#define UMUL62(a,b) (((uint64)(a)*(uint64)(b))&0x3fffffffffffffffUL)
#define UMUL63(a,b) (((uint64)(a)*(uint64)(b))&0x7fffffffffffffffUL)
#define UMUL64(a,b) ((uint64)(a)*(uint64)(b))

#define IDIV1(a,b) ((((int64)(a)/(int64)(b))<<63)>>63)
#define IDIV2(a,b) ((((int64)(a)/(int64)(b))<<62)>>62)
#define IDIV3(a,b) ((((int64)(a)/(int64)(b))<<61)>>61)
#define IDIV4(a,b) ((((int64)(a)/(int64)(b))<<60)>>60)
#define IDIV5(a,b) ((((int64)(a)/(int64)(b))<<59)>>59)
#define IDIV6(a,b) ((((int64)(a)/(int64)(b))<<58)>>58)
#define IDIV7(a,b) ((((int64)(a)/(int64)(b))<<57)>>57)
#define IDIV8(a,b) ((((int64)(a)/(int64)(b))<<56)>>56)
#define IDIV9(a,b) ((((int64)(a)/(int64)(b))<<55)>>55)
#define IDIV10(a,b) ((((int64)(a)/(int64)(b))<<54)>>54)
#define IDIV11(a,b) ((((int64)(a)/(int64)(b))<<53)>>53)
#define IDIV12(a,b) ((((int64)(a)/(int64)(b))<<52)>>52)
#define IDIV13(a,b) ((((int64)(a)/(int64)(b))<<51)>>51)
#define IDIV14(a,b) ((((int64)(a)/(int64)(b))<<50)>>50)
#define IDIV15(a,b) ((((int64)(a)/(int64)(b))<<49)>>49)
#define IDIV16(a,b) ((((int64)(a)/(int64)(b))<<48)>>48)
#define IDIV17(a,b) ((((int64)(a)/(int64)(b))<<47)>>47)
#define IDIV18(a,b) ((((int64)(a)/(int64)(b))<<46)>>46)
#define IDIV19(a,b) ((((int64)(a)/(int64)(b))<<45)>>45)
#define IDIV20(a,b) ((((int64)(a)/(int64)(b))<<44)>>44)
#define IDIV21(a,b) ((((int64)(a)/(int64)(b))<<43)>>43)
#define IDIV22(a,b) ((((int64)(a)/(int64)(b))<<42)>>42)
#define IDIV23(a,b) ((((int64)(a)/(int64)(b))<<41)>>41)
#define IDIV24(a,b) ((((int64)(a)/(int64)(b))<<40)>>40)
#define IDIV25(a,b) ((((int64)(a)/(int64)(b))<<39)>>39)
#define IDIV26(a,b) ((((int64)(a)/(int64)(b))<<38)>>38)
#define IDIV27(a,b) ((((int64)(a)/(int64)(b))<<37)>>37)
#define IDIV28(a,b) ((((int64)(a)/(int64)(b))<<36)>>36)
#define IDIV29(a,b) ((((int64)(a)/(int64)(b))<<35)>>35)
#define IDIV30(a,b) ((((int64)(a)/(int64)(b))<<34)>>34)
#define IDIV31(a,b) ((((int64)(a)/(int64)(b))<<33)>>33)
#define IDIV32(a,b) ((((int64)(a)/(int64)(b))<<32)>>32)
#define IDIV33(a,b) ((((int64)(a)/(int64)(b))<<31)>>31)
#define IDIV34(a,b) ((((int64)(a)/(int64)(b))<<30)>>30)
#define IDIV35(a,b) ((((int64)(a)/(int64)(b))<<29)>>29)
#define IDIV36(a,b) ((((int64)(a)/(int64)(b))<<28)>>28)
#define IDIV37(a,b) ((((int64)(a)/(int64)(b))<<27)>>27)
#define IDIV38(a,b) ((((int64)(a)/(int64)(b))<<26)>>26)
#define IDIV39(a,b) ((((int64)(a)/(int64)(b))<<25)>>25)
#define IDIV40(a,b) ((((int64)(a)/(int64)(b))<<24)>>24)
#define IDIV41(a,b) ((((int64)(a)/(int64)(b))<<23)>>23)
#define IDIV42(a,b) ((((int64)(a)/(int64)(b))<<22)>>22)
#define IDIV43(a,b) ((((int64)(a)/(int64)(b))<<21)>>21)
#define IDIV44(a,b) ((((int64)(a)/(int64)(b))<<20)>>20)
#define IDIV45(a,b) ((((int64)(a)/(int64)(b))<<19)>>19)
#define IDIV46(a,b) ((((int64)(a)/(int64)(b))<<18)>>18)
#define IDIV47(a,b) ((((int64)(a)/(int64)(b))<<17)>>17)
#define IDIV48(a,b) ((((int64)(a)/(int64)(b))<<16)>>16)
#define IDIV49(a,b) ((((int64)(a)/(int64)(b))<<15)>>15)
#define IDIV50(a,b) ((((int64)(a)/(int64)(b))<<14)>>14)
#define IDIV51(a,b) ((((int64)(a)/(int64)(b))<<13)>>13)
#define IDIV52(a,b) ((((int64)(a)/(int64)(b))<<12)>>12)
#define IDIV53(a,b) ((((int64)(a)/(int64)(b))<<11)>>11)
#define IDIV54(a,b) ((((int64)(a)/(int64)(b))<<10)>>10)
#define IDIV55(a,b) ((((int64)(a)/(int64)(b))<<9)>>9)
#define IDIV56(a,b) ((((int64)(a)/(int64)(b))<<8)>>8)
#define IDIV57(a,b) ((((int64)(a)/(int64)(b))<<7)>>7)
#define IDIV58(a,b) ((((int64)(a)/(int64)(b))<<6)>>6)
#define IDIV59(a,b) ((((int64)(a)/(int64)(b))<<5)>>5)
#define IDIV60(a,b) ((((int64)(a)/(int64)(b))<<4)>>4)
#define IDIV61(a,b) ((((int64)(a)/(int64)(b))<<3)>>3)
#define IDIV62(a,b) ((((int64)(a)/(int64)(b))<<2)>>2)
#define IDIV63(a,b) ((((int64)(a)/(int64)(b))<<1)>>1)
#define IDIV64(a,b) ((int64)(a)/(int64)(b))

#define UDIV1(a,b) (((uint8)(a)/(uint8)(b))&0x1)
#define UDIV2(a,b) (((uint8)(a)/(uint8)(b))&0x3)
#define UDIV3(a,b) (((uint8)(a)/(uint8)(b))&0x7)
#define UDIV4(a,b) (((uint8)(a)/(uint8)(b))&0xf)
#define UDIV5(a,b) (((uint8)(a)/(uint8)(b))&0x1f)
#define UDIV6(a,b) (((uint8)(a)/(uint8)(b))&0x3f)
#define UDIV7(a,b) (((uint8)(a)/(uint8)(b))&0x7f)
#define UDIV8(a,b) ((uint8)(a)/(uint8)(b))
#define UDIV9(a,b) (((uint16)(a)/(uint16)(b))&0x1ff)
#define UDIV10(a,b) (((uint16)(a)/(uint16)(b))&0x3ff)
#define UDIV11(a,b) (((uint16)(a)/(uint16)(b))&0x7ff)
#define UDIV12(a,b) (((uint16)(a)/(uint16)(b))&0xfff)
#define UDIV13(a,b) (((uint16)(a)/(uint16)(b))&0x1fff)
#define UDIV14(a,b) (((uint16)(a)/(uint16)(b))&0x3fff)
#define UDIV15(a,b) (((uint16)(a)/(uint16)(b))&0x7fff)
#define UDIV16(a,b) ((uint16)(a)/(uint16)(b))
#define UDIV17(a,b) (((uint32)(a)/(uint32)(b))&0x1ffff)
#define UDIV18(a,b) (((uint32)(a)/(uint32)(b))&0x3ffff)
#define UDIV19(a,b) (((uint32)(a)/(uint32)(b))&0x7ffff)
#define UDIV20(a,b) (((uint32)(a)/(uint32)(b))&0xfffff)
#define UDIV21(a,b) (((uint32)(a)/(uint32)(b))&0x1fffff)
#define UDIV22(a,b) (((uint32)(a)/(uint32)(b))&0x3fffff)
#define UDIV23(a,b) (((uint32)(a)/(uint32)(b))&0x7fffff)
#define UDIV24(a,b) (((uint32)(a)/(uint32)(b))&0xffffff)
#define UDIV25(a,b) (((uint32)(a)/(uint32)(b))&0x1ffffff)
#define UDIV26(a,b) (((uint32)(a)/(uint32)(b))&0x3ffffff)
#define UDIV27(a,b) (((uint32)(a)/(uint32)(b))&0x7ffffff)
#define UDIV28(a,b) (((uint32)(a)/(uint32)(b))&0xfffffff)
#define UDIV29(a,b) (((uint32)(a)/(uint32)(b))&0x1fffffff)
#define UDIV30(a,b) (((uint32)(a)/(uint32)(b))&0x3fffffff)
#define UDIV31(a,b) (((uint32)(a)/(uint32)(b))&0x7fffffff)
#define UDIV32(a,b) ((uint32)(a)/(uint32)(b))
#define UDIV33(a,b) (((uint64)(a)/(uint64)(b))&0x1ffffffffUL)
#define UDIV34(a,b) (((uint64)(a)/(uint64)(b))&0x3ffffffffUL)
#define UDIV35(a,b) (((uint64)(a)/(uint64)(b))&0x7ffffffffUL)
#define UDIV36(a,b) (((uint64)(a)/(uint64)(b))&0xfffffffffUL)
#define UDIV37(a,b) (((uint64)(a)/(uint64)(b))&0x1fffffffffUL)
#define UDIV38(a,b) (((uint64)(a)/(uint64)(b))&0x3fffffffffUL)
#define UDIV39(a,b) (((uint64)(a)/(uint64)(b))&0x7fffffffffUL)
#define UDIV40(a,b) (((uint64)(a)/(uint64)(b))&0xffffffffffUL)
#define UDIV41(a,b) (((uint64)(a)/(uint64)(b))&0x1ffffffffffUL)
#define UDIV42(a,b) (((uint64)(a)/(uint64)(b))&0x3ffffffffffUL)
#define UDIV43(a,b) (((uint64)(a)/(uint64)(b))&0x7ffffffffffUL)
#define UDIV44(a,b) (((uint64)(a)/(uint64)(b))&0xfffffffffffUL)
#define UDIV45(a,b) (((uint64)(a)/(uint64)(b))&0x1fffffffffffUL)
#define UDIV46(a,b) (((uint64)(a)/(uint64)(b))&0x3fffffffffffUL)
#define UDIV47(a,b) (((uint64)(a)/(uint64)(b))&0x7fffffffffffUL)
#define UDIV48(a,b) (((uint64)(a)/(uint64)(b))&0xffffffffffffUL)
#define UDIV49(a,b) (((uint64)(a)/(uint64)(b))&0x1ffffffffffffUL)
#define UDIV50(a,b) (((uint64)(a)/(uint64)(b))&0x3ffffffffffffUL)
#define UDIV51(a,b) (((uint64)(a)/(uint64)(b))&0x7ffffffffffffUL)
#define UDIV52(a,b) (((uint64)(a)/(uint64)(b))&0xfffffffffffffUL)
#define UDIV53(a,b) (((uint64)(a)/(uint64)(b))&0x1fffffffffffffUL)
#define UDIV54(a,b) (((uint64)(a)/(uint64)(b))&0x3fffffffffffffUL)
#define UDIV55(a,b) (((uint64)(a)/(uint64)(b))&0x7fffffffffffffUL)
#define UDIV56(a,b) (((uint64)(a)/(uint64)(b))&0xffffffffffffffUL)
#define UDIV57(a,b) (((uint64)(a)/(uint64)(b))&0x1ffffffffffffffUL)
#define UDIV58(a,b) (((uint64)(a)/(uint64)(b))&0x3ffffffffffffffUL)
#define UDIV59(a,b) (((uint64)(a)/(uint64)(b))&0x7ffffffffffffffUL)
#define UDIV60(a,b) (((uint64)(a)/(uint64)(b))&0xfffffffffffffffUL)
#define UDIV61(a,b) (((uint64)(a)/(uint64)(b))&0x1fffffffffffffffUL)
#define UDIV62(a,b) (((uint64)(a)/(uint64)(b))&0x3fffffffffffffffUL)
#define UDIV63(a,b) (((uint64)(a)/(uint64)(b))&0x7fffffffffffffffUL)
#define UDIV64(a,b) ((uint64)(a)/(uint64)(b))

#define FXCONST64(a,DW) ((uint64)((a)<<DW))
#define FXCONST64FL(f,DW) ((uint64)((f)*(1<<DW)))
#define FXADD64(a,b,DW) ((uint64)((a)+(b)))
#define FXSUB64(a,b,DW) ((uint64)((a)-(b)))
#define FX2REAL64(a,DW) ((double)(a)/(double)(1<<DW) - ((((a)&0x8000000000000000UL)==0) ? 0 : (double)(1<<(64-DW))))

#define FXCONST32(a,DW) ((uint32)((a)<<DW))
#define FXCONST32FL(f,DW) ((uint32)((f)*(1<<DW)))
#define FXADD32(a,b,DW) ((uint32)((a)+(b)))
#define FXSUB32(a,b,DW) ((uint32)((a)-(b)))
#define FXMUL32(a,b,DW) ((uint32)(((((uint64)((int32)(a))*(uint64)((int32)(b)))+((uint64)1<<((DW)-1)))>>DW)))
#define FXDIV32(a,b,DW) ((uint32)((((((uint64)((int32)(a)))<<((DW)+1))/((uint64)((int32)(b)))+(uint64)1)>>1)))
#define FX2REAL32(a,DW) ((float)(a)/(float)(1<<DW) - ((((a)&0x80000000)==0) ? 0 : (float)(1<<(32-DW))))

#define FXCONST16(a,DW) ((uint16)((a)<<DW))
#define FXCONST16FL(f,DW) ((uint16)((f)*(1<<DW)))
#define FXADD16(a,b,DW) ((uint16)((a)+(b)))
#define FXSUB16(a,b,DW) ((uint16)((a)-(b)))
#define FXMUL16(a,b,DW) ((uint16)(((((uint32)((int16)(a))*(uint32)((int16)(b)))+((uint32)1<<((DW)-1)))>>DW)))
#define FXDIV16(a,b,DW) ((uint16)((((((uint32)((int16)(a)))<<((DW)+1))/((uint32)((int16)(b)))+(uint32)1)>>1)))

#define FXCONST8(a,DW) ((uint8)((a)<<DW))
#define FXCONST8FL(f,DW) ((uint8)((f)*(1<<DW)))
#define FXADD8(a,b,DW) ((uint8)((a)+(b)))
#define FXSUB8(a,b,DW) ((uint8)((a)-(b)))
#define FXMUL8(a,b,DW) ((uint8)(((((uint16)((int8)(a))*(uint16)((int8)(b)))+((uint16)1<<((DW)-1)))>>DW)))
#define FXDIV8(a,b,DW) ((uint8)((((((uint16)((int8)(a)))<<((DW)+1))/((uint16)((int8)(b)))+(uint16)1)>>1)))

#endif  // CO_MATH_H

