/*******************************************************************************
 DO NOT EDIT
 This file was automatically generated by the Impulse C Compiler.

 Impulse C is Copyright 2002-2005, Impulse Accelerated Technologies, Inc.

 Stage Master is Copyright 2002-2005, Green Mountain Computing Systems, Inc.

 All rights reserved.
********************************************************************************/

#include "co.h"

/* Architecture Includes */
#include <fcntl.h>
#include "einlib.h"

#define IMPULSE_BASE 0x7800000
#define IMPULSE_CONNECTION_SIZE (sizeof(uint64) * 4)

int _co_fpga_id, _num_bytes, _fpga_status;
const char * _fpga_bitfile = "top.bin.ufp";
err_e _cray_err;



/* Run Procedures */
extern void Producer(co_stream, co_stream, co_stream, co_stream, co_stream, co_stream, co_stream, co_stream, co_parameter);
extern void PWM(co_stream, co_stream, co_stream, co_stream, co_stream, co_parameter);
extern void Filter(co_stream, co_stream, co_stream, co_stream, co_stream, co_parameter);
extern void Consumer(co_stream, co_stream, co_stream, co_stream);

co_architecture co_initialize(void *arg)

{
  co_stream threshold_0;
  co_stream threshold_1;
  co_stream pwm_0;
  co_stream pwm_1;
  co_stream iteration_0;
  co_stream iteration_1;
  co_stream dna_0;
  co_stream dna_1;
  co_stream counter_0;
  co_stream sum_0;
  co_stream counter_1;
  co_stream sum_1;
  co_stream start_0;
  co_stream score_0;
  co_stream start_1;
  co_stream score_1;

  threshold_0=co_stream_create("threshold_0",UINT_TYPE(32),1);
  threshold_1=co_stream_create("threshold_1",UINT_TYPE(32),1);
  pwm_0=co_stream_create("pwm_0",UINT_TYPE(32),32);
  pwm_1=co_stream_create("pwm_1",UINT_TYPE(32),32);
  iteration_0=co_stream_create("iteration_0",INT_TYPE(16),1);
  iteration_1=co_stream_create("iteration_1",INT_TYPE(16),1);
  dna_0=co_stream_create("dna_0",INT_TYPE(8),300);
  dna_1=co_stream_create("dna_1",INT_TYPE(8),300);
  counter_0=co_stream_create("counter_0",INT_TYPE(16),300);
  sum_0=co_stream_create("sum_0",UINT_TYPE(32),300);
  counter_1=co_stream_create("counter_1",INT_TYPE(16),300);
  sum_1=co_stream_create("sum_1",UINT_TYPE(32),300);
  start_0=co_stream_create("start_0",INT_TYPE(16),30);
  score_0=co_stream_create("score_0",UINT_TYPE(32),30);
  start_1=co_stream_create("start_1",INT_TYPE(16),30);
  score_1=co_stream_create("score_1",UINT_TYPE(32),30);
  co_process_create("Producer",(co_function)Producer,
                    9,
                    threshold_0,
                    threshold_1,
                    pwm_0,
                    pwm_1,
                    iteration_0,
                    iteration_1,
                    dna_0,
                    dna_1,
                    arg);
  co_process_create("Consumer",(co_function)Consumer,
                    4,
                    start_0,
                    score_0,
                    start_1,
                    score_1);

  /* Architecture Initialization */
  /* Open the FPGA device */
  _co_fpga_id = fpga_open("/dev/ufp0", O_RDWR|O_SYNC, &_cray_err);
  if ( _cray_err != NOERR ) {
    printf("Failed to open FPGA device.\n");
    return NULL;
  }

  /* Load the bitfile into the FPGA. */
  _num_bytes = fpga_load(_co_fpga_id, _fpga_bitfile, &_cray_err);
  if ( _cray_err != NOERR ) {
    printf("Failed to load FPGA bitfile.\n");
    return NULL;
  }

  /* Start execution of the FPGA logic. */
  _fpga_status = fpga_start(_co_fpga_id, &_cray_err);
  if ( _fpga_status != 0 ) {
	  printf("Failed to execute FPGA logic.\n");
    return NULL;
  }
  co_stream_attach(threshold_0, (void *)IMPULSE_BASE + IMPULSE_CONNECTION_SIZE*0, HW_INPUT);
  co_stream_attach(threshold_1, (void *)IMPULSE_BASE + IMPULSE_CONNECTION_SIZE*1, HW_INPUT);
  co_stream_attach(pwm_0, (void *)IMPULSE_BASE + IMPULSE_CONNECTION_SIZE*2, HW_INPUT);
  co_stream_attach(pwm_1, (void *)IMPULSE_BASE + IMPULSE_CONNECTION_SIZE*3, HW_INPUT);
  co_stream_attach(iteration_0, (void *)IMPULSE_BASE + IMPULSE_CONNECTION_SIZE*4, HW_INPUT);
  co_stream_attach(iteration_1, (void *)IMPULSE_BASE + IMPULSE_CONNECTION_SIZE*5, HW_INPUT);
  co_stream_attach(dna_0, (void *)IMPULSE_BASE + IMPULSE_CONNECTION_SIZE*6, HW_INPUT);
  co_stream_attach(dna_1, (void *)IMPULSE_BASE + IMPULSE_CONNECTION_SIZE*7, HW_INPUT);
  co_stream_attach(start_0, (void *)IMPULSE_BASE + IMPULSE_CONNECTION_SIZE*8, HW_OUTPUT);
  co_stream_attach(score_0, (void *)IMPULSE_BASE + IMPULSE_CONNECTION_SIZE*9, HW_OUTPUT);
  co_stream_attach(start_1, (void *)IMPULSE_BASE + IMPULSE_CONNECTION_SIZE*10, HW_OUTPUT);
  co_stream_attach(score_1, (void *)IMPULSE_BASE + IMPULSE_CONNECTION_SIZE*11, HW_OUTPUT);

  return(NULL);

}
