-- ****************************************
-- DO NOT EDIT
-- This file was automatically generated by the Impulse C Compiler.
-- 
-- Impulse C is Copyright 2002-2005, Impulse Accelerated Technologies, Inc.
-- 
-- Stage Master is Copyright 2002-2005, Green Mountain Computing Systems, Inc.
-- 
-- All rights reserved.
-- 
-- ****************************************


-- TARGET: VHDL
  
library ieee;
use ieee.std_logic_1164.all;

package external_components is
end package;
library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity PWM_pwm_RAM is
  port (
    rst,clk : in std_ulogic;
    we : in std_ulogic;
    addr : in std_ulogic_vector(4 downto 0);
    addr2 : in std_ulogic_vector(4 downto 0);
    din : in std_ulogic_vector(31 downto 0);
    dout : out std_ulogic_vector(31 downto 0);
    dout2 : out std_ulogic_vector(31 downto 0)
  );
end PWM_pwm_RAM;

architecture dualsync of PWM_pwm_RAM is
  type memtype is array (0 to 31) of
    std_ulogic_vector(31 downto 0);
  signal mem : memtype;
  signal raddr: unsigned(4 downto 0);
  signal raddr2: unsigned(4 downto 0);
begin
  writemem: process (clk)
  begin
    if (clk'event and clk='1') then
      if (we = '1') then
        mem(conv_integer(unsigned(addr))) <= din;
      end if;
      raddr <= unsigned(addr);
      raddr2 <= unsigned(addr2);
    end if;
  end process;

  dout <= mem(conv_integer(raddr));
  dout2 <= mem(conv_integer(raddr2));
end dualsync;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;

entity PWM_sequence_RAM is
  port (
    rst,clk : in std_ulogic;
    we : in std_ulogic;
    addr : in std_ulogic_vector(8 downto 0);
    addr2 : in std_ulogic_vector(8 downto 0);
    din : in std_ulogic_vector(7 downto 0);
    dout : out std_ulogic_vector(7 downto 0);
    dout2 : out std_ulogic_vector(7 downto 0)
  );
end PWM_sequence_RAM;

architecture dualsync of PWM_sequence_RAM is
  type memtype is array (0 to 299) of
    std_ulogic_vector(7 downto 0);
  signal mem : memtype;
  signal raddr: unsigned(8 downto 0);
  signal raddr2: unsigned(8 downto 0);
begin
  writemem: process (clk)
  begin
    if (clk'event and clk='1') then
      if (we = '1') then
        mem(conv_integer(unsigned(addr))) <= din;
      end if;
      raddr <= unsigned(addr);
      raddr2 <= unsigned(addr2);
    end if;
  end process;

  dout <= mem(conv_integer(raddr));
  dout2 <= mem(conv_integer(raddr2));
end dualsync;

library ieee;
use ieee.std_logic_1164.all;

library impulse;
use impulse.components.all;
  
entity PWM is
  port (signal reset : in std_ulogic;
    signal sclk : in std_ulogic;
    signal clk : in std_ulogic;
    signal p_pwm_stream_rdy : in std_ulogic;
    signal p_pwm_stream_en : inout std_ulogic;
    signal p_pwm_stream_eos : in std_ulogic;
    signal p_pwm_stream_data : in std_ulogic_vector (31 downto 0);
    signal p_iteration_stream_rdy : in std_ulogic;
    signal p_iteration_stream_en : inout std_ulogic;
    signal p_iteration_stream_eos : in std_ulogic;
    signal p_iteration_stream_data : in std_ulogic_vector (15 downto 0);
    signal p_dna_stream_rdy : in std_ulogic;
    signal p_dna_stream_en : inout std_ulogic;
    signal p_dna_stream_eos : in std_ulogic;
    signal p_dna_stream_data : in std_ulogic_vector (7 downto 0);
    signal p_counter_stream_rdy : in std_ulogic;
    signal p_counter_stream_en : inout std_ulogic;
    signal p_counter_stream_eos : out std_ulogic;
    signal p_counter_stream_data : out std_ulogic_vector (15 downto 0);
    signal p_sum_stream_rdy : in std_ulogic;
    signal p_sum_stream_en : inout std_ulogic;
    signal p_sum_stream_eos : out std_ulogic;
    signal p_sum_stream_data : out std_ulogic_vector (31 downto 0));
end PWM;

use work.external_components.all;
architecture rtl of PWM is
  function mkvec(b : in std_ulogic) return std_ulogic_vector is
    variable res : std_ulogic_vector(0 downto 0);
  begin
    res(0):=b;
    return(res);
  end;

  component PWM_pwm_RAM is
    port (signal rst : in std_ulogic;
      signal clk : in std_ulogic;
      signal we : in std_ulogic;
      signal addr : in std_ulogic_vector (4 downto 0);
      signal addr2 : in std_ulogic_vector (4 downto 0);
      signal din : in std_ulogic_vector (31 downto 0);
      signal dout : out std_ulogic_vector (31 downto 0);
      signal dout2 : out std_ulogic_vector (31 downto 0));
  end component;

  component PWM_sequence_RAM is
    port (signal rst : in std_ulogic;
      signal clk : in std_ulogic;
      signal we : in std_ulogic;
      signal addr : in std_ulogic_vector (8 downto 0);
      signal addr2 : in std_ulogic_vector (8 downto 0);
      signal din : in std_ulogic_vector (7 downto 0);
      signal dout : out std_ulogic_vector (7 downto 0);
      signal dout2 : out std_ulogic_vector (7 downto 0));
  end component;

  type stateType is (init, b0s0, b1s0, b1s1, b2s0, b2s1, b2s2, b3s0, b4s0, b4s1, b5s0, b6s0, b6s1, b6s2, b7s0, b8s0, b9s0, b10s0, b11s0, b11s1, b12s0, b13s0, b14s0, b15s0, b16s0, finished);
  type pipeStateType is (idle, init, run, flush);
  type t_b10_0 is record
     predicates : std_ulogic_vector (7 downto 0);
     f_r_e_g_1 : std_ulogic_vector (8 downto 0);
     f_r_e_g_2 : std_ulogic_vector (31 downto 0);
  end record;
  type t_b10_1 is record
     predicates : std_ulogic_vector (7 downto 0);
     f_r_e_g_1 : std_ulogic_vector (8 downto 0);
     f_r_e_g_2 : std_ulogic_vector (31 downto 0);
     f_suif_tmp4 : std_ulogic_vector (31 downto 0);
     f_r_e_g_0 : std_ulogic_vector (4 downto 0);
     f_r_e_g_3 : std_ulogic_vector (4 downto 0);
     f_r_e_g_4 : std_ulogic_vector (4 downto 0);
     f_r_e_g_5 : std_ulogic_vector (4 downto 0);
  end record;
  type t_b10_2 is record
     predicates : std_ulogic_vector (7 downto 0);
     f_r_e_g_1 : std_ulogic_vector (8 downto 0);
     f_r_e_g_2 : std_ulogic_vector (31 downto 0);
     f_suif_tmp4 : std_ulogic_vector (31 downto 0);
     f_r_e_g_0 : std_ulogic_vector (4 downto 0);
     f_r_e_g_3 : std_ulogic_vector (4 downto 0);
     f_r_e_g_4 : std_ulogic_vector (4 downto 0);
     f_r_e_g_5 : std_ulogic_vector (4 downto 0);
     f_sum : std_ulogic_vector (31 downto 0);
  end record;
  type t_b10_3 is record
     predicates : std_ulogic_vector (7 downto 0);
     f_sum : std_ulogic_vector (31 downto 0);
  end record;
  signal thisState : stateType;
  signal nextState : stateType;
  signal stateEn : std_ulogic;
  signal newState : std_ulogic;
  signal r_pwm_stream : std_ulogic_vector (31 downto 0);
  signal r_iteration_stream : std_ulogic_vector (15 downto 0);
  signal r_dna_stream : std_ulogic_vector (7 downto 0);
  signal r_i : std_ulogic_vector (31 downto 0);
  signal ni411_i : std_ulogic_vector (31 downto 0);
  signal ni415_i : std_ulogic_vector (31 downto 0);
  signal r_j : std_ulogic_vector (31 downto 0);
  signal ni409_j : std_ulogic_vector (31 downto 0);
  signal ni416_j : std_ulogic_vector (31 downto 0);
  signal r_k : std_ulogic_vector (31 downto 0);
  signal ni419_k : std_ulogic_vector (31 downto 0);
  signal ni422_k : std_ulogic_vector (31 downto 0);
  signal ni448_k : std_ulogic_vector (31 downto 0);
  signal r_l : std_ulogic_vector (31 downto 0);
  signal ni426_l : std_ulogic_vector (31 downto 0);
  signal ni442_l : std_ulogic_vector (31 downto 0);
  signal r_nSamplePwm : std_ulogic_vector (31 downto 0);
  signal ni413_nSamplePwm : std_ulogic_vector (31 downto 0);
  signal r_pwm : std_ulogic_vector (31 downto 0);
  signal ni94_pwm : std_ulogic_vector (31 downto 0);
  signal ni201_pwm : std_ulogic_vector (31 downto 0);
  signal ni212_pwm : std_ulogic_vector (31 downto 0);
  signal ni223_pwm : std_ulogic_vector (31 downto 0);
  signal ni234_pwm : std_ulogic_vector (31 downto 0);
  signal p_pwm_we : std_ulogic;
  signal p_pwm_din : std_ulogic_vector (31 downto 0);
  signal p_pwm_dout : std_ulogic_vector (31 downto 0);
  signal p_pwm_addr : std_ulogic_vector (4 downto 0);
  signal p_pwm_addr2 : std_ulogic_vector (4 downto 0);
  signal p_pwm_dout2 : std_ulogic_vector (31 downto 0);
  signal p_pwm_imm : std_ulogic_vector (31 downto 0);
  signal p_pwm_re : std_ulogic;
  signal r2_pwm : std_ulogic_vector (31 downto 0);
  signal p_pwm_imm2 : std_ulogic_vector (31 downto 0);
  signal p_pwm_re2 : std_ulogic;
  signal r_dnaLength : std_ulogic_vector (15 downto 0);
  signal ni418_dnaLength : std_ulogic_vector (15 downto 0);
  signal r_motifLength : std_ulogic_vector (31 downto 0);
  signal ni408_motifLength : std_ulogic_vector (31 downto 0);
  signal r_nSampleDna : std_ulogic_vector (7 downto 0);
  signal ni421_nSampleDna : std_ulogic_vector (7 downto 0);
  signal ni447_nSampleDna : std_ulogic_vector (7 downto 0);
  signal r_sequence : std_ulogic_vector (7 downto 0);
  signal ni140_sequence : std_ulogic_vector (7 downto 0);
  signal ni173_sequence : std_ulogic_vector (7 downto 0);
  signal ni283_sequence : std_ulogic_vector (7 downto 0);
  signal p_sequence_we : std_ulogic;
  signal p_sequence_din : std_ulogic_vector (7 downto 0);
  signal p_sequence_dout : std_ulogic_vector (7 downto 0);
  signal p_sequence_addr : std_ulogic_vector (8 downto 0);
  signal p_sequence_addr2 : std_ulogic_vector (8 downto 0);
  signal p_sequence_dout2 : std_ulogic_vector (7 downto 0);
  signal p_sequence_imm : std_ulogic_vector (7 downto 0);
  signal p_sequence_re : std_ulogic;
  signal r2_sequence : std_ulogic_vector (7 downto 0);
  signal p_sequence_imm2 : std_ulogic_vector (7 downto 0);
  signal p_sequence_re2 : std_ulogic;
  signal r_counter : std_ulogic_vector (15 downto 0);
  signal ni423_counter : std_ulogic_vector (15 downto 0);
  signal ni449_counter : std_ulogic_vector (15 downto 0);
  signal r_sum : std_ulogic_vector (31 downto 0);
  signal ni424_sum : std_ulogic_vector (31 downto 0);
  signal ni431_sum : std_ulogic_vector (31 downto 0);
  signal ni434_sum : std_ulogic_vector (31 downto 0);
  signal ni437_sum : std_ulogic_vector (31 downto 0);
  signal ni440_sum : std_ulogic_vector (31 downto 0);
  signal ni450_sum : std_ulogic_vector (31 downto 0);
  signal r_nHitStart : std_ulogic_vector (15 downto 0);
  signal ni444_nHitStart : std_ulogic_vector (15 downto 0);
  signal r_nHitScore : std_ulogic_vector (31 downto 0);
  signal ni445_nHitScore : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp : std_ulogic_vector (31 downto 0);
  signal ni417_suif_tmp : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp0 : std_ulogic_vector (31 downto 0);
  signal ni425_suif_tmp0 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp1 : std_ulogic_vector (31 downto 0);
  signal ni451_suif_tmp1 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp2 : std_ulogic_vector (31 downto 0);
  signal ni446_suif_tmp2 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp3 : std_ulogic_vector (31 downto 0);
  signal ni427_suif_tmp3 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp4 : std_ulogic_vector (31 downto 0);
  signal ni443_suif_tmp4 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp5 : std_ulogic_vector (31 downto 0);
  signal ni430_suif_tmp5 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp6 : std_ulogic_vector (31 downto 0);
  signal ni433_suif_tmp6 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp7 : std_ulogic_vector (31 downto 0);
  signal ni436_suif_tmp7 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp8 : std_ulogic_vector (31 downto 0);
  signal ni439_suif_tmp8 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp9 : std_ulogic_vector (31 downto 0);
  signal ni410_suif_tmp9 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp10 : std_ulogic_vector (31 downto 0);
  signal ni412_suif_tmp10 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp11 : std_ulogic_vector (31 downto 0);
  signal ni420_suif_tmp11 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp90 : std_ulogic_vector (31 downto 0);
  signal ni428_suif_tmp90 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp_0 : std_ulogic_vector (31 downto 0);
  signal ni429_suif_tmp_0 : std_ulogic_vector (31 downto 0);
  signal r_r_e_g_0 : std_ulogic_vector (4 downto 0);
  signal ni414_r_e_g_0 : std_ulogic_vector (4 downto 0);
  signal ni432_r_e_g_0 : std_ulogic_vector (4 downto 0);
  signal r_r_e_g_1 : std_ulogic_vector (8 downto 0);
  signal ni175_r_e_g_1 : std_ulogic_vector (8 downto 0);
  signal r_r_e_g_2 : std_ulogic_vector (31 downto 0);
  signal ni404_r_e_g_2 : std_ulogic_vector (31 downto 0);
  signal r_r_e_g_3 : std_ulogic_vector (4 downto 0);
  signal ni435_r_e_g_3 : std_ulogic_vector (4 downto 0);
  signal r_r_e_g_4 : std_ulogic_vector (4 downto 0);
  signal ni438_r_e_g_4 : std_ulogic_vector (4 downto 0);
  signal r_r_e_g_5 : std_ulogic_vector (4 downto 0);
  signal ni441_r_e_g_5 : std_ulogic_vector (4 downto 0);
  signal t_6 : std_ulogic_vector (8 downto 0);
  signal t_5 : std_ulogic_vector (31 downto 0);
  signal t_4 : std_ulogic_vector (31 downto 0);
  signal t_3 : std_ulogic_vector (31 downto 0);
  signal t_2 : std_ulogic_vector (31 downto 0);
  signal t_1 : std_ulogic_vector (31 downto 0);
  signal t_0 : std_ulogic_vector (8 downto 0);
  signal s_b10_state : pipeStateType;
  signal s_b10_0 : t_b10_0;
  signal s_b10_1 : t_b10_1;
  signal s_b10_2 : t_b10_2;
  signal s_b10_3 : t_b10_3;
  signal s_b10_stall : std_ulogic;
  signal s_b10_break : std_ulogic;
  signal s_b10_loop : std_ulogic;
  signal s_b10_flushed : std_ulogic;
  signal s_b10_done : std_ulogic;
  signal s_b10_vstall : std_ulogic_vector (3 downto 0);
  signal s_b10_vbreak : std_ulogic_vector (3 downto 0);
  signal s_b10_stage : std_ulogic_vector (3 downto 0);
  signal s_b10_vwrite : std_ulogic_vector (3 downto 0);
  signal s_b10_vcont : std_ulogic_vector (3 downto 0);
  signal s_b10_delay : std_ulogic_vector (1 downto 0);
  signal s_b10_predicates : std_ulogic_vector (7 downto 0);
begin
  process (clk,reset)
  begin
    if (reset='1') then
     thisState <= init;
    elsif (clk'event and clk='1') then
      if (stateEn = '1') then
        thisState <= nextState;
      end if;
    end if;
  end process;

  stateEn <= 
    '0' when thisState = b2s1 and p_pwm_stream_rdy = '0' else
    '0' when thisState = b4s0 and p_iteration_stream_rdy = '0' else
    '0' when thisState = b6s1 and p_dna_stream_rdy = '0' else
    '0' when thisState = b10s0 and s_b10_done = '0' else
    '0' when thisState = b11s0 and (p_counter_stream_rdy and p_sum_stream_rdy and p_dna_stream_rdy) = '0' else
    '0' when thisState = b15s0 and (p_pwm_stream_eos and p_iteration_stream_eos and p_dna_stream_eos and p_counter_stream_rdy and p_sum_stream_rdy) = '0' else
    '1';

  process (ni451_suif_tmp1,r_suif_tmp2,ni427_suif_tmp3,ni425_suif_tmp0,ni420_suif_tmp11,r_suif_tmp,ni412_suif_tmp10,ni410_suif_tmp9,thisState)
  begin
    case thisState is
    when init =>
      nextState <= b0s0;
    when b0s0 =>
      nextState <= b1s0;
    when b1s0 =>
      if ((not ni410_suif_tmp9(0)) = '1') then
        nextState <= b4s0;
      else
        nextState <= b1s1;
      end if;
    when b1s1 =>
      nextState <= b2s0;
    when b2s0 =>
      if ((not ni412_suif_tmp10(0)) = '1') then
        nextState <= b3s0;
      else
        nextState <= b2s1;
      end if;
    when b2s1 =>
      nextState <= b2s2;
    when b2s2 =>
      nextState <= b2s0;
    when b3s0 =>
      nextState <= b1s0;
    when b4s0 =>
      nextState <= b4s1;
    when b4s1 =>
      if (r_suif_tmp(0) = '1') then
        nextState <= b5s0;
      elsif ((not r_suif_tmp(0)) = '1') then
        nextState <= b5s0;
      else
        nextState <= b4s1;
      end if;
    when b5s0 =>
      nextState <= b6s0;
    when b6s0 =>
      if ((not ni420_suif_tmp11(0)) = '1') then
        nextState <= b7s0;
      else
        nextState <= b6s1;
      end if;
    when b6s1 =>
      nextState <= b6s2;
    when b6s2 =>
      nextState <= b6s0;
    when b7s0 =>
      if (ni425_suif_tmp0(0) = '1') then
        nextState <= b8s0;
      elsif ((not ni425_suif_tmp0(0)) = '1') then
        nextState <= b15s0;
      else
        nextState <= b7s0;
      end if;
    when b8s0 =>
      if (ni427_suif_tmp3(0) = '1') then
        nextState <= b9s0;
      elsif ((not ni427_suif_tmp3(0)) = '1') then
        nextState <= b11s0;
      else
        nextState <= b8s0;
      end if;
    when b9s0 =>
      nextState <= b10s0;
    when b10s0 =>
      nextState <= b11s0;
    when b11s0 =>
      nextState <= b11s1;
    when b11s1 =>
      if (r_suif_tmp2(0) = '1') then
        nextState <= b12s0;
      elsif ((not r_suif_tmp2(0)) = '1') then
        nextState <= b13s0;
      else
        nextState <= b11s1;
      end if;
    when b12s0 =>
      nextState <= b14s0;
    when b13s0 =>
      nextState <= b15s0;
    when b14s0 =>
      if (ni451_suif_tmp1(0) = '1') then
        nextState <= b8s0;
      elsif ((not ni451_suif_tmp1(0)) = '1') then
        nextState <= b15s0;
      else
        nextState <= b14s0;
      end if;
    when b15s0 =>
      nextState <= b0s0;
    when b16s0 =>
      nextState <= finished;
    when finished =>
      nextState <= finished;
    when others =>
      nextState <= init;
    end case;
  end process;

  process (clk,reset)
  begin
    if (reset='1') then
     newState <= '1';
    elsif (clk'event and clk='1') then
      case thisState is
      when b10s0 =>
       newState <= not s_b10_stall;
      when  others =>
       newState <= stateEn;
      end case;
    end if;
  end process;

-- b0s0
  ni408_motifLength <= X"00000008";
  ni409_j <= X"00000000";

-- b1s0
  ni410_suif_tmp9 <= "0000000000000000000000000000000" & cmp_less_s(r_j, X"00000008");

-- b1s1
  ni411_i <= X"00000000";

-- b2s0
  ni412_suif_tmp10 <= "0000000000000000000000000000000" & cmp_less_s(r_i, X"00000004");

-- b2s1
  ni415_i <= add(r_i, X"00000001");
  ni414_r_e_g_0 <= add(shl(r_i(4 downto 0), 3), r_j(4 downto 0));

-- b2s2
  ni413_nSamplePwm <= r_pwm_stream;
  ni94_pwm <= ni413_nSamplePwm;

-- b3s0
  ni416_j <= add(r_j, X"00000001");

-- b4s0
  ni417_suif_tmp <= "0000000000000000000000000000000" & eq("0" & mkvec(p_iteration_stream_eos), "00");

-- b4s1
  ni418_dnaLength <= r_iteration_stream;

-- b5s0
  ni419_k <= X"00000000";

-- b6s0
  ni420_suif_tmp11 <= "0000000000000000000000000000000" & cmp_less_s(r_k, X"00000008");

-- b6s1

-- b6s2
  ni421_nSampleDna <= r_dna_stream;
  ni140_sequence <= ni421_nSampleDna;
  t_0 <= r_k(8 downto 0);
  ni422_k <= add(r_k, X"00000001");

-- b7s0
  ni423_counter <= X"0000";
  ni424_sum <= X"00000000";
  ni425_suif_tmp0 <= "0000000000000000000000000000000" & cmp_less_equal_s(X"00000000", sub(sign_ext(r_dnaLength, 32), X"00000008"));

-- b8s0
  ni426_l <= X"00000000";
  ni427_suif_tmp3 <= "0000000000000000000000000000000" & cmp_less_s(ni426_l, X"00000008");

-- b9s0
  ni428_suif_tmp90 <= sign_ext(r_counter, 32);

  process (clk,reset)
  begin
    if (reset='1') then
     s_b10_state <= idle;
    elsif (clk'event and clk='1') then
      case s_b10_state is
      when idle =>
        if (stateEn = '1' and nextState = b10s0) then
          s_b10_state <= init;
        else
          s_b10_state <= idle;
        end if;
      when init =>
        s_b10_state <= run;
      when run =>
        if ((not s_b10_loop) = '1') then
          s_b10_state <= idle;
        elsif (s_b10_break = '1') then
          s_b10_state <= flush;
        else
          s_b10_state <= run;
        end if;
      when flush =>
        if (s_b10_flushed = '1') then
          s_b10_state <= idle;
        else
          s_b10_state <= flush;
        end if;
      when others => null;
      end case;
    end if;
  end process;

-- b10 stage 0
  s_b10_vstall(0) <= '0';
  ni175_r_e_g_1 <= add(r_l(8 downto 0), r_suif_tmp90(8 downto 0));
  ni404_r_e_g_2 <= add(r_l, X"00000001");
  s_b10_vbreak(0) <= '0';
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (s_b10_vwrite(0) = '1') then
        s_b10_0.f_r_e_g_2 <= ni404_r_e_g_2;
        s_b10_0.f_r_e_g_1 <= ni175_r_e_g_1;
        s_b10_0.predicates(0) <= '0';
        s_b10_0.predicates(1) <= '0';
        s_b10_0.predicates(2) <= '0';
        s_b10_0.predicates(3) <= '0';
        s_b10_0.predicates(4) <= '0';
        s_b10_0.predicates(5) <= '0';
        s_b10_0.predicates(6) <= '0';
        s_b10_0.predicates(7) <= '0';
      end if;
    end if;
  end process;

-- b10 stage 1
  s_b10_vstall(1) <= '0';
  ni173_sequence <= p_sequence_imm2;
  ni429_suif_tmp_0 <= sign_ext(ni173_sequence, 32);
  ni430_suif_tmp5 <= "0000000000000000000000000000000" & eq(ni429_suif_tmp_0(7 downto 0), X"41");
  ni433_suif_tmp6 <= "0000000000000000000000000000000" & eq(ni429_suif_tmp_0(7 downto 0), X"43");
  ni436_suif_tmp7 <= "0000000000000000000000000000000" & eq(ni429_suif_tmp_0(7 downto 0), X"47");
  ni439_suif_tmp8 <= "0000000000000000000000000000000" & eq(ni429_suif_tmp_0(7 downto 0), X"54");
  s_b10_predicates(6) <= 
    s_b10_predicates(5) when t_1(0) = '1' else
    '0';
  s_b10_predicates(7) <= 
    s_b10_predicates(5) when (not t_1(0)) = '1' else
    '0';
  t_1 <= 
    ni439_suif_tmp8 when s_b10_predicates(5) = '1' else
    r_suif_tmp8;
  s_b10_predicates(4) <= 
    s_b10_predicates(3) when t_2(0) = '1' else
    '0';
  s_b10_predicates(5) <= 
    s_b10_predicates(3) when (not t_2(0)) = '1' else
    '0';
  t_2 <= 
    ni436_suif_tmp7 when s_b10_predicates(3) = '1' else
    r_suif_tmp7;
  s_b10_predicates(2) <= 
    s_b10_predicates(1) when t_3(0) = '1' else
    '0';
  s_b10_predicates(3) <= 
    s_b10_predicates(1) when (not t_3(0)) = '1' else
    '0';
  t_3 <= 
    ni433_suif_tmp6 when s_b10_predicates(1) = '1' else
    r_suif_tmp6;
  s_b10_predicates(0) <= 
    '1' when ni430_suif_tmp5(0) = '1' else
    '0';
  s_b10_predicates(1) <= 
    '1' when (not ni430_suif_tmp5(0)) = '1' else
    '0';
  ni442_l <= s_b10_0.f_r_e_g_2;
  ni443_suif_tmp4 <= "0000000000000000000000000000000" & cmp_less_s(ni442_l, X"00000008");
  ni432_r_e_g_0 <= r_l(4 downto 0);
  ni435_r_e_g_3 <= add("01000", r_l(4 downto 0));
  ni438_r_e_g_4 <= add("10000", r_l(4 downto 0));
  ni441_r_e_g_5 <= add("11000", r_l(4 downto 0));
  s_b10_vbreak(1) <= '0';
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (s_b10_vwrite(1) = '1') then
        s_b10_1.f_r_e_g_5 <= ni441_r_e_g_5;
        s_b10_1.f_r_e_g_4 <= ni438_r_e_g_4;
        s_b10_1.f_r_e_g_3 <= ni435_r_e_g_3;
        s_b10_1.f_r_e_g_0 <= ni432_r_e_g_0;
        s_b10_1.f_suif_tmp4 <= ni443_suif_tmp4;
        s_b10_1.f_r_e_g_2 <= s_b10_0.f_r_e_g_2;
        s_b10_1.f_r_e_g_1 <= s_b10_0.f_r_e_g_1;
        s_b10_1.predicates(0) <= s_b10_predicates(0);
        s_b10_1.predicates(1) <= s_b10_predicates(1);
        s_b10_1.predicates(2) <= s_b10_predicates(2);
        s_b10_1.predicates(3) <= s_b10_predicates(3);
        s_b10_1.predicates(4) <= s_b10_predicates(4);
        s_b10_1.predicates(5) <= s_b10_predicates(5);
        s_b10_1.predicates(6) <= s_b10_predicates(6);
        s_b10_1.predicates(7) <= s_b10_predicates(7);
      end if;
    end if;
  end process;

-- b10 stage 2
  s_b10_vstall(2) <= '0';
  ni201_pwm <= p_pwm_imm2;
  ni431_sum <= add(s_b10_3.f_sum, ni201_pwm);
  ni212_pwm <= p_pwm_imm;
  ni434_sum <= add(s_b10_3.f_sum, ni212_pwm);
  t_4 <= 
    ni434_sum when s_b10_1.predicates(2) = '1' else
    ni431_sum when s_b10_1.predicates(0) = '1' else
    s_b10_3.f_sum;
  s_b10_vbreak(2) <= '0';
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (s_b10_vwrite(2) = '1') then
        s_b10_2.f_sum <= t_4;
        s_b10_2.f_r_e_g_5 <= s_b10_1.f_r_e_g_5;
        s_b10_2.f_r_e_g_4 <= s_b10_1.f_r_e_g_4;
        s_b10_2.f_r_e_g_3 <= s_b10_1.f_r_e_g_3;
        s_b10_2.f_r_e_g_0 <= s_b10_1.f_r_e_g_0;
        s_b10_2.f_suif_tmp4 <= s_b10_1.f_suif_tmp4;
        s_b10_2.f_r_e_g_2 <= s_b10_1.f_r_e_g_2;
        s_b10_2.f_r_e_g_1 <= s_b10_1.f_r_e_g_1;
        s_b10_2.predicates(0) <= s_b10_1.predicates(0);
        s_b10_2.predicates(1) <= s_b10_1.predicates(1);
        s_b10_2.predicates(2) <= s_b10_1.predicates(2);
        s_b10_2.predicates(3) <= s_b10_1.predicates(3);
        s_b10_2.predicates(4) <= s_b10_1.predicates(4);
        s_b10_2.predicates(5) <= s_b10_1.predicates(5);
        s_b10_2.predicates(6) <= s_b10_1.predicates(6);
        s_b10_2.predicates(7) <= s_b10_1.predicates(7);
      end if;
    end if;
  end process;

-- b10 stage 3
  s_b10_vstall(3) <= '0';
  ni223_pwm <= p_pwm_imm2;
  ni437_sum <= add(s_b10_2.f_sum, ni223_pwm);
  ni234_pwm <= p_pwm_imm;
  ni440_sum <= add(s_b10_2.f_sum, ni234_pwm);
  t_5 <= 
    ni440_sum when s_b10_2.predicates(6) = '1' else
    ni437_sum when s_b10_2.predicates(4) = '1' else
    s_b10_2.f_sum;
  s_b10_vbreak(3) <= '0';
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (s_b10_state = init) then
        s_b10_3.f_sum <= r_sum;
      elsif (s_b10_vwrite(3) = '1') then
        s_b10_3.f_sum <= t_5;
        s_b10_3.predicates(0) <= s_b10_2.predicates(0);
        s_b10_3.predicates(1) <= s_b10_2.predicates(1);
        s_b10_3.predicates(2) <= s_b10_2.predicates(2);
        s_b10_3.predicates(3) <= s_b10_2.predicates(3);
        s_b10_3.predicates(4) <= s_b10_2.predicates(4);
        s_b10_3.predicates(5) <= s_b10_2.predicates(5);
        s_b10_3.predicates(6) <= s_b10_2.predicates(6);
        s_b10_3.predicates(7) <= s_b10_2.predicates(7);
      end if;
    end if;
  end process;

  with s_b10_state select
    s_b10_break <= 
      '1' when flush,
      '0' when others;
  process (clk,reset)
  begin
    if (reset='1') then
     s_b10_delay <= "01";
    elsif (clk'event and clk='1') then
      if (s_b10_state = idle) then
       s_b10_delay <= "01";
      elsif (thisState = b10s0 and s_b10_stall = '0' and s_b10_done = '0') then
       s_b10_delay <= s_b10_delay(0) & s_b10_delay(1 downto 1);
      end if;    end if;
  end process;

  process (clk,reset)
  begin
    if (reset='1') then
     s_b10_stage <= X"0";
    elsif (clk'event and clk='1') then
      if (s_b10_state = idle) then
       s_b10_stage <= X"0";
      elsif (thisState = b10s0 and s_b10_stall = '0') then
       s_b10_stage <= s_b10_vcont(2 downto 0) & ((not s_b10_break) and s_b10_delay(0));
      end if;    end if;
  end process;

  s_b10_stall <= 
    '0' when (s_b10_vstall and s_b10_stage) = X"0" else
    '1';
  s_b10_vwrite(0) <= 
    s_b10_stage(0) when s_b10_stall = '0' else
    '0';
  s_b10_vwrite(1) <= 
    s_b10_stage(1) when s_b10_stall = '0' else
    '0';
  s_b10_vwrite(2) <= 
    s_b10_stage(2) when s_b10_stall = '0' else
    '0';
  s_b10_vwrite(3) <= 
    s_b10_stage(3) when s_b10_stall = '0' else
    '0';
  s_b10_vcont(0) <= s_b10_stage(0);
  s_b10_vcont(1) <= s_b10_stage(1);
  s_b10_vcont(2) <= s_b10_stage(2);
  s_b10_vcont(3) <= '0';
  s_b10_loop <= 
    '0' when (s_b10_stage(3) and (not s_b10_vstall(3)) and (not s_b10_2.f_suif_tmp4(0))) = '1' else
    '1';
  s_b10_flushed <= 
    '1' when s_b10_stall = '0' and s_b10_vcont = X"0" else
    '0';
  with s_b10_state select
    s_b10_done <= 
      '0' when init,
      not s_b10_loop when run,
      s_b10_flushed when flush,
      '0' when others;
-- b11s0
  ni444_nHitStart <= r_counter;
  ni445_nHitScore <= r_sum;
  ni446_suif_tmp2 <= "0000000000000000000000000000000" & eq("0" & mkvec(p_dna_stream_eos), "00");

-- b11s1
  ni447_nSampleDna <= r_dna_stream;

-- b12s0
  ni283_sequence <= r_nSampleDna;
  t_6 <= r_k(8 downto 0);
  ni448_k <= add(r_k, X"00000001");

-- b13s0

-- b14s0
  ni449_counter <= add(r_counter, X"0001");
  ni450_sum <= X"00000000";
  ni451_suif_tmp1 <= "0000000000000000000000000000000" & cmp_less_equal_s(sign_ext(ni449_counter, 32), sub(sign_ext(r_dnaLength, 32), X"00000008"));

-- b15s0

-- b16s0

-- 


  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b0s0 =>
        if (stateEn = '1') then
          r_motifLength <= ni408_motifLength;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b0s0 =>
        if (stateEn = '1') then
          r_j <= ni409_j;
        end if;
      when b3s0 =>
        if (stateEn = '1') then
          r_j <= ni416_j;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b1s0 =>
        if (stateEn = '1') then
          r_suif_tmp9 <= ni410_suif_tmp9;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b1s1 =>
        if (stateEn = '1') then
          r_i <= ni411_i;
        end if;
      when b2s1 =>
        if (stateEn = '1') then
          r_i <= ni415_i;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b2s0 =>
        if (stateEn = '1') then
          r_suif_tmp10 <= ni412_suif_tmp10;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b2s1 =>
        if (stateEn = '1') then
          r_r_e_g_0 <= ni414_r_e_g_0;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b2s2 =>
        if (stateEn = '1') then
          r_nSamplePwm <= ni413_nSamplePwm;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b4s0 =>
        if (stateEn = '1') then
          r_suif_tmp <= ni417_suif_tmp;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b4s1 =>
        if (stateEn = '1') then
          r_dnaLength <= ni418_dnaLength;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b5s0 =>
        if (stateEn = '1') then
          r_k <= ni419_k;
        end if;
      when b6s2 =>
        if (stateEn = '1') then
          r_k <= ni422_k;
        end if;
      when b12s0 =>
        if (stateEn = '1') then
          r_k <= ni448_k;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b6s0 =>
        if (stateEn = '1') then
          r_suif_tmp11 <= ni420_suif_tmp11;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b6s2 =>
        if (stateEn = '1') then
          r_nSampleDna <= ni421_nSampleDna;
        end if;
      when b11s1 =>
        if (stateEn = '1') then
          r_nSampleDna <= ni447_nSampleDna;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b7s0 =>
        if (stateEn = '1') then
          r_counter <= ni423_counter;
        end if;
      when b14s0 =>
        if (stateEn = '1') then
          r_counter <= ni449_counter;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b7s0 =>
        if (stateEn = '1') then
          r_sum <= ni424_sum;
        end if;
      when b10s0 =>
        if (s_b10_vwrite(2) = '1') then
          r_sum <= t_4;
        end if;
        if (s_b10_vwrite(3) = '1') then
          r_sum <= t_5;
        end if;
      when b14s0 =>
        if (stateEn = '1') then
          r_sum <= ni450_sum;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b7s0 =>
        if (stateEn = '1') then
          r_suif_tmp0 <= ni425_suif_tmp0;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b8s0 =>
        if (stateEn = '1') then
          r_l <= ni426_l;
        end if;
      when b10s0 =>
        if (s_b10_vwrite(1) = '1') then
          r_l <= ni442_l;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b8s0 =>
        if (stateEn = '1') then
          r_suif_tmp3 <= ni427_suif_tmp3;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b9s0 =>
        if (stateEn = '1') then
          r_suif_tmp90 <= ni428_suif_tmp90;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b11s0 =>
        if (stateEn = '1') then
          r_nHitStart <= ni444_nHitStart;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b11s0 =>
        if (stateEn = '1') then
          r_nHitScore <= ni445_nHitScore;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b11s0 =>
        if (stateEn = '1') then
          r_suif_tmp2 <= ni446_suif_tmp2;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b14s0 =>
        if (stateEn = '1') then
          r_suif_tmp1 <= ni451_suif_tmp1;
        end if;
      when others => null;
      end case;
    end if;
  end process;

-- "pwm_stream" interface signals
  process (clk)
  begin
    if (clk'event and clk='1') then
      if ((p_pwm_stream_en and p_pwm_stream_rdy) = '1') then
        r_pwm_stream <= p_pwm_stream_data;
      end if;
    end if;
  end process;

  p_pwm_stream_en <= 
    stateEn and (not p_pwm_stream_eos) when thisState = b2s1 else
    stateEn when thisState = b15s0 else
    '0';

-- "iteration_stream" interface signals
  process (clk)
  begin
    if (clk'event and clk='1') then
      if ((p_iteration_stream_en and p_iteration_stream_rdy) = '1') then
        r_iteration_stream <= p_iteration_stream_data;
      end if;
    end if;
  end process;

  p_iteration_stream_en <= 
    stateEn and (not p_iteration_stream_eos) when thisState = b4s0 else
    stateEn when thisState = b15s0 else
    '0';

-- "dna_stream" interface signals
  process (clk)
  begin
    if (clk'event and clk='1') then
      if ((p_dna_stream_en and p_dna_stream_rdy) = '1') then
        r_dna_stream <= p_dna_stream_data;
      end if;
    end if;
  end process;

  p_dna_stream_en <= 
    stateEn and (not p_dna_stream_eos) when thisState = b6s1 else
    stateEn and (not p_dna_stream_eos) when thisState = b11s0 else
    stateEn when thisState = b15s0 else
    '0';

-- "counter_stream" interface signals
  p_counter_stream_en <= 
    stateEn when thisState = b11s0 else
    stateEn when thisState = b15s0 else
    '0';
  p_counter_stream_data <= ni444_nHitStart;
  p_counter_stream_eos <= 
    '1' when thisState = b15s0 else
    '0';

-- "sum_stream" interface signals
  p_sum_stream_en <= 
    stateEn when thisState = b11s0 else
    stateEn when thisState = b15s0 else
    '0';
  p_sum_stream_data <= ni445_nHitScore;
  p_sum_stream_eos <= 
    '1' when thisState = b15s0 else
    '0';

-- "pwm" memory signals
  ram_0: PWM_pwm_RAM
    port map (
      rst => reset, 
      clk => clk, 
      we => p_pwm_we, 
      addr => p_pwm_addr, 
      addr2 => p_pwm_addr2, 
      din => p_pwm_din, 
      dout => p_pwm_dout, 
      dout2 => p_pwm_dout2);

  p_pwm_addr <= 
    r_r_e_g_0 when thisState = b2s2 else
    ni435_r_e_g_3 when thisState = b10s0 and s_b10_vwrite(1) = '1' and s_b10_predicates(2) = '1' else
    r_r_e_g_3 when thisState = b10s0 and s_b10_vwrite(1) = '1' else
    s_b10_1.f_r_e_g_5 when thisState = b10s0 and s_b10_vwrite(2) = '1' else
    (others => 'X');
  p_pwm_re <= 
    newState when thisState = b10s0 and s_b10_stage(2) = '1' and s_b10_1.predicates(2) = '1' else
    newState when thisState = b10s0 and s_b10_stage(3) = '1' and s_b10_2.predicates(6) = '1' else
    '0';
  p_pwm_re2 <= 
    newState when thisState = b10s0 and s_b10_stage(2) = '1' and s_b10_1.predicates(0) = '1' else
    newState when thisState = b10s0 and s_b10_stage(3) = '1' and s_b10_2.predicates(4) = '1' else
    '0';
  p_pwm_addr2 <= 
    ni432_r_e_g_0 when thisState = b10s0 and s_b10_vwrite(1) = '1' and s_b10_predicates(0) = '1' else
    r_r_e_g_0 when thisState = b10s0 and s_b10_vwrite(1) = '1' else
    s_b10_1.f_r_e_g_4 when thisState = b10s0 and s_b10_vwrite(2) = '1' else
    (others => 'X');
  p_pwm_we <= 
    '1' when thisState = b2s2 else
    '0';
  p_pwm_din <= ni413_nSamplePwm;
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (p_pwm_re = '1') then
        r_pwm <= p_pwm_dout;
      end if;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      if (p_pwm_re2 = '1') then
        r2_pwm <= p_pwm_dout2;
      end if;
    end if;
  end process;

  p_pwm_imm <= 
    p_pwm_dout when newState = '1' else
    r_pwm;
  p_pwm_imm2 <= 
    p_pwm_dout2 when newState = '1' else
    r2_pwm;
-- "sequence" memory signals
  ram_1: PWM_sequence_RAM
    port map (
      rst => reset, 
      clk => clk, 
      we => p_sequence_we, 
      addr => p_sequence_addr, 
      addr2 => p_sequence_addr2, 
      din => p_sequence_din, 
      dout => p_sequence_dout, 
      dout2 => p_sequence_dout2);

  p_sequence_addr <= 
    r_k(8 downto 0) when thisState = b6s2 else
    r_k(8 downto 0) when thisState = b12s0 else
    (others => 'X');
  p_sequence_re <= '0';
  p_sequence_re2 <= 
    newState when thisState = b10s0 and s_b10_stage(1) = '1' else
    '0';
  p_sequence_addr2 <= ni175_r_e_g_1;
  p_sequence_we <= 
    '1' when thisState = b6s2 else
    '1' when thisState = b12s0 else
    '0';
  p_sequence_din <= 
    ni421_nSampleDna when thisState = b6s2 else
    r_nSampleDna when thisState = b12s0 else
    (others => 'X');
  process (clk)
  begin
    if (clk'event and clk='1') then
      if (p_sequence_re = '1') then
        r_sequence <= p_sequence_dout;
      end if;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      if (p_sequence_re2 = '1') then
        r2_sequence <= p_sequence_dout2;
      end if;
    end if;
  end process;

  p_sequence_imm <= 
    p_sequence_dout when newState = '1' else
    r_sequence;
  p_sequence_imm2 <= 
    p_sequence_dout2 when newState = '1' else
    r2_sequence;
end rtl;
library ieee;
use ieee.std_logic_1164.all;

library impulse;
use impulse.components.all;
  
entity Filter is
  port (signal reset : in std_ulogic;
    signal sclk : in std_ulogic;
    signal clk : in std_ulogic;
    signal p_threshold_stream_rdy : in std_ulogic;
    signal p_threshold_stream_en : inout std_ulogic;
    signal p_threshold_stream_eos : in std_ulogic;
    signal p_threshold_stream_data : in std_ulogic_vector (31 downto 0);
    signal p_counter_stream_rdy : in std_ulogic;
    signal p_counter_stream_en : inout std_ulogic;
    signal p_counter_stream_eos : in std_ulogic;
    signal p_counter_stream_data : in std_ulogic_vector (15 downto 0);
    signal p_sum_stream_rdy : in std_ulogic;
    signal p_sum_stream_en : inout std_ulogic;
    signal p_sum_stream_eos : in std_ulogic;
    signal p_sum_stream_data : in std_ulogic_vector (31 downto 0);
    signal p_start_stream_rdy : in std_ulogic;
    signal p_start_stream_en : inout std_ulogic;
    signal p_start_stream_eos : out std_ulogic;
    signal p_start_stream_data : out std_ulogic_vector (15 downto 0);
    signal p_score_stream_rdy : in std_ulogic;
    signal p_score_stream_en : inout std_ulogic;
    signal p_score_stream_eos : out std_ulogic;
    signal p_score_stream_data : out std_ulogic_vector (31 downto 0));
end Filter;

use work.external_components.all;
architecture rtl of Filter is
  function mkvec(b : in std_ulogic) return std_ulogic_vector is
    variable res : std_ulogic_vector(0 downto 0);
  begin
    res(0):=b;
    return(res);
  end;

  type stateType is (init, b0s0, b0s1, b1s0, b2s0, b3s0, b4s0, b4s1, b4s2, b5s0, b6s0, b7s0, b8s0, b9s0, b10s0, b11s0, b12s0, b13s0, finished);
  signal thisState : stateType;
  signal nextState : stateType;
  signal stateEn : std_ulogic;
  signal newState : std_ulogic;
  signal r_threshold_stream : std_ulogic_vector (31 downto 0);
  signal r_counter_stream : std_ulogic_vector (15 downto 0);
  signal r_sum_stream : std_ulogic_vector (31 downto 0);
  signal r_threshold : std_ulogic_vector (31 downto 0);
  signal ni246_threshold : std_ulogic_vector (31 downto 0);
  signal r_filterMode : std_ulogic_vector (31 downto 0);
  signal ni247_filterMode : std_ulogic_vector (31 downto 0);
  signal ni248_filterMode : std_ulogic_vector (31 downto 0);
  signal r_nResultStart : std_ulogic_vector (15 downto 0);
  signal ni249_nResultStart : std_ulogic_vector (15 downto 0);
  signal ni259_nResultStart : std_ulogic_vector (15 downto 0);
  signal r_nResultScore : std_ulogic_vector (31 downto 0);
  signal ni250_nResultScore : std_ulogic_vector (31 downto 0);
  signal ni257_nResultScore : std_ulogic_vector (31 downto 0);
  signal ni260_nResultScore : std_ulogic_vector (31 downto 0);
  signal r_nHitStart : std_ulogic_vector (15 downto 0);
  signal ni252_nHitStart : std_ulogic_vector (15 downto 0);
  signal r_nHitScore : std_ulogic_vector (31 downto 0);
  signal ni254_nHitScore : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp : std_ulogic_vector (31 downto 0);
  signal ni245_suif_tmp : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp0 : std_ulogic_vector (31 downto 0);
  signal ni251_suif_tmp0 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp1 : std_ulogic_vector (31 downto 0);
  signal ni253_suif_tmp1 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp2 : std_ulogic_vector (31 downto 0);
  signal ni255_suif_tmp2 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp3 : std_ulogic_vector (31 downto 0);
  signal ni256_suif_tmp3 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp4 : std_ulogic_vector (31 downto 0);
  signal ni258_suif_tmp4 : std_ulogic_vector (31 downto 0);
  signal r_suif_tmp5 : std_ulogic_vector (31 downto 0);
  signal ni261_suif_tmp5 : std_ulogic_vector (31 downto 0);
  signal r_r_e_g_0 : std_ulogic_vector (0 downto 0);
  signal ni84_r_e_g_0 : std_ulogic_vector (0 downto 0);
begin
  process (clk,reset)
  begin
    if (reset='1') then
     thisState <= init;
    elsif (clk'event and clk='1') then
      if (stateEn = '1') then
        thisState <= nextState;
      end if;
    end if;
  end process;

  stateEn <= 
    '0' when thisState = b0s0 and p_threshold_stream_rdy = '0' else
    '0' when thisState = b4s0 and p_counter_stream_rdy = '0' else
    '0' when thisState = b4s1 and p_sum_stream_rdy = '0' else
    '0' when thisState = b9s0 and (p_start_stream_rdy and p_score_stream_rdy) = '0' else
    '0' when thisState = b11s0 and (p_start_stream_rdy and p_score_stream_rdy) = '0' else
    '0' when thisState = b12s0 and (p_threshold_stream_eos and p_counter_stream_eos and p_sum_stream_eos and p_start_stream_rdy and p_score_stream_rdy) = '0' else
    '1';

  process (ni261_suif_tmp5,ni258_suif_tmp4,ni256_suif_tmp3,ni255_suif_tmp2,r_suif_tmp1,ni251_suif_tmp0,ni245_suif_tmp,thisState)
  begin
    case thisState is
    when init =>
      nextState <= b0s0;
    when b0s0 =>
      nextState <= b0s1;
    when b0s1 =>
      if (ni245_suif_tmp(0) = '1') then
        nextState <= b1s0;
      elsif ((not ni245_suif_tmp(0)) = '1') then
        nextState <= b2s0;
      else
        nextState <= b0s1;
      end if;
    when b1s0 =>
      nextState <= b3s0;
    when b2s0 =>
      nextState <= b3s0;
    when b3s0 =>
      nextState <= b4s0;
    when b4s0 =>
      if ((not ni251_suif_tmp0(0)) = '1') then
        nextState <= b10s0;
      else
        nextState <= b4s1;
      end if;
    when b4s1 =>
      nextState <= b4s2;
    when b4s2 =>
      if (r_suif_tmp1(0) = '1') then
        nextState <= b5s0;
      elsif ((not r_suif_tmp1(0)) = '1') then
        nextState <= b4s0;
      else
        nextState <= b4s2;
      end if;
    when b5s0 =>
      if (ni255_suif_tmp2(0) = '1') then
        nextState <= b6s0;
      elsif ((not ni255_suif_tmp2(0)) = '1') then
        nextState <= b8s0;
      else
        nextState <= b5s0;
      end if;
    when b6s0 =>
      if (ni256_suif_tmp3(0) = '1') then
        nextState <= b7s0;
      elsif ((not ni256_suif_tmp3(0)) = '1') then
        nextState <= b4s0;
      else
        nextState <= b6s0;
      end if;
    when b7s0 =>
      nextState <= b4s0;
    when b8s0 =>
      if (ni258_suif_tmp4(0) = '1') then
        nextState <= b9s0;
      elsif ((not ni258_suif_tmp4(0)) = '1') then
        nextState <= b4s0;
      else
        nextState <= b8s0;
      end if;
    when b9s0 =>
      nextState <= b4s0;
    when b10s0 =>
      if (ni261_suif_tmp5(0) = '1') then
        nextState <= b11s0;
      elsif ((not ni261_suif_tmp5(0)) = '1') then
        nextState <= b12s0;
      else
        nextState <= b10s0;
      end if;
    when b11s0 =>
      nextState <= b12s0;
    when b12s0 =>
      nextState <= b0s0;
    when b13s0 =>
      nextState <= finished;
    when finished =>
      nextState <= finished;
    when others =>
      nextState <= init;
    end case;
  end process;

  process (clk,reset)
  begin
    if (reset='1') then
     newState <= '1';
    elsif (clk'event and clk='1') then
      newState <= stateEn;
    end if;
  end process;

-- b0s0
  ni84_r_e_g_0 <= mkvec(p_threshold_stream_eos);

-- b0s1
  ni246_threshold <= r_threshold_stream;
  ni245_suif_tmp <= "0000000000000000000000000000000" & neq("0" & r_r_e_g_0, "00");

-- b1s0
  ni247_filterMode <= X"00000001";

-- b2s0
  ni248_filterMode <= X"00000002";

-- b3s0
  ni249_nResultStart <= X"0000";
  ni250_nResultScore <= X"00000000";

-- b4s0
  ni251_suif_tmp0 <= "0000000000000000000000000000000" & eq("0" & mkvec(p_counter_stream_eos), "00");

-- b4s1
  ni252_nHitStart <= r_counter_stream;
  ni253_suif_tmp1 <= "0000000000000000000000000000000" & eq("0" & mkvec(p_sum_stream_eos), "00");

-- b4s2
  ni254_nHitScore <= r_sum_stream;

-- b5s0
  ni255_suif_tmp2 <= "0000000000000000000000000000000" & eq(r_filterMode(2 downto 0), "001");

-- b6s0
  ni256_suif_tmp3 <= "0000000000000000000000000000000" & cmp_less_s(X"00000000", r_nHitScore);

-- b7s0
  ni257_nResultScore <= add(r_nResultScore, r_nHitScore);

-- b8s0
  ni258_suif_tmp4 <= "0000000000000000000000000000000" & cmp_less_equal_s(r_threshold, r_nHitScore);

-- b9s0
  ni259_nResultStart <= r_nHitStart;
  ni260_nResultScore <= r_nHitScore;

-- b10s0
  ni261_suif_tmp5 <= "0000000000000000000000000000000" & eq(r_filterMode(2 downto 0), "001");

-- b11s0

-- b12s0

-- b13s0

-- 


  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b0s0 =>
        if (stateEn = '1') then
          r_r_e_g_0 <= ni84_r_e_g_0;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b0s1 =>
        if (stateEn = '1') then
          r_threshold <= ni246_threshold;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b0s1 =>
        if (stateEn = '1') then
          r_suif_tmp <= ni245_suif_tmp;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b1s0 =>
        if (stateEn = '1') then
          r_filterMode <= ni247_filterMode;
        end if;
      when b2s0 =>
        if (stateEn = '1') then
          r_filterMode <= ni248_filterMode;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b3s0 =>
        if (stateEn = '1') then
          r_nResultStart <= ni249_nResultStart;
        end if;
      when b9s0 =>
        if (stateEn = '1') then
          r_nResultStart <= ni259_nResultStart;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b3s0 =>
        if (stateEn = '1') then
          r_nResultScore <= ni250_nResultScore;
        end if;
      when b7s0 =>
        if (stateEn = '1') then
          r_nResultScore <= ni257_nResultScore;
        end if;
      when b9s0 =>
        if (stateEn = '1') then
          r_nResultScore <= ni260_nResultScore;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b4s0 =>
        if (stateEn = '1') then
          r_suif_tmp0 <= ni251_suif_tmp0;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b4s1 =>
        if (stateEn = '1') then
          r_nHitStart <= ni252_nHitStart;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b4s1 =>
        if (stateEn = '1') then
          r_suif_tmp1 <= ni253_suif_tmp1;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b4s2 =>
        if (stateEn = '1') then
          r_nHitScore <= ni254_nHitScore;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b5s0 =>
        if (stateEn = '1') then
          r_suif_tmp2 <= ni255_suif_tmp2;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b6s0 =>
        if (stateEn = '1') then
          r_suif_tmp3 <= ni256_suif_tmp3;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b8s0 =>
        if (stateEn = '1') then
          r_suif_tmp4 <= ni258_suif_tmp4;
        end if;
      when others => null;
      end case;
    end if;
  end process;

  process (clk)
  begin
    if (clk'event and clk='1') then
      case thisState is
      when b10s0 =>
        if (stateEn = '1') then
          r_suif_tmp5 <= ni261_suif_tmp5;
        end if;
      when others => null;
      end case;
    end if;
  end process;

-- "threshold_stream" interface signals
  process (clk)
  begin
    if (clk'event and clk='1') then
      if ((p_threshold_stream_en and p_threshold_stream_rdy) = '1') then
        r_threshold_stream <= p_threshold_stream_data;
      end if;
    end if;
  end process;

  p_threshold_stream_en <= 
    stateEn and (not p_threshold_stream_eos) when thisState = b0s0 else
    stateEn when thisState = b12s0 else
    '0';

-- "counter_stream" interface signals
  process (clk)
  begin
    if (clk'event and clk='1') then
      if ((p_counter_stream_en and p_counter_stream_rdy) = '1') then
        r_counter_stream <= p_counter_stream_data;
      end if;
    end if;
  end process;

  p_counter_stream_en <= 
    stateEn and (not p_counter_stream_eos) when thisState = b4s0 else
    stateEn when thisState = b12s0 else
    '0';

-- "sum_stream" interface signals
  process (clk)
  begin
    if (clk'event and clk='1') then
      if ((p_sum_stream_en and p_sum_stream_rdy) = '1') then
        r_sum_stream <= p_sum_stream_data;
      end if;
    end if;
  end process;

  p_sum_stream_en <= 
    stateEn and (not p_sum_stream_eos) when thisState = b4s1 else
    stateEn when thisState = b12s0 else
    '0';

-- "start_stream" interface signals
  p_start_stream_en <= 
    stateEn when thisState = b9s0 else
    stateEn when thisState = b11s0 else
    stateEn when thisState = b12s0 else
    '0';
  p_start_stream_data <= 
    ni259_nResultStart when thisState = b9s0 else
    r_nResultStart when thisState = b11s0 else
    (others => 'X');
  p_start_stream_eos <= 
    '1' when thisState = b12s0 else
    '0';

-- "score_stream" interface signals
  p_score_stream_en <= 
    stateEn when thisState = b9s0 else
    stateEn when thisState = b11s0 else
    stateEn when thisState = b12s0 else
    '0';
  p_score_stream_data <= 
    ni260_nResultScore when thisState = b9s0 else
    r_nResultScore when thisState = b11s0 else
    (others => 'X');
  p_score_stream_eos <= 
    '1' when thisState = b12s0 else
    '0';

end rtl;
